//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>

#include "param.h"
#include "bitmap.h"

#ifdef ATTEN32
unsigned short attenh[256*32];
unsigned short attenm[256*64];
unsigned short attenl[256*32];
#else
short attenh[65536];
unsigned char attenl[65536];
#endif

void attenuateInit()
{
#ifdef ATTEN32
	int i,j;
	for(i=0;i<256;i++)
	{
		for(j=0;j<32;j++)
		{
			int c=j<<11;
			attenh[(j<<8)+i]=(unsigned short)RGBTO16((C16TOR(c)*(1+i))>>8,0,0);
			c=j;
			attenl[(j<<8)+i]=(unsigned short)RGBTO16(0,0,(C16TOB(c)*(1+i))>>8);
		}
		for(j=0;j<64;j++)
		{
			int c=j<<5;

			attenm[(j<<8)+i]=(unsigned short)RGBTO16(0,(C16TOG(c)*(1+i))>>8,0);
		}
	}
#else
	int i;
	for(i=0;i<65536;i++)
	{
		int k=1+(i&255);
		int c=(i>>8)&255;
		attenl[i]=RGBTO16(0,(k*C16TOG(c))>>8,(k*C16TOB(c))>>8);
		c=i&0xff00;
		attenh[i]=RGBTO16((k*C16TOR(c))>>8,(k*C16TOG(c))>>8,0);
	}
#endif

}


Filter::Filter(int col,int tx)
{
}



Bitmap::Bitmap(int w, int h)
{
	start=new short[w*h];
	name=NULL;
	next=NULL;
	count=0;
	width=w;height=h;
	thread=0;
}

Bitmap::~Bitmap()
{
	while(thread) Sleep(100);
	if (name) delete name;
	delete start;
}

void Bitmap::drawplot(int x, int y, short col)
{
	if ((y<0)||(y>=height)) return;
	if ((x<0)||(x>=width)) return;

	start[y*width+x]=col;
}
void Bitmap::drawverticalline(int x, int y1, int y2, short col)
{
	short	*buffer;
	
	if ((x<0)||(x>=width)) return;
	if (y1>y2)
	{
		int z=y1; y1=y2; y2=z;
	}
	if ((y2<0)||(y1>=height)) return;
	if (y1<0) y1=0;
	if (y2>=height) y2=height-1;

	buffer  = start + y1*width + x;
	for(int y=y1;y<=y2;y++)
	{
		*(buffer)=col;
		buffer+=width;
	}
}

void Bitmap::drawhorizontalline(int x1, int x2, int y, short col)
{
	short *buffer;
	if ((y<0)||(y>=height)) return;
	if (x1>x2)
	{
		int z=x1; x1=x2; x2=z;
	}
	if ((x2<0)||(x1>=width)) return;
	if (x1<0) x1=0;
	if (x2>=width) x2=width-1;

	buffer  = start + y*width+x1;
	for(int x=x1;x<=x2;x++) *(buffer++)=col;
}
void Bitmap::drawbox(int x, int y, int w, int h, short col)
{
	if ((w<=0)||(h<=0)) return;
	drawhorizontalline(x,x+w-1,y,col);
	drawhorizontalline(x,x+w-1,y+h-1,col);
	drawverticalline(x,y,y+h-1,col);
	drawverticalline(x+w-1,y,y+h-1,col);
}

void Bitmap::drawboxf(int x, int y, int w, int h, short col)
{
	if ((w<=0)||(h<=0)) return;
	for(int i=0;i<h;i++) drawhorizontalline(x,x+w-1,y+i,col);
}

void Bitmap::drawline(int x1, int y1, int x2, int y2, short col)
{
	float	l;
	int		ax, ay, bx, by, dx, dy, kx, ky, k, i;
	short	*buffer;
	
	
	// Clipping 2D //
	if (x1 < 0)
	{
		if (x2 < 0) return;
		l=-(float)x1*(float)(y2-y1)/(x2-x1);
		y1 += (int)l;
		x1  = 0;
	}
	if (x2 < 0)
	{
		l=-(float)x2*(float)(y1-y2)/(x1-x2);
		y2 += (int)l;
		x2  = 0;
	}
	
	if (x1 > width - 1)
	{
		if (x2 > width - 1) return;
		l=(float)(width -1-x1)*(float)(y2-y1)/(x2-x1);
		y1 += (int)l;
		x1  = width - 1;
	}
	if (x2 > width - 1)
	{
		l=(float)(width -1-x2)*(float)(y1-y2)/(x1-x2);
		y2 += (int)l;
		x2  = width - 1;
	}
	
	if (y1 < 0)
	{
		if (y2 < 0) return;
		l=-(float)y1*(float)(x2-x1)/(y2-y1);
		x1 += (int)l;
		y1  = 0;
	}
	if (y2 < 0)
	{
		l=-(float)y2*(float)(x1-x2)/(y1-y2);
		x2 += (int)l;
		y2  = 0;
	}
	
	if (y1 > height - 1)
	{
		if (y2 > height - 1) return;
		l=(float)(height -1-y1)*(float)(x2-x1)/(y2-y1);
		x1 += (int)l;
		y1  = height - 1;
	}
	if (y2 > height - 1)
	{
		l=(float)(height -1-y2)*(float)(x1-x2)/(y1-y2);
		x2 += (int)l;
		y2  = height - 1;
	}
	
	// Trac de la ligne //
	dx = abs(x2-x1); 
	dy = abs(y2-y1);
	if (dx >= dy)
	{
		if (x2>x1) 
		{ 
			ax = (int) x1; 
			ay = (int) y1; 
			bx = (int) x2; 
			by = (int) y2;
		}
		else 
		{ 
			ax = (int) x2; 
			ay = (int) y2; 
			bx = (int) x1; 
			by = (int) y1;
		}
		
		kx = bx - ax; 
		ky = by - ay;
		dx = 1;
		dy = width;
		buffer  = start;
		buffer += ax*dx + ay*width;
		
		if (ky<0)
		{
			dy = -dy; 
			ky = -ky;
		}
		k		= kx>>1;
		
		for(i=ax; i<=bx; i++)
		{
			*buffer= col;
			k	   += ky;
			if (k > kx)
			{
				k	   -= kx;
				buffer += dy;
			}
			buffer += dx;
		}
	}
	else
	{
		if (y2 > y1) 
		{ 
			ax = (int) x1; 
			ay = (int) y1; 
			bx = (int) x2; 
			by = (int) y2;
		}
		else 
		{ 
			ax = (int) x2; 
			ay = (int) y2; 
			bx = (int) x1; 
			by = (int) y1;
		}
		
		kx = bx - ax; 
		ky = by - ay;
		dx = 1;
		dy = width;
		buffer  = start;
		buffer += ax*dx + ay*width;
		
		if (kx<0) 
		{ 
			dx = -dx; 
			kx = -kx;
		}
		
		k		= ky>>1;
		for(i=ay; i<=by; i++)
		{
			*buffer= col;
			k += kx;
			if (k > ky)
			{
				k -= ky;
				buffer += dx;
			}
			buffer += dy;
		}
	}
}

#define LINEB_0 160
#define LINEB_1 64

void Bitmap::drawlinebold(int x1, int y1, int x2, int y2, short col)
{
	float	l;
	int		ax, ay, bx, by, dx, dy, kx, ky, k, i;
	short	*buffer;
	
	int bold=3;
	
	// Clipping 2D //
	if (x1 < 0)
	{
		if (x2 < 0) return;
		l=-(float)x1*(float)(y2-y1)/(x2-x1);
		y1 += (int)l;
		x1  = 0;
	}
	if (x2 < 0)
	{
		l=-(float)x2*(float)(y1-y2)/(x1-x2);
		y2 += (int)l;
		x2  = 0;
	}
	
	if (x1 > width - bold)
	{
		if (x2 > width - bold) return;
		l=(float)(width -bold-x1)*(float)(y2-y1)/(x2-x1);
		y1 += (int)l;
		x1  = width - bold;
	}
	if (x2 > width - bold)
	{
		l=(float)(width -bold-x2)*(float)(y1-y2)/(x1-x2);
		y2 += (int)l;
		x2  = width - bold;
	}
	
	if (y1 < 0)
	{
		if (y2 < 0) return;
		l=-(float)y1*(float)(x2-x1)/(y2-y1);
		x1 += (int)l;
		y1  = 0;
	}
	if (y2 < 0)
	{
		l=-(float)y2*(float)(x1-x2)/(y1-y2);
		x2 += (int)l;
		y2  = 0;
	}
	
	if (y1 > height - bold)
	{
		if (y2 > height - bold) return;
		l=(float)(height -bold-y1)*(float)(x2-x1)/(y2-y1);
		x1 += (int)l;
		y1  = height - bold;
	}
	if (y2 > height - bold)
	{
		l=(float)(height -bold-y2)*(float)(x1-x2)/(y1-y2);
		x2 += (int)l;
		y2  = height - bold;
	}
	
	// Trac de la ligne //
	dx = abs(x2-x1); 
	dy = abs(y2-y1);
	if (dx >= dy)
	{
		if (x2>x1) 
		{ 
			ax = (int) x1; 
			ay = (int) y1; 
			bx = (int) x2; 
			by = (int) y2;
		}
		else 
		{ 
			ax = (int) x2; 
			ay = (int) y2; 
			bx = (int) x1; 
			by = (int) y1;
		}
		
		kx = bx - ax; 
		ky = by - ay;
		dx = 1;
		dy = width;
		buffer  = start;
		buffer += ax*dx + ay*width;
		
		if (ky<0)
		{
			dy = -dy; 
			ky = -ky;
		}
		k		= kx>>1;
		
		for(i=ax; i<=bx; i++)
		{
//			*buffer= col;
			buffer[0]=ALPHA(buffer[0],col,LINEB_1);
			buffer[1]=ALPHA(buffer[1],col,LINEB_0);
			buffer[2]=ALPHA(buffer[2],col,LINEB_1);
			buffer[width+0]=ALPHA(buffer[width+0],col,LINEB_0);
			buffer[width+1]=col;
			buffer[width+2]=ALPHA(buffer[width+2],col,LINEB_0);
			buffer[width+width+0]=ALPHA(buffer[width+width+0],col,LINEB_1);
			buffer[width+width+1]=ALPHA(buffer[width+width+1],col,LINEB_0);
			buffer[width+width+2]=ALPHA(buffer[width+width+2],col,LINEB_1);
/*			buffer[0]=buffer[1]=buffer[2]=col;
			buffer[width+0]=buffer[width+1]=buffer[width+2]=col;
			buffer[width+width+0]=buffer[width+width+1]=buffer[width+width+2]=col;
*/			k	   += ky;
			if (k > kx)
			{
				k	   -= kx;
				buffer += dy;
			}
			buffer += dx;
		}
	}
	else
	{
		if (y2 > y1) 
		{ 
			ax = (int) x1; 
			ay = (int) y1; 
			bx = (int) x2; 
			by = (int) y2;
		}
		else 
		{ 
			ax = (int) x2; 
			ay = (int) y2; 
			bx = (int) x1; 
			by = (int) y1;
		}
		
		kx = bx - ax; 
		ky = by - ay;
		dx = 1;
		dy = width;
		buffer  = start;
		buffer += ax*dx + ay*width;
		
		if (kx<0) 
		{ 
			dx = -dx; 
			kx = -kx;
		}
		
		k		= ky>>1;
		for(i=ay; i<=by; i++)
		{
//			*buffer= col;
			buffer[0]=ALPHA(buffer[0],col,LINEB_1);
			buffer[1]=ALPHA(buffer[1],col,LINEB_0);
			buffer[2]=ALPHA(buffer[2],col,LINEB_1);
			buffer[width+0]=ALPHA(buffer[width+0],col,LINEB_0);
			buffer[width+1]=col;
			buffer[width+2]=ALPHA(buffer[width+2],col,LINEB_0);
			buffer[width+width+0]=ALPHA(buffer[width+width+0],col,LINEB_1);
			buffer[width+width+1]=ALPHA(buffer[width+width+1],col,LINEB_0);
			buffer[width+width+2]=ALPHA(buffer[width+width+2],col,LINEB_1);
//			buffer[1]=buffer[width+0]=buffer[width+1]=buffer[width+2]=buffer[width+width+1]=col;
			k += kx;
			if (k > ky)
			{
				k -= ky;
				buffer += dx;
			}
			buffer += dy;
		}
	}
}

void Bitmap::empty(short col)
{
	int n=width*height;
	for(int i=0;i<n;i++) start[i]=col;
}

int Bitmap::drawtextbox(int x,int y,int w,int h,int type,char* src,int len,int textcol,int backcol,Font* font)
{
	return drawstrbox_(x,y,w,h,type,src,len,textcol,backcol,font);
}
int Bitmap::drawtextboxEx(int x,int y,int w,int h,int type,char* src,int len,int textcol,int backcol,Font* font,Font* font2)
{
	int ht;
	textnblines(w,src,len,font,&ht);
	if (ht<=h) return drawstrbox_(x,y,w,h,type,src,len,textcol,backcol,font);
	return drawstrbox_(x,y,w,h,type,src,len,textcol,backcol,font2);
}

int Bitmap::clip(int &xd,int &yd,Bitmap* src,int &xs,int &ys,int &w,int &h)
{
	if ((w<=0)||(h<=0)) return -1;	// dj clipp

	if ((xd>=width)||(yd>=height)) return -1;	// trop  droite ou trop en bas
	if ((xs>=src->width)||(ys>=src->height)) return -1;	// trop  droite ou trop en bas

	if (xd+w>width) w=width-xd;	// clipping  droite
	if (yd+h>height) h=height-yd;	// clipping en bas
	if (xs+w>src->width) w=src->width-xs;	// clipping  droite
	if (ys+h>src->height) h=src->height-ys;	// clipping en bas


	if (xd<0) {w+=xd; xs-=xd; xd=0;}	// clipping  gauche
	if (yd<0) {h+=yd; ys-=yd; yd=0;}	// clipping en haut
	if ((w<=0)||(h<=0)) return -1;

	if (xs<0) {w+=xs; xd-=xs; xs=0;}	// clipping  gauche
	if (ys<0) {h+=ys; yd-=ys; ys=0;}	// clipping en haut
	if ((w<=0)||(h<=0)) return -1;

	return 0;
}

void Bitmap::blit(int xd,int yd,Bitmap* src,int xs,int ys,int w,int h,int col)
{
	if (clip(xd,yd,src,xs,ys,w,h)) return;

	short* src0=src->start+ys*src->width+xs;
	short* dest0=start+yd*width+xd;
	if (col<0)
	for(int j=0;j<h;j++)
	{
		memcpy(dest0,src0,w<<1);
		dest0+=width;
		src0+=src->width;
	}
	else
	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		short colt=col;
		for(int i=0;i<w;i++)
		{
			if ((*src1)!=colt) (*dest1)=(*src1);
			dest1++;
			src1++;
		}
		dest0+=width;
		src0+=src->width;
	}
}

void Bitmap::blittransp(int xd,int yd,Bitmap* src,int xs,int ys,int w,int h,int col)
{
	if (clip(xd,yd,src,xs,ys,w,h)) return;

	short* src0=src->start+ys*src->width+xs;
	short* dest0=start+yd*width+xd;
	if (col<0)
	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		for(int i=0;i<w;i++)
		{
			(*dest1)=(((*src1)>>1)&0x7bef)+(((*dest1)>>1)&0x7bef);
			dest1++;
			src1++;
		}
		dest0+=width;
		src0+=src->width;
	}
	else
	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		short colt=col;
		for(int i=0;i<w;i++)
		{
			if ((*src1)!=colt) (*dest1)=(((*src1)>>1)&0x7bef)+(((*dest1)>>1)&0x7bef);
			dest1++;
			src1++;
		}
		dest0+=width;
		src0+=src->width;
	}
}

int Bitmap::clipstretch(int &xd,int &yd,int &wd,int &hd,Bitmap* src,int &xs,int &ys,int &ws,int &hs)
{
	if ((wd<=0)||(hd<=0)||(ws<=0)||(hs<=0)) return -1;	// dj clipp

	if ((xd>=width)||(yd>=height)) return -1;	// trop  droite ou trop en bas
	if ((xs>=src->width)||(ys>=src->height)) return -1;	// trop  droite ou trop en bas

	int w,h;
	if (xd+wd>width) { w=width-xd; ws=(ws*w)/wd; wd=w; }	// clipping  droite
	if (yd+hd>height){ h=height-yd; hs=(hs*h)/hd; hd=h; }	// clipping en bas
	if ((ws<=0)||(hs<=0)) return -1;

	if (xs+ws>src->width) { w=src->width-xs; wd=(wd*w)/ws; ws=w; }	// clipping  droite
	if (ys+hs>src->height) { h=src->height-ys; hd=(hd*h)/hs; hs=h; }	// clipping en bas
	if ((wd<=0)||(hd<=0)) return -1;

	if ((xd+wd<=0)||(yd+hd<=0)) return -1;	// trop  gauche ou trop en haut
	if ((xs+ws<=0)||(ys+hs<=0)) return -1;	// trop  gauche ou trop en haut

	if (xd<0) {w=wd+xd; xs-=(ws*xd)/wd; ws=(ws*w)/wd; xd=0; wd=w; }	// clipping en haut
	if (yd<0) {h=hd+yd; ys-=(hs*yd)/hd; hs=(hs*h)/hd; yd=0; hd=h; }	// clipping  gauche
	if ((ws<=0)||(hs<=0)) return -1;

	if (xs<0) {w=ws+xs; xd-=(wd*xs)/ws; wd=(wd*w)/ws; xs=0; ws=w; }	// clipping en haut
	if (ys<0) {h=hs+ys; yd-=(hd*ys)/hs; hd=(hd*h)/hs; ys=0; hs=h; }	// clipping  gauche
	if ((wd<=0)||(hd<=0)) return -1;

	return 0;
}

void Bitmap::stretch(int xd,int yd,int wd,int hd,Bitmap* src,int xs,int ys,int ws,int hs)
{
	if (clipstretch(xd,yd,wd,hd,src,xs,ys,ws,hs)) return;

	short* src0=src->start+ys*src->width+xs;
	short* dest0=start+yd*width+xd;

	int dx=(ws<<16)/wd;
	int dy=(hs<<16)/hd;

	int y=0;
	for(int j=0;j<hd;j++)
	{
		short* dest1=dest0;
		short* src1=src0+(y>>16)*src->width;
		int x=0;
		for(int i=0;i<wd;i++)
		{
			*(dest1++)=src1[x>>16];
			x+=dx;
		}
		dest0+=width;
		y+=dy;
	}
}


void Bitmap::blitalphaconst(int xd,int yd,Bitmap* src,int xs,int ys,int w,int h,uchar alpha,int col)
{
	if (clip(xd,yd,src,xs,ys,w,h)) return;

	short* src0=src->start+ys*src->width+xs;
	short* dest0=start+yd*width+xd;
	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		if (col<0)
		for(int i=0;i<w;i++)
		{
			(*dest1)=ALPHA((*dest1),(*src1),alpha);
			dest1++;
			src1++;
		}
		else
		for(int i=0;i<w;i++)
		{
			if ((*src1)!=col) (*dest1)=ALPHA((*dest1),(*src1),alpha);
			dest1++;
			src1++;
		}
		dest0+=width;
		src0+=src->width;
	}
}

void Bitmap::blitshadow(int xd,int yd,Bitmap* src,int xs,int ys,int w,int h)
{
	if (clip(xd,yd,src,xs,ys,w,h)) return;

	short* src0=src->start+ys*src->width+xs;
	short* dest0=start+yd*width+xd;
	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		for(int i=0;i<w;i++)
		{
			(*dest1)=ATTENUATE((*dest1),C16TOG(*src1));
			dest1++;
			src1++;
		}
		dest0+=width;
		src0+=src->width;
	}
}

int Bitmap::clipdoublesrc(int &xd,int &yd,Bitmap* src1,int &xs1,int &ys1,Bitmap* src2,int &xs2,int &ys2,int &w,int &h)
{
	if ((w<=0)||(h<=0)) return -1;	// dj clipp

	if ((xd>=width)||(yd>=height)) return -1;	// trop  droite ou trop en bas
	if ((xs1>=src1->width)||(ys1>=src1->height)) return -1;	// trop  droite ou trop en bas
	if ((xs2>=src2->width)||(ys2>=src2->height)) return -1;	// trop  droite ou trop en bas

	if (xd+w>width) w=width-xd;	// clipping  droite
	if (yd+h>height) h=height-yd;	// clipping en bas
	if (xs1+w>src1->width) w=src1->width-xs1;	// clipping  droite
	if (ys1+h>src1->height) h=src1->height-ys1;	// clipping en bas
	if (xs2+w>src2->width) w=src2->width-xs2;	// clipping  droite
	if (ys2+h>src2->height) h=src2->height-ys2;	// clipping en bas


	if (xd<0) {w+=xd; xs1-=xd; xs2-=xd; xd=0;}	// clipping  gauche
	if (yd<0) {h+=yd; ys1-=yd; ys2-=yd; yd=0;}	// clipping en haut
	if ((w<=0)||(h<=0)) return -1;

	if (xs1<0) {w+=xs1; xd-=xs1; xs2-=xs1; xs1=0;}	// clipping  gauche
	if (ys1<0) {h+=ys1; yd-=ys1; ys2-=ys1; ys1=0;}	// clipping  gauche
	if ((w<=0)||(h<=0)) return -1;

	if (xs2<0) {w+=xs2; xd-=xs2; xs1-=xs2; xs2=0;}	// clipping  gauche
	if (ys2<0) {h+=ys2; yd-=ys2; ys1-=ys2; ys2=0;}	// clipping  gauche
	if ((w<=0)||(h<=0)) return -1;

	return 0;
}

void Bitmap::blitalpha(int xd,int yd,Bitmap* src,int xs,int ys,Bitmap* alpha,int xa,int ya,int w,int h)
{
	if (clipdoublesrc(xd,yd,src,xs,ys,alpha,xa,ya,w,h)) return;

	short* src0=src->start+ys*src->width+xs;
	short* alpha0=alpha->start+ya*alpha->width+xa;
	short* dest0=start+yd*width+xd;

	for(int j=0;j<h;j++)
	{
		short* dest1=dest0;
		short* src1=src0;
		short* alpha1=alpha0;
		for(int i=0;i<w;i++)
		{
			*dest1=ALPHA((*dest1),(*src1),C16TOG(*alpha1));
			dest1++;
			src1++;
			alpha1++;
		}
		dest0+=width;
		src0+=src->width;
		alpha0+=alpha->width;
	}
}
