//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _CONTROL_
#define _CONTROL_

#include"param.h"

class Container;
class Bitmap;

class Control
{
private:
protected:
public:
	Control *father;
	Control *sons;
	Control *brother;
	Container *container;
	int enable;
	int xs,ys,oxs,oys,ws,hs;
	int xabs,yabs;
	int move_dx;
	int move_dy;
	int move_count;
	int infinite;

	Control(Container *c,Control* f,int x,int y,int w,int h);
	virtual ~Control();
	void setenable(int flag);
	int getenable();
	void localpos(int *x,int *y,int *w,int *h);
	void globalpos(int *x,int *y);

	void drawrec(Bitmap *bmp,int x,int y);
	Control* clicrec(int x,int y);
	void unclicrec(int x,int y);
	void moveclicrec(int x,int y);

	void gofront();
	void goback();
	void link(Control* newfather);

	void setpos(int x,int y);
	void setsize(int w,int h);
	void getpos(int *x,int *y);
	void setoff(int ox,int oy);
	int inside(int x,int y);

	void move(int dx,int dy,int count);
	int moving();

	virtual void draw(Bitmap *bmp,int x,int y);
	virtual Control* clic(int x,int y);
	virtual void unclic(int x,int y);
	virtual void moveclic(int x,int y);
};
#include "ctr_cross.h"
#include "ctr_button.h"
#include "ctr_map.h"
#include "ctr_text.h"
#include "ctr_back.h"
#include "ctr_push.h"
#include "ctr_lines.h"
#include "ctr_list.h"
#include "ctr_keybd.h"

#endif