//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "bitmap.h"
#include "rsc.h"


Ctr_back::Ctr_back(Container *c,Control* f,int x,int y,int w,int h):Control(c,f,x,y,w,h)
{
	hor=rscGet("interf/skin/hor.r");
	vert=rscGet("interf/skin/vert.r");
	back=new Bitmap(w-16,h-16);
	backempty();
	alpha=230;
//	infinite=1;
}

Ctr_back::~Ctr_back()
{
	rscUnuseit(hor);
	rscUnuseit(vert);
	delete back;
}

Control* Ctr_back::clic(int x,int y)
{
//	PRINTF("button down\n");
	return this;
}

Bitmap* Ctr_back::getback()
{
	return back;
}

void Ctr_back::backempty()
{
	back->empty((short)BACKCOL);
}

void Ctr_back::drawtitle(char *title)
{
	back->drawtextboxEx(0,0,200,30,ALIGN_CENTER+ALIGN_VCENTER,title,strlen(title),(short)COL_TITLE,-1,font_key,font_subtitle);
}


void Ctr_back::draw(Bitmap *bmp,int dx,int dy)
{
	int w=ws>>1;
	int h=(hs-16)>>1;

	
	if (hor)
	{
		bmp->blit(dx,dy,hor,0,0,w,8,0x1f);
		bmp->blit(dx+w,dy,hor,hor->width-(ws-w),0,ws-w,8,0x1f);

		bmp->blit(dx,dy+hs-8,hor,0,8,w,8,0x1f);
		bmp->blit(dx+w,dy+hs-8,hor,hor->width-(ws-w),8,ws-w,8,0x1f);
	}
	if (vert)
	{
		bmp->blit(dx,dy+8,vert,0,0,8,h,0x1f);
		bmp->blit(dx,dy+8+h,vert,0,0,8,hs-16-h,0x1f);
		bmp->blit(dx+ws-8,dy+8,vert,8,0,8,h,0x1f);
		bmp->blit(dx+ws-8,dy+8+h,vert,8,0,8,hs-16-h,0x1f);
	}
	bmp->blitalphaconst(dx+8,dy+8,back,0,0,ws-16,hs-16,alpha,-1);
//	bmp->blit(dx+8,dy+8,back,0,0,ws-16,hs-16,-1);
}

void Ctr_back::setalpha(int a)
{
	alpha=a;
}

Ctr_back* Ctr_back_create(Container *c,Control* f,int x,int y,int w,int h)
{
	return new Ctr_back(c,f,x,y,w,h);
}
