//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _CTR_BUTTON_
#define _CTR_BUTTON_

#include"param.h"

class Container;
class Bitmap;


#define CBBUTTON_DOWN 0
#define CBBUTTON_UP 1
#define CBBUTTON_MOVEDOWN 2
#define CBBUTTON_UPOUTSIDE 3


/* principe des couches
- on utilise jusqu' 16 couches pour l'affichage
- un masque indique quelles couches utiliser (en commenant toujours par la premire)
	- deux masques, un par tat du bouton
- pour chaque couche, on choisit :
	- une ou plusieurs sources (bitmap ou couleur flat)
	- un ou plusieurs coefficients
	- un type de rendu
*/

struct Srcbmp
{
	Bitmap* bmp;
	int color;
	int animwidth;
	int offw;
	int offh;
};

struct Layer
{
	int src1;
	int src2;
	int coef1;
	int coef2;
	int tp;	
};
#define NB_SRCBMP 4
#define NB_LAYER 16

#define LAYER_DISABLED 0
#define LAYER_FLATBOX 1
#define LAYER_BLIT 2
#define LAYER_BLITTRANSP 3
#define LAYER_BLITALPHA 4
#define LAYER_BLITSHADOW 5

class Ctr_button : public Control
{
private:
	int nb_state;
	int state;

	Srcbmp srcbmp[NB_SRCBMP];
	Layer layer[NB_LAYER];
	int* mskstate;

	void (*cbfun)(Ctr_button* b,int x,int y,int up,void* user1,void* user2);
	void* userparam1;
	void* userparam2;

public:
	Ctr_button(Container *c,Control* f,int x,int y,int w,int h,int nstates);
	~Ctr_button();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void setsrcbmp(int i,Bitmap *bmp,int color,int anim);
	void movesrcbmp(int i,int x,int y);
	void setlayer(int i,int s1,int s2,int c1,int c2,int tp);
	void setmask(int i,int msk);
	void setstate(int s);
	void setcb(void (*cb)(Ctr_button* b,int x,int y,int type,void* user1,void* user2),void* user1,void* user2);

};

Ctr_button* Ctr_button_create(Container *c,Control* f,int x,int y,int w,int h,int nstates);

#endif