//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "bitmap.h"
#include "interf.h"
Ctr_lines::Ctr_lines(Container *c,Control* f,int x,int y,int w,int h):Control(c,f,x,y,w,h)
{
	npixels=0;
	tx=ty=tcol=NULL;
	scale=0;
}

Ctr_lines::~Ctr_lines()
{
	if (tx) delete tx;
	if (ty) delete ty;
	if (tcol) delete tcol;
}

/*
Control* Ctr_lines::clic(int x,int y)
{
	return NULL;
}
void Ctr_lines::unclic(int x,int y)
{
}
*/
void Ctr_lines::draw(Bitmap *bmp,int dx,int dy)
{
	if (npixels<2) return;
	int lx=dx+imap->xcoord(tx[0]);
	int ly=dy+imap->ycoord(ty[0]);
	for(int i=1;i<npixels;i++)
	{
		int x=dx+imap->xcoord(tx[i]);
		int y=dy+imap->ycoord(ty[i]);
		bmp->drawlinebold(lx,ly,x,y,tcol[i]);
		lx=x; ly=y;
	}
}

void Ctr_lines::setscale(int s)
{
//	PRINTF("lines::setscale : %d\n",s);
	scale=s;
}

void Ctr_lines::setnpixels(int n)
{
	if (tx) delete tx;
	if (ty) delete ty;
	if (tcol) delete tcol;
	tx=ty=tcol=NULL;
	if (n)
	{
		tx=new int[n];
		ty=new int[n];
		tcol=new int[n];
	}
	for(int i=0;i<n;i++) tx[i]=ty[i]=tcol[i]=0;
	npixels=n;
}

void Ctr_lines::setnthpix(int i,int x,int y,int col)
{
	if ((i<0)||(i>=npixels)) return;
	tx[i]=x;
	ty[i]=y;
	tcol[i]=col;
}

Ctr_lines* Ctr_lines_create(Container *c,Control* f,int x,int y,int w,int h)
{
	return new Ctr_lines(c,f,x,y,w,h);
}