//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _CTR_LIST_
#define _CTR_LIST_

#include"param.h"

class Container;
class Bitmap;

#define LITEM_TEXT 1
#define LITEM_BUTTON 2
#define LITEM_ICON 4

class Listitem;

typedef void (*CBLIST)(Listitem* b,void* user1,void* user2);

class Listitem
{
	int style;
	char* name;
	Font* font;
	int tx,tstyle,tcol;
	Bitmap* button;
	Bitmap* icon;
	int ix,iy,ixs,iys,iw,ih;
	int down;
	CBLIST cbfun;
	void* userparam1;
	void* userparam2;
public:
	int score;
	Listitem();
	~Listitem();
	void setname(char* name);
	char* getname();
	void settext(int x,int style,int col);
	void setbutton(char* filename);
	void seticon(char* filename);
	void seticonpos(int x,int y,int xs,int ys,int w,int h);
	void setdown(int d);
	int getdown();
	void setstyle(int s);
	void setfont(Font* f);
	void setscore(int s);
	void setcb(CBLIST cb,void* user1,void* user2);
	void draw(Bitmap* bmp,int x,int y,int w,int h);
	void callcb();
};


class Ctr_list : public Control
{
private:
	Bitmap* list;
	int dh;
	int nitems;
	int maxitems;
	Listitem** items;
	int first;
	int anim;

public:
	Ctr_list(Container *c,Control* f,int x,int y,int w,int h,int dy);
	~Ctr_list();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	Bitmap* getlist();

	void refresh();

	void empty();
	void setnitems(int n);
	int getnitems();
	Listitem* getnthitem(int i);
	Listitem* getnextitem();
	void scroll(int delta);
	void scrollto(int i);
	void setscroll(int i);
	int mayscroll(int i);
	int getscroll();
	void sortname(int slimit);
};

Ctr_list* Ctr_list_create(Container *c,Control* f,int x,int y,int w,int h,int dy);

#endif