//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _CTR_MAP_
#define _CTR_MAP_

#include"param.h"

#include"poi.h"
class Container;
class Bitmap;
class Ctr_button;
class Ctr_lines;

#define MAP_MAXPOI 20

class Submap
{
public:
	Bitmap* src;
	Poi* poitab[MAP_MAXPOI];
	Ctr_button* poibtab[MAP_MAXPOI];
	int xm;
	int ym;
	HANDLE file;
	int offload;

};

class Ctr_map : Control
{
private:
	Submap* submap[4];
	int scale;
	int zoomdir;	// direction du zoom
	int zoomk;		// coefficient de zoom
	int zoomrun;	// continuer le zoom automatiquement

	int dwm,dhm;	// dimensions des sous-cartes
	int xm,ym;	// coordonnees de la sous-carte haut-gauche
	int xclic,yclic;	// coordonnees lors du clic
	int move;

	int target;
	int targetx;
	int targety;
	int gpsstate,gpsx,gpsy;
	int gpstrack;
	Ctr_button* gps;
	Control *shell;

	int lastxs,lastys;

	void tryload();
	int isinarea(int x,int y);
	int isinarea(int x,int y,int limit);
	void middlearea(int i,int* x,int* y);

public:
	Ctr_lines* lines;

	Ctr_map(Container *c,Control* f,int x,int y,int w,int h,int wm,int hm);
	~Ctr_map();
	void reload(int xxm,int yym);

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void moveclic(int x,int y);

	void draw(Bitmap *bmp,int x,int y);

	void zoom(int change);
	void zoomd(int in);
	void zoomstop();

	void setscale(int newscale);
	int getscale();
	int xcoord(int x);
	int ycoord(int y);
	int absxcoord(int x);
	int absycoord(int y);

	void gpsnotify(int state,int x,int y);
	void gpssettrack(int tracker);
	int getgpsmode();

	void updatepoi(int x,int y);
	void updatepoi();
	void clicpoi(Poi* p);
	void getcoord(int* x,int *y);
	void moveto(int x,int y,int delay);
	void resetpoi();
};

Ctr_map* Ctr_map_create(Container *c,Control* f,int x,int y,int w,int h,int wm,int hm);

#endif