//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "bitmap.h"
#include "rsc.h"

Ctr_push::Ctr_push(Container *c,Control* f,int x,int y,int w,int h,char* filename,CBPUSH cb,void* u1,void* u2):Control(c,f,x,y,w,h)
{
	bmp=rscGet(filename);
//	if (bmp) PRINTF("load ok\n");
	cbfun=cb;
	userparam1=u1;
	userparam2=u2;
	offh=0;
	disable=0;
	back=-1;
}

Ctr_push::Ctr_push(Container *c,Control* f,int x,int y,int w,int h,Bitmap* b,CBPUSH cb,void* u1,void* u2):Control(c,f,x,y,w,h)
{
	bmp=b;
	cbfun=cb;
	userparam1=u1;
	userparam2=u2;
	offh=0;
	disable=0;
	back=-1;
}

Ctr_push::~Ctr_push()
{
//	PRINTF("delete push\n");
	if (bmp) PRINTF("unload %s\n",bmp->name);
	if (bmp) rscUnuseit(bmp);
}

void Ctr_push::enable(int v)
{
	disable=(!v)?1:0;
	offh=(disable)?hs+hs:0;
}

void Ctr_push::setback(int b)
{
	back=b;
}

Control* Ctr_push::clic(int x,int y)
{
	if (disable) return this;
	offh=hs;
	if (cbfun)
	{
		(*cbfun)(this,x,y,CBBUTTON_DOWN,userparam1,userparam2);
		return this;
	}
	return this;
}
void Ctr_push::unclic(int x,int y)
{
	if (disable) return;
	offh=0;
//	PRINTF("button up\n");
	if (cbfun)
	{
		if (inside(x,y)) (*cbfun)(this,x,y,CBBUTTON_UP,userparam1,userparam2);
		else (*cbfun)(this,x,y,CBBUTTON_UPOUTSIDE,userparam1,userparam2);
	}
}

void Ctr_push::draw(Bitmap *bmpd,int dx,int dy)
{
	int x=dx;
	int y=dy;

	if (bmp) bmpd->blit(x,y,bmp,0,offh,ws,hs,back);
}

void Ctr_push::bmpupdate(char *filename)
{
	if (bmp) rscUnuseit(bmp);
	bmp=NULL;
	if (filename) bmp=rscGet(filename);
}

Ctr_push* Ctr_push_create(Container *c,Control* f,int x,int y,int w,int h,char* filename,CBPUSH cb,void* user1,void* user2)
{
	return new Ctr_push(c,f,x,y,w,h,filename,cb,user1,user2);
}

Ctr_push* Ctr_push_create(Container *c,Control* f,int x,int y,int w,int h,char* filename,CBPUSH cb,void* user1,void* user2,int back)
{
	Ctr_push *p=new Ctr_push(c,f,x,y,w,h,filename,cb,user1,user2);
	if (p) p->setback(back);
	return p;
}

Ctr_push* Ctr_push_create(Container *c,Control* f,int x,int y,int w,int h,Bitmap* bmp,CBPUSH cb,void* user1,void* user2)
{
	return new Ctr_push(c,f,x,y,w,h,bmp,cb,user1,user2);
}
Ctr_push* Ctr_push_create(Container *c,Control* f,int x,int y,int w,int h,Bitmap* bmp,CBPUSH cb,void* user1,void* user2,int back)
{
	Ctr_push *p=new Ctr_push(c,f,x,y,w,h,bmp,cb,user1,user2);
	if (p) p->setback(back);
	return p;
}
