//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "bitmap.h"
#include "rsc.h"

#define TEXT_SPEED 20

Ctr_text::Ctr_text(Container *c,Control* f,int x,int y,int w,int h,displaystring *txt,int colf,int colb,Font* ft,int st):Control(c,f,x,y,w,h)
{
	bmp=new Bitmap(w,h);
	backbmp=NULL;
	text=new displaystring[displaystrlen(txt)+1];
	displaycopy(text,txt);
	front=colf;
	back=colb;
	font=ft;
	style=st;
	first=anim=0;
	countlignes();
	refresh();
}

Ctr_text::~Ctr_text()
{
	delete text;
	delete bmp;
	if (backbmp) rscUnuseit(backbmp);
}

void Ctr_text::countlignes()
{
	bmp->textnblines(ws,text,strlen(text),font,&nlignes);
}

void Ctr_text::refresh()
{
	if (backbmp) bmp->blit(0,0,backbmp,0,0,backbmp->width,backbmp->height,-1);
	else bmp->empty((back==-1)?0x1f:back);
	bmp->drawtextbox(0,-first+anim,ws,((nlignes<bmp->height)?bmp->height:(bmp->height+first-anim)),style,text,strlen(text),front,back,font);
}

void Ctr_text::backupdate(char *filename)
{
	if (backbmp) rscUnuseit(backbmp);
	backbmp=NULL;
	if (filename) backbmp=rscGet(filename);
	refresh();
}

/*
Control* Ctr_text::clic(int x,int y)
{
	return NULL;
}
void Ctr_text::unclic(int x,int y)
{
}
*/
void Ctr_text::draw(Bitmap *b,int dx,int dy)
{
	if (anim)
	{
		if (anim<0)
		{
			anim+=TEXT_SPEED;
			if (anim>0) anim=0;
		}
		else if (anim>0)
		{
			anim-=TEXT_SPEED;
			if (anim<0) anim=0;
		}
		refresh();
	}
	b->blit(dx,dy,bmp,0,0,ws,hs,0x1f);

}


void Ctr_text::textupdate(displaystring *txt)
{
	delete text;
	text=new displaystring[displaystrlen(txt)+1];
	displaycopy(text,txt);
	countlignes();
	refresh();
}
void Ctr_text::textappend(displaystring *txt)
{
	int n=0;
	if (text) n+=strlen(text);
	n+=strlen(txt);
	char* newtext=new displaystring[n+1];
	displaycopy(newtext,text);
	displaycopy(newtext+strlen(text),txt);
	if (text) delete text;
	text=newtext;
	countlignes();
	refresh();
}

void Ctr_text::scroll(int delta)
{
	scrollto(first+delta);
}
void Ctr_text::scrollto(int i)
{
	if (i<0) i=0;
	if (i+hs>nlignes) i=nlignes-hs;
	if (i<0) i=0;
	anim=(i-first);
	first=i;
	refresh();
}
void Ctr_text::setscroll(int i)
{
	if (i<0) i=0;
	if (i+hs>nlignes) i=nlignes-hs;
	if (i<0) i=0;
	anim=0;
	first=i;
	refresh();
}

int Ctr_text::mayscroll(int i)
{
	i+=first;
	if (i<0) return 0;
	if (i+hs>nlignes) return 0;
	return 1;
}

int Ctr_text::getscroll()
{
	return first;
}

Ctr_text* Ctr_text_create(Container *c,Control* f,int x,int y,int w,int h,displaystring *txt,int colf,int colb,Font* ft)
{
	return new Ctr_text(c,f,x,y,w,h,txt,colf,colb,ft,ALIGN_CENTER);
}

Ctr_text* Ctr_text_create(Container *c,Control* f,int x,int y,int w,int h,displaystring *txt,int colf,int colb,Font* ft,int style)
{
	return new Ctr_text(c,f,x,y,w,h,txt,colf,colb,ft,style);
}