//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>

#include "param.h"
#include "dico.h"
#include "file.h"


Dico::Dico()
{
	nref=0;
	data=NULL;
	sel=NULL;
}

Dico::~Dico()
{
	if (data) fileRelease(data);
	if (sel) delete sel;

}

int Dico::msbtoint(char *p)
{
	return ((p[0]&255)<<24)+((p[1]&255)<<16)+((p[2]&255)<<8)+(p[3]&255);
}

int Dico::load(char *filename)
{
	nref=0;
	data=fileLoad(filename);
	if (!data) return -1;

	int i=0;
	nref=msbtoint(data+i); i+=4;
	indkey=(int*)(&data[i]); i+=(nref<<2);
	indenr=(int*)(&data[i]); i+=(nref<<2);
	content=&data[i];
	if (sel) delete sel;
	sel=new int[nref];

	return 0;
}

int Dico::getindex(char *src)
{
	int i;
	for(i=0;i<nref;i++)
	{
		int offs=msbtoint((char*)(&indkey[i]));
		if (strcmp(content+offs,src)>=0) return i;
	}
	return -1;
}

char* Dico::getkey(int index)
{
	if ((index<0)||(index>=nref)) return NULL;
	return content+msbtoint((char*)(&indkey[index]));
}

char* Dico::getenr(int index)
{
	if ((index<0)||(index>=nref)) return NULL;
	return content+msbtoint((char*)(&indenr[index]));
}

int Dico::getndico()
{
	return nref;
}
int Dico::getselect(int index)
{
	if ((index<0)||(index>=nref)) return 0;
	return sel[index];
}
int Dico::select(char* key)
{
	int i;
	int n=0;
	for(i=0;i<nref;i++)
	{
		int k=(strstr(content+msbtoint((char*)(&indkey[i])),key)==NULL)?0:1;
		sel[i]=k;
		n+=k;
//		if (k) PRINTF("-%s : %s\n",&index[tstreet[i].index],getdesc(&tstreet[i]));
	}
	return n;
}


