//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>

#include "param.h"
#include "file.h"

char* fileLoad(char *filename,int *size)
{
	HANDLE file;
	DWORD nread;
	filename_type realname[MAX_FILENAME];

	filename_copyfromchar(realname,filename);
	file=CreateFile(realname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (file == INVALID_HANDLE_VALUE) return NULL;

	int n=GetFileSize(file,NULL);
	if (n==INVALID_FILE_SIZE)
	{
		CloseHandle(file);
		return NULL;
	}
	char* p=new char[n+1];
	if (!ReadFile(file,p,n,&nread,NULL))
	{
		delete p;
		CloseHandle(file);
		return NULL;
	}
	p[n]=0;
	if (size) *size=n;
	CloseHandle(file);
	return p;
}

char* fileLoad(char *filename)
{
	return fileLoad(filename,NULL);
}

void fileRelease(char *data)
{
	if (data) delete data;
}

int fileCheck(char *filename)
{
	HANDLE file;
	filename_type realname[MAX_FILENAME];

	filename_copyfromchar(realname,filename);
	file=CreateFile(realname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (file == INVALID_HANDLE_VALUE) return 0;
	CloseHandle(file);
	return 1;
}

int fileHash(char *filename,int ln)
{
	int v=0;
	int N=1<<ln;
	unsigned char* p=(unsigned char*)filename;

	while(*p)
	{
		 v=v+v+*(p++);
		 while(v>=N) v=(v&(N-1))+(v>>ln);
	}
	return v;
}
