#include <windows.h>
#include <string.h>

#include "param.h"

#include "poi.h"
#include "config.h"


//--------------------------------- GPS
int gps_ok=0;
int gps_x=4558;
int gps_y=3961;
volatile int restartgps;

int gpsparser_index=-1;
char gpsparser_buffer[256];

#define my_float double
void logstr(char* src)
{
}

HANDLE hCom=0;

//my_float ay=6029291.;my_float by=-1242.1;my_float ax=-168037.;my_float bx=781.9426;
//my_float ay=5976610.4702298;my_float by=-1231.24265265186;my_float ax=-171502.420589663;my_float bx=797.743266197527;
my_float ay=6005167.65312002;my_float by=-1237.13091638051;my_float ax=-173684.406719718;my_float bx=807.544945475982;


void gpsResetpos()
{
	Poi* p=poilist->getstart();
	if (p)
	{
		gps_x=p->x;
		gps_y=p->y;
	}
}


my_float my_atof(char* src)
{
	int c;
	my_float f=0;
	my_float div=1;
	int point=0;
	while(c=*src++)
	{
		if ((c=='.')&&(!point)) point=1;
		else if ((c>='0')&&(c<='9'))
		{
			f=(f*10)+c-'0';
			if (point) div*=10;
		}
		else return f/div;
	}
	return f/div;
}

void gpscut(char** tab,int n)
{
	int i,j;
	int len=strlen(gpsparser_buffer);
	j=0;
	tab[j++]=gpsparser_buffer;
	for(i=0;i<len;i++)
		if (gpsparser_buffer[i]==',')
		{
			gpsparser_buffer[i]=0;
			if (j<n) tab[j++]=&gpsparser_buffer[i+1];
		}
	while(j<n) tab[j++]=&gpsparser_buffer[len];;
}

void gpsfeed(char *src,int len)
{
//	display_type dst[1024];
	char* args[16];
	int i;
	for(i=0;i<len;i++)
	{
		char c=src[i];
		if (gpsparser_index<0)
		{
			if (c=='$') gpsparser_index=0;
		}
		else
		{
			if (c==13)
			{
				gpsparser_buffer[gpsparser_index]=0;
				if (!strncmp(gpsparser_buffer,"GPRMC",5))
				{
					my_float x,y;

/*					logstr(gpsparser_buffer,strlen(gpsparser_buffer));
					logstr("\n",1);
					display_copyfromchar(dst,gpsparser_buffer);
					consoleAdd(dst);
					consoleAdd(TEXT("\r\n"));
*/
//					strcpy(gpsparser_buffer,"GPRMC,152514.786,A,4852.6770,N,00219.6096,E,9.18,292.29,260406,,,A*6B");

					gpscut(args,8);

					if (args[2][0]=='A')
					{
						y=my_atof(args[3]);
						if (args[4][0]=='S') y=-y;

						x=my_atof(args[5]);
						if (args[6][0]=='W') x=-x;
						
						x=ax+bx*x;
						y=ay+by*y;
						gps_ok=1;
						gps_x=(int)x;
						gps_y=(int)y;
					}
					else
					{
						gps_ok=0;
					}

//					wsprintf(dst,TEXT("%d - %d - %d"),gps_ok,gps_x,gps_y);
//					SetWindowText(hpos,dst);

				}
				gpsparser_index=-1;
			}
			else gpsparser_buffer[gpsparser_index++]=c;
		}
	}
}
#ifdef POCKETPC

void gpsClose()
{
	logstr("gps close\r\n");

	if (hCom) CloseHandle(hCom);
	hCom=0;
}

int gpsInit()
{
	DCB dcb;
	COMMTIMEOUTS ct;
	BOOL fSuccess;
//	display_type buffer[256];

	logstr("gps open\r\n");

	gps_ok=0;

	hCom=CreateFile(TEXT(GPSCOM),GENERIC_READ | GENERIC_WRITE,0,
		NULL,OPEN_EXISTING,0,NULL);
	if (hCom == INVALID_HANDLE_VALUE)
	{
		hCom=0;
//		wsprintf(buffer,TEXT("## CreateFile failed with error %d.\r\n"), GetLastError());
//		consoleAdd(buffer);
		return -1;
	}
	
	fSuccess = GetCommState(hCom, &dcb);
	if (!fSuccess) 
	{
		// Handle the error.
		hCom=0;
//		wsprintf(buffer,TEXT("## GetCommState failed with error %d.\r\n"), GetLastError());
//		consoleAdd(buffer);
		return -2;
	}
	dcb.BaudRate = GPSBD; //CBR_2400;     // set the baud rate
	dcb.ByteSize = 8;             // data size, xmit, and rcv
	dcb.Parity = NOPARITY;        // no parity bit
	dcb.StopBits = ONESTOPBIT;    // one stop bit
	fSuccess = SetCommState(hCom, &dcb);
	if (!fSuccess) 
	{
		hCom=0;
		// Handle the error.
//		wsprintf(buffer,TEXT("## SetCommState failed with error %d.\r\n"), GetLastError());
//		consoleAdd(buffer);
		return -3;
	}
	fSuccess = GetCommTimeouts(hCom, &ct);
	if (!fSuccess) 
	{
		hCom=0;
		// Handle the error.
//		wsprintf(buffer,TEXT("## GetCommTimeouts failed with error %d.\r\n"), GetLastError());
//		consoleAdd(buffer);
		return -4;
	}
	ct.ReadIntervalTimeout=MAXDWORD;

	fSuccess = SetCommTimeouts(hCom, &ct);
	if (!fSuccess) 
	{
		hCom=0;
		// Handle the error.
//		wsprintf(buffer,TEXT("## SetCommTimeouts failed with error %d.\r\n"), GetLastError());
//		consoleAdd(buffer);
		return -5;
	}

//	consoleAdd(TEXT("## RS device ready\r\n"));
	return 0;
}
#endif

void gpsReset()
{
	restartgps=1;
}


DWORD WINAPI Threadgps(LPVOID lpParameter)
{
	char buffer[128];
	restartgps=0;
	while(1)
	{
		logstr("gps loop\r\n");
	#ifdef POCKETPC
		if (restartgps)
		{
			gpsClose();
			restartgps=0;
		}


		if (!hCom) gpsInit();

		if (!hCom)
		{
			gps_ok=-1;
		}
		else
		{
			int k;
			char buf[600];
			DWORD dwBytesRead;

			do
			{
				logstr("gps read\r\n");
				buf[0]=0;
				if (ReadFile (hCom,buf,64,&dwBytesRead,NULL)) k=dwBytesRead;
				else k=-1;
				if (k<0) gpsClose();
				else if (k>0)
				{
					buf[k]=0;
					gpsfeed(buf,k);
				}
			}
			while(k==64);
		}
	#else
		if (restartgps)
		{
			restartgps=0;
		}
		gps_ok=-1;
		int k=GetTickCount();
		gps_x=2000+((k/1000)%4000);
		gps_y=3000;
	#endif
		Sleep(500);
	}
	ExitThread(0);
	return 0;
}


void gpsStart()
{
	DWORD tid;
    HANDLE th=CreateThread(NULL,0,Threadgps,NULL,0,&tid);
#ifndef POCKETPC
//	SetThreadPriority(th,THREAD_PRIORITY_BELOW_NORMAL);//THREAD_PRIORITY_LOWEST);
#endif
}



