//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _HASH_
#define _HASH_

#include"param.h"

char* fileLoad(char *filename);
void fileRelease(char *data);

#define HASH_N 32

class HashKey
{
public:
	HashKey(uchar* k,int klen,uchar *v,int vlen,HashKey* nxt);
	~HashKey();

	char* key;
	char* val;
	HashKey* next;

	void dump();

};


class Hash
{
private:
	int n;
	HashKey** htab;
	int hashval(unsigned char *key,int len);
	int parse(unsigned char *src);
public:
	Hash(int nb);
	~Hash();

	int load(char *filename);
	int load(char *filename,int crypt);

	void dump();
	void reverse();
	char* get(char *key);
	char* getnth(char *key,int n);
	HashKey* getnth(int n);
};

#endif