//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _INTERF_
#define _INTERF_

#include"param.h"

#include"street.h"

#define ITF_NB 31
#define ITF_MAIN 0
#define ITF_ZOOM 1
#define ITF_SIMPLE 2
#define ITF_POI 3
#define ITF_PWD 4
#define ITF_DICO 5
#define ITF_DICORESULT 6
#define ITF_I 7
#define ITF_DICOLIST 8
#define ITF_CONVLIST 9
#define ITF_CONVMONEY 10
#define ITF_CONVTEMPER 11
#define ITF_CONVLONG 12
#define ITF_POWER 13
#define ITF_LANG 14
#define ITF_START 15
#define ITF_ITI 16
#define ITF_SEL 17
#define ITF_ITILIST 18
#define ITF_SEQ 19
#define ITF_SEARCH 20
#define ITF_PANIER 21
#define ITF_PLAY 22
#define ITF_I2 23
#define ITF_MODE 24
#define ITF_TOOLS 25
#define ITF_INDEX 26
#define ITF_STATION 27
#define ITF_DIAPO 28
#define ITF_STREET 29
#define ITF_METRO 30


class Ctr_map;
class Container;
class Bitmap;
class Control;
class Ctr_button;
class Ctr_back;
class Ctr_push;
class Ctr_list;
class Hash;
class HashKey;
class Dico;
class Metro;

class Interf
{
private:
protected:
	int hiding;
public:
	Interf();
	~Interf();
	virtual void load();
	virtual void unload();
	virtual void show();
	virtual void hide();
};


class Interf_main : public Control, public Interf
{
private:
	int loaded;
	Ctr_button *bar;
	Ctr_button *gps;
	Ctr_push *welcome;
	Ctr_push *zoom;
	Ctr_push *search;
	Ctr_push *select;
	int count;
public:
	Interf_main(Container *c,Control* f);
	~Interf_main();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void zoomit();
	void langupdate();
};

Interf_main* Interf_main_create(Container *c,Control* f);

class Interf_zoom : public Control, public Interf
{
private:
	int loaded;
	Ctr_button *bar;
	Ctr_push *zoomin;
	Ctr_push *zoomout;
	Ctr_push *cancel;
	Ctr_button *level;
	int count;
	int t0;
public:
	Interf_zoom(Container *c,Control* f);
	~Interf_zoom();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void zoom(int in,int state);
	void cbcancel();
	void langupdate();

};

Interf_zoom* Interf_zoom_create(Container *c,Control* f);

class Interf_simple : public Control, public Interf
{
private:
	int loaded;
	Bitmap*	icons;
	Bitmap* menu;

	Ctr_button *bar;
	Ctr_push *left;
	Ctr_push *right;
	Ctr_push *cancel;
	Ctr_button *choices;
	int count;
	int countscroll;
	int scrollpos;
	int t0;
	int scrollmax;
	int lastlang;
public:
	Interf_simple(Container *c,Control* f);
	~Interf_simple();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbcancel();
	void cbchoice(int x);
	void scroll(int state,int dir);
	void redrawbar();


};

Interf_simple* Interf_simple_create(Container *c,Control* f);

#define PWD_MAX 16

class Interf_pwd : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich;
	char pwd[PWD_MAX];
	char pwd_crypt[PWD_MAX];
	void mkpwd_crypt();
public:
	Interf_pwd(Container *c,Control* f);
	~Interf_pwd();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
};

Interf_pwd* Interf_pwd_create(Container *c,Control* f);



class Interf_poi : public Control, public Interf
{
private:
	int loaded;
	Ctr_back *back;
	Ctr_push *left;
	Ctr_push *steps;
	Ctr_push *heart;
	Ctr_push *right;
	Ctr_push *hp;
	Ctr_push *morepic;
	Ctr_list* list;
	Ctr_text* text;
	Ctr_push* up;
	Ctr_push* down;

	Bitmap* iconsbig;
	Hash *poidata;
	int count;
	Poi* poi;
	Bitmap* star;
	Bitmap* metro;
	int npics;
	int npages;
	int nhp;
	int nsub;

	int page;
	int pic;

	int backinterf;
	void* backuser1;
	void* backuser2;

public:
	Interf_poi(Container *c,Control* f);
	~Interf_poi();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbclose();
	void cbhp();
	void cbsteps();
	void cbheart();
	void cbkey(int v);
	void cbpoiplay(Poi* q);
	void cbpoigo(Poi* q);

	void drawtitle();
	void drawpic();
	int drawnote(int y);
	void drawnav();
	int drawmetro(int y);
	void appendtext(char *txt,int col,int fontnumber);

	int getpicfilepath(int i,char* buffer);

	void poiset(Poi* p);
	void pageset(int pg);
	void poigo(Poi* p,int from,void* user1,void* user2);

};

Interf_poi* Interf_poi_create(Container *c,Control* f);


#define DICO_MAX 50

class Interf_dico : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich;
	Ctr_list* list;
	Ctr_push* up;
	Ctr_push* down;
	char inp[DICO_MAX];

	int charbase;
	int chartime;
	Dico* dico;
	int keybd;

public:
	Interf_dico(Container *c,Control* f);
	~Interf_dico();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void resetdisplay();
	void updatedisplay();

	void cbkey(int val);
	void cbchoice(int val);
	void selectdico(char* filename);
};

Interf_dico* Interf_dico_create(Container *c,Control* f);

class Interf_dicoresult : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* src;
	Ctr_text* trad;
public:
	Interf_dicoresult(Container *c,Control* f);
	~Interf_dicoresult();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void resultset(char* p);
};

Interf_dicoresult* Interf_dicoresult_create(Container *c,Control* f);

class Interf_i : public Control, public Interf
{
private:
	int loaded;
	Ctr_button* back;
public:
	Interf_i(Container *c,Control* f);
	~Interf_i();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};

Interf_i* Interf_i_create(Container *c,Control* f);


class Interf_dicolist : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_dicolist(Container *c,Control* f);
	~Interf_dicolist();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};

Interf_dicolist* Interf_dicolist_create(Container *c,Control* f);

class Interf_convlist : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_convlist(Container *c,Control* f);
	~Interf_convlist();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};

Interf_convlist* Interf_convlist_create(Container *c,Control* f);

class Interf_convmoney : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich_h;
	Ctr_text* affich_l;
	Ctr_button* bdev_h;
	Ctr_button* bdev_l;
	int devise_h;
	int devise_l;
	int val;
	void updateval();
public:
	Interf_convmoney(Container *c,Control* f);
	~Interf_convmoney();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
};

Interf_convmoney* Interf_convmoney_create(Container *c,Control* f);

class Interf_convtemper : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich_h;
	Ctr_text* affich_l;
	Ctr_button* bdev_h;
	Ctr_button* bdev_l;
	int devise_h;
	int devise_l;
	int val;
	void updateval();
public:
	Interf_convtemper(Container *c,Control* f);
	~Interf_convtemper();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
};

Interf_convtemper* Interf_convtemper_create(Container *c,Control* f);

class Interf_convlong : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich_h;
	Ctr_text* affich_l;
	Ctr_button* bdev_h;
	Ctr_button* bdev_l;
	int devise_h;
	int devise_l;
	int val;
	void updateval();
public:
	Interf_convlong(Container *c,Control* f);
	~Interf_convlong();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
};

Interf_convlong* Interf_convlong_create(Container *c,Control* f);

class Interf_power : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
#ifdef POCKETPC
	SYSTEM_POWER_STATUS_EX2 sps;
#else
	SYSTEM_POWER_STATUS sps;
#endif
	int closewhenoff;
public:
	Interf_power(Container *c,Control* f);
	~Interf_power();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	int checkpower();
	int getpower();

	void setclosewhenoff(int v);
};

Interf_power* Interf_power_create(Container *c,Control* f);

#define LANG_FR 0
#define LANG_EN 1
#define LANG_SP 2
#define LANG_JP 3


class Interf_lang : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	int lang;
	Hash* locdata;

	void loadlocfile();

public:
	Interf_lang(Container *c,Control* f);
	~Interf_lang();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	int getlang();
	void cbkey(int val);
	char* loc(char *key);
};

Interf_lang* Interf_lang_create(Container *c,Control* f);

class Interf_start : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_start(Container *c,Control* f);
	~Interf_start();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
};

Interf_start* Interf_start_create(Container *c,Control* f);


class Interf_iti : public Control, public Interf
{
private:
	int loaded;
	int xo,yo;
	int xd,yd;
	Ctr_push* detail;
public:
	Interf_iti(Container *c,Control* f);
	~Interf_iti();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void setorg(int x,int y);
	void setdst(int x,int y);
	void update();

};

Interf_iti* Interf_iti_create(Container *c,Control* f);

class Interf_sel : public Control, public Interf
{
private:
	int loaded;
	int tp;
	Ctr_button* viseur;
public:
	Interf_sel(Container *c,Control* f);
	~Interf_sel();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);
	void settype(int t);

	void cbsel();
};

Interf_sel* Interf_sel_create(Container *c,Control* f);

class Interf_itilist : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_push* prev;
	Ctr_push* next;
	Ctr_list* list;
public:
	Interf_itilist(Container *c,Control* f);
	~Interf_itilist();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void drawiti();
	void cbkey(int val);
	void select(int station);
};

Interf_itilist* Interf_itilist_create(Container *c,Control* f);

#define SEQ_MAXBACK 50

class Interf_seq : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_list* list;
	Ctr_text* text;
	int pgback[SEQ_MAXBACK];
	int pgbackscroll[SEQ_MAXBACK];
	int pgbackindex;

	int pg;
	Ctr_push* prev;
	Ctr_push* next;
	Ctr_push* up;
	Ctr_push* down;
	Ctr_push* hp_play;
	Ctr_push* hp_stop;
	Ctr_push* info;
	Ctr_push* volplus;
	Ctr_button* level;
	Ctr_push* volmoins;
	char* mp3;

	Hash* seq;

	HashKey* pagereach(int i);
	int pagereach(char* id);

public:
	Interf_seq(Container *c,Control* f);
	~Interf_seq();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void getseq(char *filename);
	void page(int i);
	void page(char* p);

	void cbkey(int val);
	void cbvol(int v);
};

Interf_seq* Interf_seq_create(Container *c,Control* f);

class Interf_search : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_list* list;
	Ctr_push* prev;
	Ctr_push* up;
	Ctr_push* down;
	Ctr_push* todiapo;
	int page;

public:
	Interf_search(Container *c,Control* f);
	~Interf_search();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void setpage(int pg,int scroll);
	void cbarbo(int val);
	void cbkey(int val);
	void cbpoi(int i);
	void cbdiapo();
};

Interf_search* Interf_search_create(Container *c,Control* f);

#define PANIER_MAXPOI 32

class Interf_panier : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_list* list;
	Ctr_push* up;
	Ctr_push* down;
	Poi* lpoi[PANIER_MAXPOI];
	char* lpoiname[PANIER_MAXPOI];
	int lpoicrit[PANIER_MAXPOI];
	int npoi;

public:
	Interf_panier(Container *c,Control* f);
	~Interf_panier();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
	void cbsel(int val);

	void listclear();
	void listadd(Poi* p,char* name,int crit);
	void listrem(Poi* p);
	int listcontains(Poi* p);
	int listfull();

};

Interf_panier* Interf_panier_create(Container *c,Control* f);

class Interf_play : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* count;
	Ctr_push* down;
	Ctr_push* pause;

	Ctr_push *leveldown;
	Ctr_push *levelup;
	Ctr_button *level;
	int lastcount;
	int moreinfo;

public:
	Interf_play(Container *c,Control* f);
	~Interf_play();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbkey(int val);
	void cbvol(int v);
	void cbpause();
	void updatetitle(char *val);
	void setmoreinfo(int v);

};

Interf_play* Interf_play_create(Container *c,Control* f);

class Interf_i2 : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_i2(Container *c,Control* f);
	~Interf_i2();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};

Interf_i2* Interf_i2_create(Container *c,Control* f);

class Interf_mode : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_mode(Container *c,Control* f);
	~Interf_mode();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};


Interf_mode* Interf_mode_create(Container *c,Control* f);

class Interf_tools : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
public:
	Interf_tools(Container *c,Control* f);
	~Interf_tools();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

};

Interf_tools* Interf_tools_create(Container *c,Control* f);

#define INDEX_MAX 50

class Interf_index : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich;
	Ctr_list* list;
	Ctr_push* up;
	Ctr_push* down;
	char inp[INDEX_MAX];
	int charbase;
	int chartime;
public:
	Interf_index(Container *c,Control* f);
	~Interf_index();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void resetdisplay();
	void updatedisplay();

	void cbkey(int val);
	void cbchoice(Poi* p);
};

Interf_index* Interf_index_create(Container *c,Control* f);


class Interf_station : public Control, public Interf
{
private:
	int loaded;

	Ctr_button *bar;
	int station;
	Ctr_push *go;
	Ctr_push *cancel;
	Bitmap* bmp;
	Ctr_button *display;

	int count;
	int t0;
public:
	Interf_station(Container *c,Control* f);
	~Interf_station();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void cbcancel();
	void cbgo();
	void redrawbar(int station);
};

Interf_station* Interf_station_create(Container *c,Control* f);

class Interf_diapo : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_button* diapo;
	Ctr_push* prev;
	Ctr_push* next;
	Ctr_push* poi;
	Ctr_button* cross;
	Bitmap* film;
	Bitmap* paris;
	Bitmap* pellicule;
	Bitmap* icon;
	Poi* currentpoi;

	Bitmap* pics[4];
	int index;
	int scroll;
	int anim;
	int crit;
	int autoscroll;

public:
	Interf_diapo(Container *c,Control* f);
	~Interf_diapo();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void drawpoimenu();
	Bitmap* loadpoipic(Poi* p);
	void loadpic(int i);
	void drawfilm();

	void setcrit(int c,int i);
	void cbkey(int val);
	void cbpoi();
	void cblist();

	void setautoscroll();
};

Interf_diapo* Interf_diapo_create(Container *c,Control* f);

#define STREET_MAX 16

class Interf_street : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich;
	Ctr_list* list;
	Ctr_push* up;
	Ctr_push* down;
	char inp[STREET_MAX];
	int charbase;
	int chartime;
public:
	Interf_street(Container *c,Control* f);
	~Interf_street();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void resetdisplay();
	void updatedisplay();

	void cbkey(int val);
	void cbchoice(Street* p);
};

Interf_street* Interf_street_create(Container *c,Control* f);

#define METRO_MAX 16

class Interf_metro : public Control, public Interf
{
private:
	int loaded;
	Ctr_back* back;
	Ctr_text* affich;
	Ctr_list* list;
	Ctr_push* up;
	Ctr_push* down;
	char inp[METRO_MAX];
	int charbase;
	int chartime;
public:
	Interf_metro(Container *c,Control* f);
	~Interf_metro();

	void load();
	void unload();
	void show();
	void hide();

	Control* clic(int x,int y);
	void unclic(int x,int y);
	void draw(Bitmap *bmp,int x,int y);

	void resetdisplay();
	void updatedisplay();

	void cbkey(int val);
	void cbchoice(int p);
};

Interf_metro* Interf_metro_create(Container *c,Control* f);

extern Metro* metro;

extern Interf_main *imain;
extern Interf_zoom *izoom;
extern Interf_simple *isimple;
extern Ctr_map *imap;
extern Interf_poi *ipoi;
extern Interf_pwd *ipwd;
extern Interf_dico *idico;
extern Interf_dicoresult *idicoresult;
extern Interf_i *ii;
extern Interf_dicolist *idicolist;
extern Interf_convlist *iconvlist;
extern Interf_convmoney *iconvmoney;
extern Interf_convtemper *iconvtemper;
extern Interf_convlong *iconvlong;
extern Interf_power *ipower;
extern Interf_lang *ilang;
extern Interf_start *istart;
extern Interf_iti *iiti;
extern Interf_sel *isel;
extern Interf_itilist *iitilist;
extern Interf_seq *iseq;
extern Interf_search *isearch;
extern Interf_panier *ipanier;
extern Interf_play *iplay;
extern Interf_i2 *ii2;
extern Interf_mode *imode;
extern Interf_tools *itools;
extern Interf_index *iindex;
extern Interf_station *istation;
extern Interf_diapo *idiapo;
extern Interf_street *istreet;
extern Interf_metro *imetro;

void interfInit(Container* container);

void interfActive(int interf,int val);
int interfIsActive(int interf);

#endif