//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_convlist::Interf_convlist(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_convlist::~Interf_convlist()
{
	hide();
	unload();
	link(NULL);
}


void icbconvlistclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_CONVLIST,0);
}

void icbconvlistsel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		int x=(int)user2;
		if (x==0) interfActive(ITF_CONVMONEY,1);
		else if (x==1) interfActive(ITF_CONVLONG,1);
		else if (x==4) interfActive(ITF_CONVTEMPER,1);
		else if (x==2)
		{
			iseq->getseq(ilang->loc("loc_tailles_seq"));
			interfActive(ITF_SEQ,1);
		}
		else if (x==3)
		{
			iseq->getseq(ilang->loc("loc_pointures_seq"));
			interfActive(ITF_SEQ,1);
		}
	}
}


void Interf_convlist::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_convlist_title"));

	Ctr_push_create(container,back,8,40,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_convlist_money"),font_subtitle,2),icbconvlistsel,this,(void*)0);
	Ctr_push_create(container,back,8,80,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_convlist_lengths"),font_subtitle,2),icbconvlistsel,this,(void*)1);
	Ctr_push_create(container,back,8,120,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_convlist_tailles"),font_subtitle,2),icbconvlistsel,this,(void*)2);
	Ctr_push_create(container,back,8,160,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_convlist_pointures"),font_subtitle,2),icbconvlistsel,this,(void*)3);
	Ctr_push_create(container,back,8,200,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_convlist_temper"),font_subtitle,2),icbconvlistsel,this,(void*)4);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbconvlistclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_convlist::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_convlist::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_convlist::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_convlist::clic(int x,int y)
{
	return NULL;
}
void Interf_convlist::unclic(int x,int y)
{
}

void Interf_convlist::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_convlist* Interf_convlist_create(Container *c,Control* f)
{
	return new Interf_convlist(c,f);
}

