//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"

#define LONG_NBDEV 6

int convertlong[LONG_NBDEV]={100,10000,10000000,254,3048,16093440};

Interf_convlong::Interf_convlong(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	val=0;
	devise_h=0;
	devise_l=3;
}

Interf_convlong::~Interf_convlong()
{
	hide();
	unload();
	link(NULL);
}

void icbconvlongclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_CONVLONG,0);
}

void Interf_convlong::updateval()
{
	char buffer[32];
	sprintf(buffer,"%d",val);
	affich_h->textupdate(buffer);

	float x=(float)val;
	if (devise_h!=devise_l)	x=x*convertlong[devise_h]/convertlong[devise_l];

	sprintf(buffer,"%.3f",x);
	affich_l->textupdate(buffer);

	bdev_h->movesrcbmp(0,0,32*devise_h);
	bdev_l->movesrcbmp(0,0,32*devise_l);
}

void Interf_convlong::cbkey(int v)
{
	if (v==-2)
	{
		devise_h++;
		if (devise_h>=LONG_NBDEV) devise_h=0;
	}
	else if (v==-3)
	{
		devise_l++;
		if (devise_l>=LONG_NBDEV) devise_l=0;
	}
	else if (v==-1) val/=10;
	else if (v==10) val=0;
	else if (val<100000) val=val*10+v;

	updateval();
}

void icbconvlongkey(int key,void* user,void* user2)
{
	((Interf_convlong*)user)->cbkey(key);
}

void icbconvlongbdev_h(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convlong*)user)->cbkey(-2);
}

void icbconvlongbdev_l(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convlong*)user)->cbkey(-3);
}

#define LONG_X0 20
#define LONG_DX	76
#define LONG_Y0	130
#define LONG_DY	(32+8)



void Interf_convlong::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_convlong_title"));

	Ctr_keybd_create(container,back,LONG_X0,LONG_Y0,KEYBD_NUMERICAL,icbconvlongkey,this,NULL);

	affich_h=Ctr_text_create(container,back,LONG_X0,40+4,142,24,"0",COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_h->backupdate("interf/skin/txt_fond_142.r");
	affich_l=Ctr_text_create(container,back,LONG_X0,80+4,142,24,"0",RGBTO16(87,192,45),-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_l->backupdate("interf/skin/txt_fond_142.r");

	Bitmap* longgif=rscGet("interf/keybd/long.r");
	bdev_h=Ctr_button_create(container,back,LONG_X0+2*LONG_DX,40,44,32,1);
	bdev_h->setsrcbmp(0,longgif,-1,0);
	bdev_h->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_h->setmask(0,1);
	bdev_h->setcb(icbconvlongbdev_h,(void*)this,NULL);
	bdev_l=Ctr_button_create(container,back,LONG_X0+2*LONG_DX,80,44,32,1);
	bdev_l->setsrcbmp(0,rscUseit(longgif),-1,0);
	bdev_l->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_l->setmask(0,1);
	bdev_l->setcb(icbconvlongbdev_l,(void*)this,NULL);

	updateval();

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbconvlongclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_convlong::unload()
{
	if (!loaded) return;
//	PRINTF("unload convlong\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}


void Interf_convlong::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

	val=0;
	updateval();
}

void Interf_convlong::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_convlong::clic(int x,int y)
{
	return NULL;
}
void Interf_convlong::unclic(int x,int y)
{
}

void Interf_convlong::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_convlong* Interf_convlong_create(Container *c,Control* f)
{
	return new Interf_convlong(c,f);
}

