//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "config.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"

#define MONEY_NBDEV 3

int convertmoney[MONEY_NBDEV]={1,1,1};

Interf_convmoney::Interf_convmoney(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	val=0;
	devise_h=0;
	devise_l=1;
	convertmoney[0]=atoi(config->get("euro"));
	convertmoney[1]=atoi(config->get("dollar"));
	convertmoney[2]=atoi(config->get("pound"));
}

Interf_convmoney::~Interf_convmoney()
{
	hide();
	unload();
	link(NULL);
}

void icbconvmoneyclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_CONVMONEY,0);
}

void Interf_convmoney::updateval()
{
	char buffer[32];
	sprintf(buffer,"%d",val);
	affich_h->textupdate(buffer);

	float x=(float)val;
	if (devise_h!=devise_l)	x=x*convertmoney[devise_h]/convertmoney[devise_l];

	sprintf(buffer,"%.2f",x);
	affich_l->textupdate(buffer);

	bdev_h->movesrcbmp(0,0,32*devise_h);
	bdev_l->movesrcbmp(0,0,32*devise_l);
}

void Interf_convmoney::cbkey(int v)
{
	if (v==-2)
	{
		devise_h++;
		if (devise_h>=MONEY_NBDEV) devise_h=0;
	}
	else if (v==-3)
	{
		devise_l++;
		if (devise_l>=MONEY_NBDEV) devise_l=0;
	}
	else if (v==-1) val/=10;
	else if (v==10) val=0;
	else if (val<100000) val=val*10+v;

	updateval();
}

void icbconvmoneykey(int key,void* user,void* user2)
{
	((Interf_convmoney*)user)->cbkey(key);
}

void icbbdev_h(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convmoney*)user)->cbkey(-2);
}

void icbbdev_l(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convmoney*)user)->cbkey(-3);
}

#define MONEY_X0 20
#define MONEY_DX	76
#define MONEY_Y0	130
#define MONEY_DY	(32+8)



void Interf_convmoney::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_convmoney_title"));

	Ctr_keybd_create(container,back,MONEY_X0,MONEY_Y0,KEYBD_NUMERICAL,icbconvmoneykey,this,NULL);

	affich_h=Ctr_text_create(container,back,MONEY_X0,40+4,142,24,"0",COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_h->backupdate("interf/skin/txt_fond_142.r");
	affich_l=Ctr_text_create(container,back,MONEY_X0,80+4,142,24,"0",RGBTO16(87,192,45),-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_l->backupdate("interf/skin/txt_fond_142.r");

	Bitmap* moneygif=rscGet("interf/keybd/money.r");
	bdev_h=Ctr_button_create(container,back,MONEY_X0+2*MONEY_DX,40,44,32,1);
	bdev_h->setsrcbmp(0,moneygif,-1,0);
	bdev_h->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_h->setmask(0,1);
	bdev_h->setcb(icbbdev_h,(void*)this,NULL);
	bdev_l=Ctr_button_create(container,back,MONEY_X0+2*MONEY_DX,80,44,32,1);
	bdev_l->setsrcbmp(0,rscUseit(moneygif),-1,0);
	bdev_l->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_l->setmask(0,1);
	bdev_l->setcb(icbbdev_l,(void*)this,NULL);

	updateval();

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbconvmoneyclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_convmoney::unload()
{
	if (!loaded) return;
//	PRINTF("unload convmoney\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}


void Interf_convmoney::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

	val=0;
	updateval();
}

void Interf_convmoney::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_convmoney::clic(int x,int y)
{
	return NULL;
}
void Interf_convmoney::unclic(int x,int y)
{
}

void Interf_convmoney::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_convmoney* Interf_convmoney_create(Container *c,Control* f)
{
	return new Interf_convmoney(c,f);
}

