//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_convtemper::Interf_convtemper(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	val=0;
	devise_h=0;
	devise_l=1;
}

Interf_convtemper::~Interf_convtemper()
{
	hide();
	unload();
	link(NULL);
}

void icbconvtemperclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_CONVTEMPER,0);
}

void Interf_convtemper::updateval()
{
	char buffer[32];
	sprintf(buffer,"%d",val);
	affich_h->textupdate(buffer);

	float x=(float)val;
	if (devise_h==0) x=(x*9)/5+32;
	else x=((x-32)*5)/9;


	sprintf(buffer,"%.1f",x);
	affich_l->textupdate(buffer);

	bdev_h->movesrcbmp(0,0,32*devise_h);
	bdev_l->movesrcbmp(0,0,32*devise_l);
}

void Interf_convtemper::cbkey(int v)
{
	if ((v==-2)||(v==-3))
	{
		devise_h=1-devise_h;
		devise_l=1-devise_l;
	}
	else if (v==-1) val/=10;
	else if (v==10) val=0;
	else if (val<100000) val=val*10+v;

	updateval();
}

void icbconvtemperkey(int key,void* user,void* user2)
{
	((Interf_convtemper*)user)->cbkey(key);
}

void icbconvtemperbdev_h(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convtemper*)user)->cbkey(-2);
}

void icbconvtemperbdev_l(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_convtemper*)user)->cbkey(-3);
}

#define TEMPER_X0 20
#define TEMPER_DX	76
#define TEMPER_Y0	130
#define TEMPER_DY	(32+8)



void Interf_convtemper::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_convtemper_title"));

	Ctr_keybd_create(container,back,TEMPER_X0,TEMPER_Y0,KEYBD_NUMERICAL,icbconvtemperkey,this,NULL);

	affich_h=Ctr_text_create(container,back,TEMPER_X0,40+4,142,24,"0",COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_h->backupdate("interf/skin/txt_fond_142.r");
	affich_l=Ctr_text_create(container,back,TEMPER_X0,80+4,142,24,"0",RGBTO16(87,192,45),-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich_l->backupdate("interf/skin/txt_fond_142.r");

	Bitmap* tempergif=rscGet("interf/keybd/temper.r");
	bdev_h=Ctr_button_create(container,back,TEMPER_X0+2*TEMPER_DX,40,44,32,1);
	bdev_h->setsrcbmp(0,tempergif,-1,0);
	bdev_h->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_h->setmask(0,1);
	bdev_h->setcb(icbconvtemperbdev_h,(void*)this,NULL);
	bdev_l=Ctr_button_create(container,back,TEMPER_X0+2*TEMPER_DX,80,44,32,1);
	bdev_l->setsrcbmp(0,rscUseit(tempergif),-1,0);
	bdev_l->setlayer(0,0,0,0,0,LAYER_BLIT);
	bdev_l->setmask(0,1);
	bdev_l->setcb(icbconvtemperbdev_l,(void*)this,NULL);

	updateval();

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbconvtemperclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_convtemper::unload()
{
	if (!loaded) return;
//	PRINTF("unload convtemper\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}


void Interf_convtemper::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

	val=0;
	updateval();
}

void Interf_convtemper::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_convtemper::clic(int x,int y)
{
	return NULL;
}
void Interf_convtemper::unclic(int x,int y)
{
}

void Interf_convtemper::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_convtemper* Interf_convtemper_create(Container *c,Control* f)
{
	return new Interf_convtemper(c,f);
}

