//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "hash.h"
#include "file.h"

#include "raw/raw.h"

#define DELTADIAPO 8

Interf_diapo::Interf_diapo(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	paris=rscGet("interf/diapo/paris.r");
	pellicule=rscGet("interf/diapo/pellicule_fond.r");
	icon=rscGet("interf/diapo/pict_photo.r");
	currentpoi=NULL;
	autoscroll=0;
}

Interf_diapo::~Interf_diapo()
{
	hide();
	unload();
	link(NULL);
}

void icbdiapoclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_DIAPO,0);
}


void Interf_diapo::cbpoi()
{
	if (currentpoi)
	{
		interfActive(ITF_DIAPO,0);
		ipoi->poigo(currentpoi,ITF_DIAPO,(void*)crit,(void*)(index+1));
	}
}


void icbdiapopoi(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{

	if (state==CBBUTTON_UP) ((Interf_diapo*)user)->cbpoi();
}




#define DIAPO_X0 (((240-2*2)-44*4)/5)
#define DIAPO_DX	(44+DIAPO_X0)
#define DIAPO_DY	(32+8)
#define DIAPO_Y0	310-DIAPO_DY



void Interf_diapo::cbkey(int v)
{
	PRINTF("cbkey %d\n",v);
	if (v>0)
	{
		if (!pics[2])
		{
			if (!autoscroll)return;
			autoscroll=-autoscroll;
			cbkey(autoscroll);
			return;
		}
		scroll=0;
		anim=((pics[1]->width+pics[2]->width)>>1)+DELTADIAPO;
//		PRINTF("anim=%d\n",anim);
	}
	else if (v<0)
	{
		if (!pics[0])
		{
			if (!autoscroll)return;
			autoscroll=-autoscroll;
			cbkey(autoscroll);
			return;
		}
		rscUnuseit(pics[3]);
		for(int i=3;i>0;i--) pics[i]=pics[i-1];
		pics[0]=NULL;
		index--;
		loadpic(0);
		anim=-(((pics[1]->width+pics[2]->width)>>1)+DELTADIAPO);
		scroll=-anim;
//		PRINTF("anim=%d\n",anim);
	}
}

void icbdiapokey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_diapo*)user)->cbkey((int)user2);
}

Bitmap* Interf_diapo::loadpoipic(Poi* p) 
{
	char buffer[256];
	char* pp;
#ifdef HASHFILE
	pp=poilist->getname(p);
	sprintf(buffer,"poi_/%02d/%s",fileHash(pp,HASHFILE),pp);
#else
	sprintf(buffer,"poi/%s",poilist->getname(p));
#endif
	Hash* poidata=new Hash(16);
	poidata->load(buffer,POICRYPT);

	for(int i=0;i<10;i++)
	{
		char p[128];
		sprintf(p,"Photo%d",i+1);
		char *q=poidata->get(p);
		strcpy(p,q);
		forceraw(p);
#ifdef HASHFILE
		sprintf(buffer,"pics_/%02d/%s",fileHash(p,HASHFILE),p);
#else
		sprintf(buffer,"pics/%s",p);
#endif
		Bitmap* picbmp=rscGet(buffer);
		if (picbmp)
		{
			delete poidata;
			return picbmp;
		}
	}
	delete poidata;
	return NULL;
}

void Interf_diapo::loadpic(int i)
{
	int j=index+i;

	PRINTF("##nbsorted = %d\n",poilist->nbsorted());
	if (pics[i]) rscUnuseit(pics[i]);
	pics[i]=NULL;

	Poi* p=poilist->nthsorted(j);
	if (!p) return;

	pics[i]=loadpoipic(p);
	PRINTF("%d:load %s\n",i,poilist->getdesclocal(p));
}

int calcheight(int hdiap,int hfilm,int mn)
{
	int h=(hfilm-hdiap)>>1;
	if (h<mn) h=mn;
	return h;
}
void Interf_diapo::drawfilm()
{

	if (pellicule) film->blit(0,0,pellicule,0,0,film->width,film->height,-1);
	else film->empty(0);
	if (!pics[1]) return;
	int x0=((diapo->ws-pics[1]->width)>>1)-scroll;

	if (pics[0]) film->blit(x0-pics[0]->width-DELTADIAPO,calcheight(pics[0]->height,film->height,10),pics[0],0,0,pics[0]->width,pics[0]->height,-1);
	for(int i=1;i<4;i++)
	{
		if (!pics[i]) return;
		film->blit(x0,calcheight(pics[i]->height,film->height,10),pics[i],0,0,pics[i]->width,pics[i]->height,-1);
		x0+=DELTADIAPO+pics[i]->width;
	}
}

void Interf_diapo::drawpoimenu()
{
	if (poi) poi->link(NULL);
	if (poi) delete poi;
	poi=NULL;

	Poi* p=poilist->nthsorted(index+1);
	currentpoi=p;

	back->backempty();
	Bitmap *bmp=back->getback();

	if (paris) bmp->blit(70,250,paris,0,0,paris->width,paris->height,0x1f);
	int px=poilist->getpoix(p);
	int py=poilist->getpoiy(p);

	char* subtitle=poilist->getdesclocalized(p);
	bmp->drawtextboxEx(0,198,bmp->width,30,ALIGN_CENTER|ALIGN_VCENTER,subtitle,strlen(subtitle),(short)RGBTO16(255,128,0),(short)BACKCOL,font_subtitle,font_normal);

	char buf[16];
	sprintf(buf,"loc_C%d",crit+1);
	char* title=ilang->loc(buf);
	bmp->drawtextboxEx(30,5,162,19,ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(128,128,128),(short)BACKCOL,font_title,font_subtitle);
	bmp->blit(0,0,icon,0,0,28,28,0x1f);

	cross->setpos(px*61/8000+70+8,py*49/8000+254+8);

	prev->enable(pics[0]?1:0);
	next->enable(pics[2]?1:0);
}


void Interf_diapo::cblist()
{
	interfActive(ITF_DIAPO,0);
	interfActive(ITF_SEARCH,1);
	isearch->setpage(crit+1,0);
}

void icbdiapolist(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_diapo*)user)->cblist();
}


void Interf_diapo::setcrit(int c,int ind)
{
	int i;
	crit=c;
	poilist->setcrit(crit,0);
/*	int n=poilist->getnpoi();
	for(int i=0;i<n;i++)
	{
		int s=poilist->score(i,crit);
		poilist->setscore(poilist->getnth(i),s);
	}
	poilist->sort();
*/	imap->updatepoi();
	isimple->redrawbar();
	interfActive(ITF_SIMPLE,1);


	index=ind-1;
	for(i=0;i<4;i++)
	{
		loadpic(i);
	}
	scroll=anim=0;
	drawfilm();
	drawpoimenu();
	if (autoscroll) cbkey(autoscroll);
}

void Interf_diapo::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	film=new Bitmap(back->ws-2,166);

	diapo=Ctr_button_create(container,(Control*)back,1,40,film->width,film->height,1);
	diapo->setsrcbmp(0,film,-1,0);
	diapo->setlayer(0,0,0,0,0,LAYER_BLIT);
	diapo->setmask(0,1);
	
	cross=Ctr_button_create(container,(Control*)back,0,0,13,13,1);
	cross->setoff(6,6);
	cross->setsrcbmp(0,rscGet("interf/diapo/localisation.r"),0x1f,0);
	cross->setlayer(0,0,0,0,0,LAYER_BLIT);
	cross->setmask(0,1);


	for(int i=0;i<4;i++) pics[i]=NULL;

	prev=Ctr_push_create(container,(Control*)back,10,162,26,26,"interf/nav/scroll_left.r",icbdiapokey,this,(void*)-1,0x109e);
	next=Ctr_push_create(container,(Control*)back,back->ws-10-26,162,26,26,"interf/nav/scroll_right.r",icbdiapokey,this,(void*)1,0x109e);
	poi=Ctr_push_create(container,(Control*)back,96,236,42,18,"interf/diapo/bout_info+.r",icbdiapopoi,this,(void*)NULL,0x109e);

	Ctr_push_create(container,back,DIAPO_X0+3*DIAPO_DX,DIAPO_Y0-4,36,36,
		(ilang->getlang()==LANG_JP)?"interf/diapo/bout_list_jp.r":"interf/diapo/bout_list.r",
		icbdiapolist,this,(void*)NULL,0x87f);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbdiapoclose,this,NULL,0x1f);
	poi=NULL;

	autoscroll=0;

	loaded=1;
}

void Interf_diapo::setautoscroll()
{
	autoscroll=1;
}

void Interf_diapo::unload()
{
	if (!loaded) return;
//	PRINTF("unload diapo %d\n",loaded);
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
//	PRINTF("end unload diapo %d\n",loaded);
}


void Interf_diapo::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;
}

void Interf_diapo::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_diapo::clic(int x,int y)
{
	return NULL;
}
void Interf_diapo::unclic(int x,int y)
{
}

void Interf_diapo::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
	if (anim)
	{
		if (anim>0)
		{
			if (autoscroll) scroll++;
			else scroll+=20;
			if (scroll>=anim)
			{
				anim=0;
				scroll=0;
				rscUnuseit(pics[0]);
				for(int i=0;i<3;i++) pics[i]=pics[i+1];
				pics[3]=NULL;
				index++;
				loadpic(3);
				drawpoimenu();
				cbkey(autoscroll);
			}
		}
		else
		{
			if (autoscroll) scroll--;
			else scroll-=20;
			if (scroll<0)
			{
				scroll=0;
				anim=0;
				drawpoimenu();
				cbkey(autoscroll);
			}
		}
		drawfilm();
	}
}

Interf_diapo* Interf_diapo_create(Container *c,Control* f)
{
	return new Interf_diapo(c,f);
}

