//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "dico.h"



Interf_dico::Interf_dico(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	dico=NULL;
}

Interf_dico::~Interf_dico()
{
	hide();
	unload();
	link(NULL);
	if (dico) delete dico;
}

void Interf_dico::resetdisplay()
{
	strcpy(inp,"");
	updatedisplay();
}

void Interf_dico::cbchoice(int val)
{
	char* p=dico->getenr(val);
	interfActive(ITF_DICORESULT,1);
	idicoresult->resultset(p);
}

void icbdicosel(Listitem *b,void* user,void* user2)
{
	((Interf_dico*)user)->cbchoice((int)user2);
}

void Interf_dico::updatedisplay()
{
	int i0=0;
	int len=strlen(inp);
	i0=dico->getindex(inp);
	affich->textupdate(len?inp:"_");

	list->empty();

	if (i0>=0)
	{
		int n=i0+50;
		int ndico=dico->getndico();
		if (n>ndico) n=ndico;
		for(int i=i0;i<n;i++)
		{
			Listitem* li=list->getnextitem();
			li->setname(dico->getenr(i));
			li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
			li->setfont(font_key);
			li->setbutton("interf/skin/b2.r");
			li->setstyle(LITEM_TEXT|LITEM_BUTTON);
			li->setcb(icbdicosel,(void*)this,(void*)i);
		}
	}

	list->setscroll(0);
	up->enable(list->mayscroll(-1));
	down->enable(list->mayscroll(1));
}


void icbdicoclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_DICO,0);
}

void Interf_dico::cbkey(int val)
{
	int len=strlen(inp);
	if ((val==-2)||(val==-3))
	{
		list->scroll(val==-3?4:-4);
//		pgbackscroll[pgbackindex-1]=list->getscroll();
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if ((val>=0)&&(val<=26)&&(len<DICO_MAX-1))
	{
		if ((len)||(val!=26))
		{
			len++;
			inp[len-1]=(val==26)?32:val+'a';
			inp[len]=0;
			updatedisplay();
		}
	}
	else if ((val>=28)&&(val<=255)&&(len<INDEX_MAX-1))
	{
		len++;
		inp[len-1]=val;
		inp[len]=0;
		updatedisplay();
	}
	else if (val==27)
	{
		if (len>0)
		{
			if ((len>4)&&(inp[len-5]=='\\')) len-=5;
			else len--;
		}
		inp[len]=0;
		updatedisplay();
	}
	else if ((val>10000)&&(len<DICO_MAX-5))
	{
		inp[len++]='\\';
		sprintf(inp+len,"%04x",val);
		updatedisplay();
	}
	PRINTF("text : %s\n",inp);

}

void icbdicoscroll(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_dico*)user)->cbkey((int)user2);
}

void icbdicokey(int key,void* user,void* user2)
{
	((Interf_dico*)user)->cbkey(key);
}

#define DICO_X0 20
#define DICO_DX	76
#define DICO_Y0	208
#define DICO_DY	(32+2)



void Interf_dico::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_dico_title"));

	list=Ctr_list_create(container,(Control*)back,8,36,186,128,32);
	up=Ctr_push_create(container,back,8+186+2,36,32,32,"interf/nav/up.r",icbdicoscroll,this,(void*)-2,0x1f);
	down=Ctr_push_create(container,back,8+186+2,36+128-32,32,32,"interf/nav/down.r",icbdicoscroll,this,(void*)-3,0x1f);

	Ctr_keybd_create(container,back,9,DICO_Y0,keybd,icbdicokey,this,NULL);

	affich=Ctr_text_create(container,back,DICO_X0+0*DICO_DX,DICO_Y0-DICO_DY+4,185,24,inp,COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich->backupdate("interf/skin/txt_fond_185.r");


	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbdicoclose,this,NULL,0x1f);

	loaded=1;
}


void Interf_dico::selectdico(char* filename)
{
	if (dico) delete dico;
	dico=new Dico();
	dico->load(filename);
	keybd=KEYBD_ALPHA;
	if(!strcmp(filename,"dico/japonais-fr.dic")) keybd=KEYBD_JAPANESE;
}

void Interf_dico::unload()
{
	if (!loaded) return;

//	PRINTF("unload dico\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_dico::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	resetdisplay();
	hiding=0;

}

void Interf_dico::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_dico::clic(int x,int y)
{
	return NULL;
}
void Interf_dico::unclic(int x,int y)
{
}

void Interf_dico::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_dico* Interf_dico_create(Container *c,Control* f)
{
	return new Interf_dico(c,f);
}


