//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_dicolist::Interf_dicolist(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_dicolist::~Interf_dicolist()
{
	hide();
	unload();
	link(NULL);
}


void icbdicolistclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_DICOLIST,0);
}

void icbdicolistsel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		idico->selectdico((char*)user2);
		interfActive(ITF_DICO,1);
	}
}


void Interf_dicolist::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_dicolist_title"));

	Ctr_push_create(container,back,8,40,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_fr_en"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/french-english.dic");
	Ctr_push_create(container,back,8,80,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_en_fr"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/english-french.dic");
	Ctr_push_create(container,back,8,120,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_fr_sp"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/french-spanish.dic");
	Ctr_push_create(container,back,8,160,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_sp_fr"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/spanish-french.dic");
	Ctr_push_create(container,back,8,200,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_fr_jp"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/fr-japonais.dic");
	Ctr_push_create(container,back,8,240,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_dicolist_jp_fr"),font_subtitle,2),icbdicolistsel,this,(void*)"dico/japonais-fr.dic");

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbdicolistclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_dicolist::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_dicolist::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_dicolist::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_dicolist::clic(int x,int y)
{
	return NULL;
}
void Interf_dicolist::unclic(int x,int y)
{
}

void Interf_dicolist::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_dicolist* Interf_dicolist_create(Container *c,Control* f)
{
	return new Interf_dicolist(c,f);
}

