//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "dico.h"


Interf_dicoresult::Interf_dicoresult(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_dicoresult::~Interf_dicoresult()
{
	hide();
	unload();
	link(NULL);
}

void Interf_dicoresult::resultset(char* p)
{
	src->textupdate(p);
	trad->textupdate(p+strlen(p)+1);
}

void icbdicoresultclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_DICORESULT,0);
}


void Interf_dicoresult::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_dicoresult_title"));

	src=Ctr_text_create(container,back,16,40,204,80,"",COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	src->backupdate("interf/skin/txt_fond_204_80.r");
	trad=Ctr_text_create(container,back,16,130,204,150,"",RGBTO16(87,192,45),-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	trad->backupdate("interf/skin/txt_fond_204_150.r");

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbdicoresultclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_dicoresult::unload()
{
	if (!loaded) return;

//	PRINTF("unload dicoresult\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_dicoresult::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_dicoresult::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_dicoresult::clic(int x,int y)
{
	return NULL;
}
void Interf_dicoresult::unclic(int x,int y)
{
}

void Interf_dicoresult::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_dicoresult* Interf_dicoresult_create(Container *c,Control* f)
{
	return new Interf_dicoresult(c,f);
}

