//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_i::Interf_i(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_i::~Interf_i()
{
	hide();
	unload();
	link(NULL);
}


void icbilang(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_LANG,1);
	}
}

void icbihelp(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		iseq->getseq(ilang->loc("loc_aide_seq"));
		interfActive(ITF_SEQ,1);
	}
}

void icbihotel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		Poi* poi=poilist->getstart();
		if (poi)
		{
			ipoi->poigo(poi,-1,NULL,NULL);
		}
	}
}

void icbiguide(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I2,1);
	}
}

void icbimap(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I,0);
	}
}

void icbidiapo(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_DIAPO,1);
//		idiapo->setautoscroll();
		idiapo->setcrit(44,0);
	}
}

void icbipanier(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_PANIER,1);
	}
}

#define I_Y0	(40)
#define I_DY	(32+4)


void Interf_i::load()
{
	if (loaded) return;

	Bitmap* fond=rscGet("interf/accueil/fond.r");
	back=Ctr_button_create(container,this,1,1,238,316,1);
	back->setsrcbmp(0,fond,0x1f,0);
	back->setlayer(0,0,0,0,0,LAYER_BLIT);
	back->setmask(0,1);

	Ctr_button* logo=Ctr_button_create(container,back,100,10,38,38,1);
	logo->setsrcbmp(0,rscGet("interf/accueil/logo.r"),0x1f,0);
	logo->setlayer(0,0,0,0,0,LAYER_BLIT);
	logo->setmask(0,1);

	Ctr_button* blang=Ctr_button_create(container,back,97,266,44,30,1);
	blang->setsrcbmp(0,rscGet("interf/accueil/bout_langue.r"),0x1f,0);
	blang->setlayer(0,0,0,0,0,LAYER_BLIT);
	blang->setmask(0,1);
	blang->movesrcbmp(0,0,30*ilang->getlang());
	blang->setcb(icbilang,(void*)this,NULL);

	Ctr_push_create(container,back,26,63,87,87,ilang->loc("loc_i_diapo"),icbidiapo,this,(void*)NULL,0x1f);
	Ctr_push_create(container,back,127,63,87,87,ilang->loc("loc_i_map"),icbimap,this,(void*)NULL,0x1f);
	Ctr_push_create(container,back,26,164,87,87,ilang->loc("loc_i_guide"),icbiguide,this,(void*)NULL,0x1f);
	Ctr_push_create(container,back,127,164,87,87,ilang->loc("loc_i_hotel"),icbihotel,this,(void*)NULL,0x1f);
	Ctr_push_create(container,back,20,266,44,30,"interf/accueil/bt_aide.r",icbihelp,this,(void*)NULL,0x1f);
	Ctr_push_create(container,back,174,266,44,30,"interf/accueil/bout_fav.r",icbipanier,this,(void*)NULL,0x1f);
	
	char* p=ilang->loc("loc_i_help");
	fond->drawtextbox(20-10,296,44+20,20,ALIGN_CENTER,p,strlen(p),RGBTO16(0x80,0x80,0x80),-1,font_normal);
	p=ilang->loc("loc_i_lang");
	fond->drawtextbox(97-10,296,44+20,20,ALIGN_CENTER,p,strlen(p),RGBTO16(0x80,0x80,0x80),-1,font_normal);
	p=ilang->loc("loc_i_fav");
	fond->drawtextbox(174-10,296,44+20,20,ALIGN_CENTER,p,strlen(p),RGBTO16(0x80,0x80,0x80),-1,font_normal);

	loaded=1;
}

void Interf_i::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_i::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_i::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_i::clic(int x,int y)
{
	return NULL;
}
void Interf_i::unclic(int x,int y)
{
}

void Interf_i::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_i* Interf_i_create(Container *c,Control* f)
{
	return new Interf_i(c,f);
}

