//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_i2::Interf_i2(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_i2::~Interf_i2()
{
	hide();
	unload();
	link(NULL);
}


void icbi2close(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_I2,0);
}


void icbi2index(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I2,0);
		interfActive(ITF_INDEX,1);
	}
}


void icbi2theme(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I2,0);
		interfActive(ITF_SEARCH,1);
	}
}

void icbi2panier(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I2,0);
		interfActive(ITF_PANIER,1);
	}
}

void icbi2tools(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I2,0);
		interfActive(ITF_TOOLS,1);
	}
}



#define I2_Y0	(40+12)
#define I2_DY	(32+12)


void Interf_i2::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_i2_title"));

	Ctr_push_create(container,back,8,I2_Y0+0*I2_DY,219,32,rscButton("interf/skin/bout_guide.r",54,ilang->loc("loc_i2_bythema"),font_subtitle,3),icbi2theme,this,(void*)NULL,0x109e);
	Ctr_push_create(container,back,8,I2_Y0+1*I2_DY,219,32,rscButton("interf/skin/bout_index.r",54,ilang->loc("loc_i2_byname"),font_subtitle,3),icbi2index,this,(void*)NULL,0x109e);
	Ctr_push_create(container,back,8,I2_Y0+2*I2_DY,219,32,rscButton("interf/skin/bout_outils.r",54,ilang->loc("loc_i2_tools"),font_subtitle,3),icbi2tools,this,(void*)NULL,0x109e);
	Ctr_push_create(container,back,8,I2_Y0+3*I2_DY,219,32,rscButton("interf/skin/bout_favoris.r",54,ilang->loc("loc_i2_panier"),font_subtitle,3),icbi2panier,this,(void*)NULL,0x109e);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbi2close,this,NULL,0x1f);


	loaded=1;
}

void Interf_i2::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_i2::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_i2::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_i2::clic(int x,int y)
{
	return NULL;
}
void Interf_i2::unclic(int x,int y)
{
}

void Interf_i2::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_i2* Interf_i2_create(Container *c,Control* f)
{
	return new Interf_i2(c,f);
}

