//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "poi.h"


Interf_index::Interf_index(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_index::~Interf_index()
{
	hide();
	unload();
	link(NULL);
}

void Interf_index::resetdisplay()
{
	strcpy(inp,"");
	updatedisplay();
}

void Interf_index::cbchoice(Poi* poi)
{
	if (!poi) return;

	poilist->setpoi(poi->num);

	imap->updatepoi();
	isimple->redrawbar();
	interfActive(ITF_SIMPLE,1);

	ipoi->poigo(poi,-1,NULL,NULL);
	interfActive(ITF_INDEX,0);
}

void icbindexsel(Listitem *b,void* user,void* user2)
{
	((Interf_index*)user)->cbchoice((Poi*)user2);
}

void Interf_index::updatedisplay()
{
	int n=0;
	int len=strlen(inp);
	char buf[256];
	spaceremove(buf,inp);
	n=poilist->select(buf);
	affich->textupdate(len?inp:"_");

	list->empty();

	if ((n==0)||(n>50))
	{
		Listitem* li=list->getnextitem();
		li->setname(ilang->loc(n?"loc_index_full":"loc_index_empty"));
		li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
		li->setfont(font_normal);
		li->setstyle(LITEM_TEXT);
	}
	else if (n<=50)
	{
		int npoi=poilist->getnpoi();
		for(int i=0;i<npoi;i++)
		{
			Poi* p=poilist->getnth(i);
			if (p->select)
			{
				Listitem* li=list->getnextitem();
				printf("%s select=%d\n",poilist->getdescn(p,p->select),p->select);
				printf("->%s, %s\n",poilist->getdesclocal(p),poilist->getdesclocalized(p));
				li->setname(poilist->getdescn(p,p->select));
				li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
				li->setfont(font_normal);
				li->setbutton("interf/skin/b2.r");
				li->setstyle(LITEM_TEXT|LITEM_BUTTON);
				li->setcb(icbindexsel,(void*)this,(void*)p);
			}
		}
	}


	list->sortname(-1);
	list->setscroll(0);
	up->enable(list->mayscroll(-1));
	down->enable(list->mayscroll(1));
}


void icbindexclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_INDEX,0);
}

void Interf_index::cbkey(int val)
{
	int len=strlen(inp);
	if ((val==-2)||(val==-3))
	{
		list->scroll(val==-3?4:-4);
//		pgbackscroll[pgbackindex-1]=list->getscroll();
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if ((val>=0)&&(val<=26)&&(len<INDEX_MAX-1))
	{
		if ((len)||(val!=26))
		{
			len++;
			inp[len-1]=(val==26)?32:val+'a';
			inp[len]=0;
			updatedisplay();
		}
	}
	else if ((val>=28)&&(val<=255)&&(len<INDEX_MAX-1))
	{
		len++;
		inp[len-1]=val;
		inp[len]=0;
		updatedisplay();
	}
	else if (val==27)
	{
		if (len>0)
		{
			if ((len>4)&&(inp[len-5]=='\\')) len-=5;
			else len--;
		}
		inp[len]=0;
		updatedisplay();
	}
	else if ((val>10000)&&(len<INDEX_MAX-5))
	{
		inp[len++]='\\';
		sprintf(inp+len,"%04x",val);
		updatedisplay();
	}
	PRINTF("text : %s\n",inp);

}

void icbindexscroll(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_index*)user)->cbkey((int)user2);
}

void icbindexkey(int key,void* user,void* user2)
{
	((Interf_index*)user)->cbkey(key);
}

#define INDEX_X0 20
#define INDEX_DX	76
#define INDEX_Y0	208
#define INDEX_DY	(32+2)



void Interf_index::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_index_title"));

	list=Ctr_list_create(container,(Control*)back,8,36,186,128,32);
	up=Ctr_push_create(container,back,8+186+2,36,32,32,"interf/nav/up.r",icbindexscroll,this,(void*)-2,0x1f);
	down=Ctr_push_create(container,back,8+186+2,36+128-32,32,32,"interf/nav/down.r",icbindexscroll,this,(void*)-3,0x1f);

	Ctr_keybd_create(container,back,9,INDEX_Y0,(ilang->getlang()==LANG_JP)?KEYBD_JAPANESE:KEYBD_ALPHA,icbindexkey,this,NULL);

	affich=Ctr_text_create(container,back,INDEX_X0+0*INDEX_DX,INDEX_Y0-INDEX_DY+4,142,24,inp,COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich->backupdate("interf/skin/txt_fond_142.r");
	Ctr_push_create(container,back,INDEX_X0+144,INDEX_Y0-INDEX_DY+4,142,24,"interf/keybd/effacer.r",icbindexscroll,this,(void*)27,0x1f);


	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbindexclose,this,NULL,0x1f);

	loaded=1;
}


void Interf_index::unload()
{
	if (!loaded) return;

//	PRINTF("unload index\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_index::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	resetdisplay();
	hiding=0;

}

void Interf_index::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_index::clic(int x,int y)
{
	return NULL;
}
void Interf_index::unclic(int x,int y)
{
}

void Interf_index::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_index* Interf_index_create(Container *c,Control* f)
{
	return new Interf_index(c,f);
}

