//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "metro.h"

Interf_iti::Interf_iti(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	xo=yo=xd=yd=0;
}

Interf_iti::~Interf_iti()
{
	hide();
	unload();
	link(NULL);
}

void Interf_iti::update()
{
	int n=metro->solve(xo,yo,xd,yd);
	imap->lines->setnpixels(n+1);
	imap->lines->setnthpix(0,xo,yo,0);
	int ll=-1;
	for(int i=0;i<n-1;i++)
	{
		int q=metro->getnthquai(i);
		int s=metro->stationfromquai(q);
		int l=metro->lignefromquai(q);
		imap->lines->setnthpix(i+1,metro->getstationx(s),metro->getstationy(s),(l!=ll)?0:
		metro->getlinecolor(l));
		ll=l;
	}
	imap->lines->setnthpix(n,xd,yd,0);
	imap->lines->setenable(1);
}

void Interf_iti::setorg(int x,int y)
{
	xo=x;
	yo=y;
}
void Interf_iti::setdst(int x,int y)
{
	xd=x;
	yd=y;
}


void icbdetail(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_ITILIST,1);
		iitilist->drawiti();
	}
}


void Interf_iti::load()
{
	if (loaded) return;

	detail=Ctr_push_create(container,this,0,80,44,32,rscGet("interf/bout_metro.r"),icbdetail,this,(void*)NULL,0x87f);
	loaded=1;
}

void Interf_iti::unload()
{
	if (!loaded) return;

//##	loaded=0;
}

void Interf_iti::show()
{
	if (!loaded) load();

	detail->setpos(-48,80);
	detail->move(4,0,12);
	setenable(1);
}

void Interf_iti::hide()
{
//	if (!loaded) unload();
//	setenable(0);
	detail->setpos(0,80);
	detail->move(-4,0,12);
}

Control* Interf_iti::clic(int x,int y)
{
	return NULL;
}
void Interf_iti::unclic(int x,int y)
{
}

void Interf_iti::draw(Bitmap *bmp,int dx,int dy)
{

}

Interf_iti* Interf_iti_create(Container *c,Control* f)
{
	return new Interf_iti(c,f);
}

