//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "metro.h"


Interf_itilist::Interf_itilist(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_itilist::~Interf_itilist()
{
	hide();
	unload();
	link(NULL);
}

void icbitilistclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_ITILIST,0);
}


void Interf_itilist::select(int station)
{
	back->setalpha(150);
	imap->moveto(metro->getstationx(station),metro->getstationy(station),1);
}

void icbitiliststation(Listitem* i,void* user,void* user2)
{
	((Interf_itilist*)user)->select((int)user2);
}

void Interf_itilist::drawiti()
{
	int i;
	back->setalpha(230);
	back->backempty();
	back->drawtitle(ilang->loc("loc_itilist_title"));

	list->empty();

	int n=metro->getnsteps();
	PRINTF("nmetro=%d\n",n);

	if (metro->gettime()<0)
	{
		Listitem* li=list->getnextitem();
		li->setname(ilang->loc("loc_itilist_none"));
		li->setfont(font_normal);
		li->settext(30,ALIGN_LEFT+ALIGN_VCENTER,COL_TITLE);
		li->setstyle(LITEM_TEXT);
	}
	else
	{

		Listitem* li=list->getnextitem();
		char* nm=ilang->loc("loc_itilist_time");
		char buffer[128];
		sprintf(buffer,nm,metro->gettime());
		li->setname(buffer);
		li->setfont(font_normal);
		li->settext(30,ALIGN_LEFT+ALIGN_VCENTER,COL_TITLE);
		li->setstyle(LITEM_TEXT);

		int ll=-1;
		int ls=-1;
		for(i=0;i<n-1;i++)
		{
			int q=metro->getnthquai(i);
			int s=metro->stationfromquai(q);
			int l=metro->lignefromquai(q);
			if ((l!=ll)||(i==n-2))
			{
				li=list->getnextitem();
				char* nm=ilang->loc("loc_itilist_descendre");
				if (ls==-1) nm=ilang->loc("loc_itilist_marcher");
				li->setname(nm);
				li->setfont(font_normal);
				li->settext(30,ALIGN_LEFT+ALIGN_VCENTER,COL_TITLE);
				li->setstyle(LITEM_TEXT);

				li=list->getnextitem();
				if ((ls==-1)||(i==n-2)) ls=s;
				char* n=metro->getstationname(ls);
				li->setname(n);
				li->setfont(font_underline);
				li->settext(30,ALIGN_CENTER,0);
				li->setstyle(LITEM_TEXT);
				li->setcb(icbitiliststation,(void*)this,(void*)ls);
			}
			if (l!=ll)
			{
				Listitem* li=list->getnextitem();
				li->setname(ilang->loc("loc_itilist_direction"));
				li->setfont(font_normal);
				li->settext(30,ALIGN_LEFT+ALIGN_VCENTER,COL_TITLE);
				li->setstyle(LITEM_TEXT);
				
				li=list->getnextitem();
				char* n=metro->getlignename(l);
				n=2+strstr(n,"-");
				li->setname(n);
				li->setfont(font_subtitle);
				li->settext(30,ALIGN_CENTER,COL_TITLE);
				li->seticon("interf/lignes.r");
				li->seticonpos(0,0,25*metro->getindligne(l),0,25,25);
				li->setstyle(LITEM_TEXT+LITEM_ICON);
				ll=l;
			}
			ls=s;
		}

		li=list->getnextitem();
		nm=ilang->loc("loc_itilist_finir");
		if (ls==-1) nm=ilang->loc("loc_itilist_toutmarcher");

		li->setname(nm);
		li->setfont(font_normal);
		li->settext(30,ALIGN_LEFT+ALIGN_VCENTER,COL_TITLE);
		li->setstyle(LITEM_TEXT);
	}
	list->scrollto(0);
	prev->enable(list->mayscroll(-1));
	next->enable(list->mayscroll(1));
}

void Interf_itilist::cbkey(int v)
{
	if (v==0)
	{
		imap->lines->setnpixels(0);
		interfActive(ITF_ITILIST,0);
		interfActive(ITF_ITI,0);
	}
	else
	{
		list->scroll(5*v);
		prev->enable(list->mayscroll(-1));
		next->enable(list->mayscroll(1));
	}
}

void icbitilistkey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_itilist*)user)->cbkey((int)user2);
}


#define ITILIST_X0 (((240-2*2)-44*3)/4)
#define ITILIST_DX	(44+ITILIST_X0)
#define ITILIST_DY	(32+8)
#define ITILIST_Y0	310-ITILIST_DY



void Interf_itilist::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	list=Ctr_list_create(container,(Control*)back,16,40,240-4-32,220,32);

	Ctr_push_create(container,back,ITILIST_X0+0*ITILIST_DX,ITILIST_Y0,44,32,"interf/nav/bout_corbeille.r",icbitilistkey,this,(void*)0,0x087f);

	prev=Ctr_push_create(container,back,ITILIST_X0+2*ITILIST_DX-32,ITILIST_Y0,32,32,"interf/nav/up.r",icbitilistkey,this,(void*)-1,0x1f);
	next=Ctr_push_create(container,back,ITILIST_X0+2*ITILIST_DX,ITILIST_Y0,32,32,"interf/nav/down.r",icbitilistkey,this,(void*)1,0x1f);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbitilistclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_itilist::unload()
{
	if (!loaded) return;
	interfActive(ITF_ITILIST,0);
//	PRINTF("unload itilist\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}


void Interf_itilist::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_itilist::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_itilist::clic(int x,int y)
{
	return NULL;
}
void Interf_itilist::unclic(int x,int y)
{
}

void Interf_itilist::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_itilist* Interf_itilist_create(Container *c,Control* f)
{
	return new Interf_itilist(c,f);
}

