//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "hash.h"
#include "gps.h"


const char* locfiles[]={"loc/fr.loc","loc/en.loc","loc/sp.loc","loc/jp.loc"};

Interf_lang::Interf_lang(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	locdata=NULL;
	lang=LANG_FR;
	loadlocfile();
}

Interf_lang::~Interf_lang()
{
	hide();
	unload();
	link(NULL);
	if (locdata) delete locdata;
}

void Interf_lang::loadlocfile()
{
	if (locdata) delete locdata;
	locdata=new Hash(256);
	locdata->load((char*)locfiles[lang]);
}

void icblangclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_LANG,0);
}

void Interf_lang::cbkey(int v)
{
	lang=v;

	PRINTF("#############change language\n");
	loadlocfile();
// notifier ici les diffrentes interfaces concernes par le changement de langue
	poilistReload();
	izoom->langupdate();
	imain->langupdate();
	interfActive(ITF_LANG,0);
	interfActive(ITF_I,0);
	ii->unload();
	interfActive(ITF_I,1);
	if(poilist->getstart())
	{
		gpsResetpos();
		imap->moveto(gps_x,gps_y,50);
	}
}

char* Interf_lang::loc(char *key)
{
	char *p=NULL;
	if (locdata) p=locdata->get(key);
	if (p==NULL) return "**NOLOC";
	return p;
}

void icblangkey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_lang*)user)->cbkey((int)user2);
}

void Interf_lang::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(loc("loc_lang_title"));

	Ctr_push_create(container,back,8,40,220,32,rscButton("interf/skin/b1.r",loc("loc_lang_french"),font_subtitle,2),icblangkey,this,(void*)LANG_FR);
	Ctr_push_create(container,back,8,80,220,32,rscButton("interf/skin/b1.r",loc("loc_lang_english"),font_subtitle,2),icblangkey,this,(void*)LANG_EN);
	Ctr_push_create(container,back,8,120,220,32,rscButton("interf/skin/b1.r",loc("loc_lang_spanish"),font_subtitle,2),icblangkey,this,(void*)LANG_SP);
	Ctr_push_create(container,back,8,160,220,32,rscButton("interf/skin/b1.r",loc("loc_lang_japanese"),font_subtitle,2),icblangkey,this,(void*)LANG_JP);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icblangclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_lang::unload()
{
	if (!loaded) return;

//	PRINTF("unload lang\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_lang::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_lang::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_lang::clic(int x,int y)
{
	return NULL;
}
void Interf_lang::unclic(int x,int y)
{
}

int Interf_lang::getlang()
{
	return lang;
}

void Interf_lang::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_lang* Interf_lang_create(Container *c,Control* f)
{
	return new Interf_lang(c,f);
}

