//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"

Interf_main::Interf_main(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	zoom=NULL;
	count=0;
}

Interf_main::~Interf_main()
{
	hide();
	unload();
	link(NULL);
}

void Interf_main::zoomit()
{
//	PRINTF("cbzoom\n");
	interfActive(ITF_ZOOM,1);
}

void icbzoom(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_main*)user)->zoomit();
}

void icbsimple(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		if (interfIsActive(ITF_SIMPLE)) interfActive(ITF_SIMPLE,0);
		else interfActive(ITF_SIMPLE,1);
	}
}


void icbgps(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) imap->gpssettrack(1);
}

void icbtxt(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_MODE,1);
	}
}

void icbhlp(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_I,1);
	}
}


void Interf_main::load()
{
	if (loaded) return;
	Bitmap* gpsgif=rscGet("interf/main/gps2.r");
	Bitmap* gpsgif_jp=rscGet("interf/main/gps2_jp.r");

	bar=Ctr_button_create(container,this,0,0,0,0,0);

	gps=Ctr_button_create(container,bar,48*2,320-32,48,32,2);
	gps->setsrcbmp(0,gpsgif,-1,0);
	gps->setsrcbmp(1,gpsgif_jp,-1,0);
	gps->setlayer(0,0,0,0,0,LAYER_BLIT);
	gps->setlayer(1,1,0,0,0,LAYER_BLIT);
	gps->setmask(0,1);
	gps->setmask(1,2);
	gps->setcb(icbgps,(void*)this,NULL);

	welcome=Ctr_push_create(container,bar,0,320-32,48,32,"interf/main/welcome.r",icbhlp,this,NULL);
	zoom=Ctr_push_create(container,bar,48,320-32,48,32,"interf/main/zoom2.r",icbzoom,this,NULL);

	search=Ctr_push_create(container,bar,48*3,320-32,48,32,"interf/main/search.r",icbtxt,this,NULL);
	select=Ctr_push_create(container,bar,48*4,320-32,48,32,"interf/main/select.r",icbsimple,this,NULL);

	loaded=1;
}

void Interf_main::langupdate()
{
	if (!loaded) return;
	welcome->bmpupdate((ilang->getlang()==LANG_JP)?"interf/main/welcome_jp.r":"interf/main/welcome.r");
	zoom->bmpupdate((ilang->getlang()==LANG_JP)?"interf/main/zoom2_jp.r":"interf/main/zoom2.r");
	search->bmpupdate((ilang->getlang()==LANG_JP)?"interf/main/search_jp.r":"interf/main/search.r");
	select->bmpupdate((ilang->getlang()==LANG_JP)?"interf/main/select_jp.r":"interf/main/select.r");
	gps->setstate((ilang->getlang()==LANG_JP)?1:0);
}


void Interf_main::unload()
{
	if (!loaded) return;

//##	loaded=0;
}


void Interf_main::show()
{
	if (!loaded) load();
	bar->setpos(0,36);
	bar->move(0,-4,9);
	setenable(1);
}

void Interf_main::hide()
{
//	if (!loaded) unload();
//	setenable(0);
	count=9;
	bar->setpos(0,0);
	bar->move(0,4,9);
}

Control* Interf_main::clic(int x,int y)
{
	return NULL;
}
void Interf_main::unclic(int x,int y)
{
}

void Interf_main::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	gps->movesrcbmp(0,0,32*imap->getgpsmode());
	gps->movesrcbmp(1,0,32*imap->getgpsmode());
//	gps->movesrcbmp(0,0,32*2);
//	gps->movesrcbmp(1,0,32*2);

	if (count)
	{
		if (!(--count))
		{
			setenable(0);

		}
	}
}

Interf_main* Interf_main_create(Container *c,Control* f)
{
	return new Interf_main(c,f);
}

