//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "metro.h"


Interf_metro::Interf_metro(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_metro::~Interf_metro()
{
	hide();
	unload();
	link(NULL);
}

void Interf_metro::resetdisplay()
{
	strcpy(inp,"");
	updatedisplay();
}

void Interf_metro::cbchoice(int station)
{

//	PRINTF("###move to %d,%d\n",metro->x,metro->y);
	PRINTF("Station %d\n",station);

	imap->setscale(1);
	imap->moveto(metro->getstationx(station),metro->getstationy(station),1);

	interfActive(ITF_I,0);
	interfActive(ITF_METRO,0);

}

void icbmetrosel(Listitem *b,void* user,void* user2)
{
	((Interf_metro*)user)->cbchoice((int)user2);
}

void Interf_metro::updatedisplay()
{
	int n=0;
	int len=strlen(inp);
	char buf[256];
	spaceremove(buf,inp);
	n=metro->select(buf);
	affich->textupdate(len?inp:"_");

	list->empty();

	if ((n==0)||(n>50))
	{
		Listitem* li=list->getnextitem();
		li->setname(ilang->loc(n?"loc_metro_full":"loc_metro_empty"));
		li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
		li->setfont(font_normal);
		li->setstyle(LITEM_TEXT);
	}
	else if (n<50)
	{
		int nmetro=metro->getnstations();
		for(int i=0;i<nmetro;i++)
		{
			if (metro->isselected(i))
			{
				Listitem* li=list->getnextitem();
				li->setname(metro->getstationname(i));
				li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
				li->setfont(font_normal);
				li->setbutton("interf/skin/b2.r");
				li->setstyle(LITEM_TEXT|LITEM_BUTTON);
				li->setcb(icbmetrosel,(void*)this,(void*)i);
			}
		}
	}


	list->sortname(-1);
	list->setscroll(0);
	up->enable(list->mayscroll(-1));
	down->enable(list->mayscroll(1));
}


void icbmetroclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_METRO,0);
}

void Interf_metro::cbkey(int val)
{
	int len=strlen(inp);
	if ((val==-2)||(val==-3))
	{
		list->scroll(val==-3?4:-4);
//		pgbackscroll[pgbackindex-1]=list->getscroll();
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if ((val>=0)&&(val<=26)&&(len<METRO_MAX-1))
	{
		if ((len)||(val!=26))
		{
			len++;
			inp[len-1]=(val==26)?32:val+'a';
			inp[len]=0;
			updatedisplay();
		}
	}
	else if (val==27)
	{
		if (len>0) len--;
		inp[len]=0;
		updatedisplay();
	}
//	PRINTF("text : %s\n",inp);

}

void icbmetroscroll(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_metro*)user)->cbkey((int)user2);
}

void icbmetrokey(int key,void* user,void* user2)
{
	((Interf_metro*)user)->cbkey(key);
}

#define METRO_X0 20
#define METRO_DX	76
#define METRO_Y0	208
#define METRO_DY	(32+2)



void Interf_metro::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_metro_title"));

	list=Ctr_list_create(container,(Control*)back,8,36,186,128,32);
	up=Ctr_push_create(container,back,8+186+2,36,32,32,"interf/nav/up.r",icbmetroscroll,this,(void*)-2,0x1f);
	down=Ctr_push_create(container,back,8+186+2,36+128-32,32,32,"interf/nav/down.r",icbmetroscroll,this,(void*)-3,0x1f);

	Ctr_keybd_create(container,back,9,METRO_Y0,KEYBD_ALPHA,icbmetrokey,this,NULL);


	affich=Ctr_text_create(container,back,METRO_X0+0*METRO_DX,METRO_Y0-METRO_DY+4,142,24,inp,COL_TITLE,-1,font_key,ALIGN_CENTER+ALIGN_VCENTER);
	affich->backupdate("interf/skin/txt_fond_142.r");
	Ctr_push_create(container,back,METRO_X0+144,METRO_Y0-METRO_DY+4,142,24,"interf/keybd/effacer.r",icbmetroscroll,this,(void*)27,0x1f);


	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbmetroclose,this,NULL,0x1f);

	loaded=1;
}


void Interf_metro::unload()
{
	if (!loaded) return;

//	PRINTF("unload metro\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_metro::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	resetdisplay();
	hiding=0;

}

void Interf_metro::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_metro::clic(int x,int y)
{
	return NULL;
}
void Interf_metro::unclic(int x,int y)
{
}

void Interf_metro::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_metro* Interf_metro_create(Container *c,Control* f)
{
	return new Interf_metro(c,f);
}

