//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_mode::Interf_mode(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_mode::~Interf_mode()
{
	hide();
	unload();
	link(NULL);
}


void icbmodeclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_MODE,0);
}

void icbmodeindex(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_MODE,0);
		interfActive(ITF_INDEX,1);
	}
}

void icbmodestreet(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_MODE,0);
		interfActive(ITF_STREET,1);
	}
}

void icbmodemetro(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_MODE,0);
		interfActive(ITF_METRO,1);
	}
}


#define MODE_Y0	(40+12)
#define MODE_DY	(32+12)


void Interf_mode::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_mode_title"));

	Ctr_push_create(container,back,8,MODE_Y0,220,32,rscButton("interf/skin/bout_trouver_lieu.r",54,ilang->loc("loc_mode_byname"),font_subtitle,3),icbmodeindex,this,(void*)NULL,0x109e);
	Ctr_push_create(container,back,8,MODE_Y0+1*MODE_DY,220,32,rscButton("interf/skin/bout_trouver_rue.r",54,ilang->loc("loc_mode_bystreet"),font_subtitle,3),icbmodestreet,this,(void*)NULL,0x109e);
	Ctr_push_create(container,back,8,MODE_Y0+2*MODE_DY,220,32,rscButton("interf/skin/bout_trouver_station.r",54,ilang->loc("loc_mode_bymetro"),font_subtitle,3),icbmodemetro,this,(void*)NULL,0x109e);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbmodeclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_mode::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_mode::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_mode::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_mode::clic(int x,int y)
{
	return NULL;
}
void Interf_mode::unclic(int x,int y)
{
}

void Interf_mode::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_mode* Interf_mode_create(Container *c,Control* f)
{
	return new Interf_mode(c,f);
}

