//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_panier::Interf_panier(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	npoi=0;
}

Interf_panier::~Interf_panier()
{
	hide();
	unload();
	link(NULL);
	listclear();
}

void icbpanierclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_PANIER,0);
}


void Interf_panier::cbkey(int v)
{
	if (v>=0) list->scroll(v?5:-5);
	up->enable(list->mayscroll(-1));
	down->enable(list->mayscroll(1));

}

void icbpanierkey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_panier*)user)->cbkey((int)user2);
}


#define PANIER_X0 (((240-2*2)-44*3)/4)
#define PANIER_DX	(44+PANIER_X0)
#define PANIER_DY	(32+8)
#define PANIER_Y0	320-PANIER_DY


void Interf_panier::cbsel(int i)
{
	if ((i<0)||(i>=npoi)) return;
	Poi* poi=lpoi[i];

	poilist->currentcrit(lpoicrit[i],1);
	imap->updatepoi();
	isimple->redrawbar();
	interfActive(ITF_SIMPLE,1);

	ipoi->poigo(poi,-1,NULL,NULL);
}


void icbpaniersel(Listitem* b,void* user1,void* user2)
{
	((Interf_panier*)user1)->cbsel((int)user2);
}


void Interf_panier::listclear()
{
	for(int i=0;i<npoi;i++) delete lpoiname[i];
	npoi=0;
}

void Interf_panier::listadd(Poi* p,char* name,int crit)
{
	if (npoi<PANIER_MAXPOI)
	{
		lpoi[npoi]=p;
		lpoiname[npoi]=new char[strlen(name)+1];
		strcpy(lpoiname[npoi],name);
		lpoicrit[npoi]=crit;
		npoi++;
	}
}
void Interf_panier::listrem(Poi* p)
{
	for(int i=0;i<npoi;i++) if (lpoi[i]==p)
	{
		delete lpoiname[i];
		while(i+1<npoi)
		{
			lpoi[i]=lpoi[i+1];
			lpoiname[i]=lpoiname[i+1];
			lpoicrit[i]=lpoicrit[i+1];
		}
		npoi--;
		return;
	}
}
int Interf_panier::listcontains(Poi* p)
{
	for(int i=0;i<npoi;i++) if (lpoi[i]==p) return 1;
	return 0;
}

int Interf_panier::listfull()
{
	if (npoi<PANIER_MAXPOI) return 0;
	return 1;
}

void Interf_panier::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_panier_title"));

	list=Ctr_list_create(container,(Control*)back,8,40,240-4-16,220,32);

	for(int i=0;i<npoi;i++)
	{
		Listitem* li=list->getnextitem();
		li->setname(lpoiname[i]);
		li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
		li->setfont(font_normal);
		li->setbutton("interf/skin/b1.r");
		li->setstyle(LITEM_TEXT|LITEM_BUTTON);
		li->setcb(icbpaniersel,(void*)this,(void*)i);
	}
	if (!npoi)
	{
		Listitem* li=list->getnextitem();
		li->setname(ilang->loc("loc_panier_empty"));
		li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
		li->setfont(font_normal);
		li->setstyle(LITEM_TEXT);
	}

	up=Ctr_push_create(container,back,PANIER_X0+0*PANIER_DX,PANIER_Y0,32,32,"interf/nav/up.r",icbpanierkey,this,(void*)0,0x1f);
	down=Ctr_push_create(container,back,PANIER_X0+2*PANIER_DX,PANIER_Y0,32,32,"interf/nav/down.r",icbpanierkey,this,(void*)1,0x1f);

	cbkey(0);
	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbpanierclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_panier::unload()
{
	if (!loaded) return;
//	PRINTF("unload panier %d\n",loaded);
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
//	PRINTF("end unload panier %d\n",loaded);
}


void Interf_panier::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;
}

void Interf_panier::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_panier::clic(int x,int y)
{
	return NULL;
}
void Interf_panier::unclic(int x,int y)
{
}

void Interf_panier::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_panier* Interf_panier_create(Container *c,Control* f)
{
	return new Interf_panier(c,f);
}

