//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


extern "C" {
#include "mp3/audio.h"
} 

Interf_play::Interf_play(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	moreinfo=0;
}

Interf_play::~Interf_play()
{
	hide();
	unload();
	link(NULL);
}

void icbplayclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		mp3stop();
		interfActive(ITF_PLAY,0);
	}
}


void Interf_play::cbkey(int v)
{
	if (v==1)
	{
		ipoi->pageset(2);
		mp3stop();
		interfActive(ITF_PLAY,0);
	}
}

void icbplaykey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_play*)user)->cbkey((int)user2);
}



void Interf_play::cbvol(int v)
{
	audioSetVolume(audioGetVolume()+v);
}



void icblevelchg(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_play*)user)->cbvol((int)user2);
}


void Interf_play::cbpause()
{
	mp3setpause(1-mp3getpause());
	pause->bmpupdate(mp3getpause()?"interf/sound/b_play.r":"interf/sound/b_pause.r");
}



void icbplaypause(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_play*)user)->cbpause();
}

#define PLAY_X0 (((240-2*2)-44*3)/4)
#define PLAY_DX	(44+PLAY_X0)
#define PLAY_DY	(32+8)
#define PLAY_Y0	300-PLAY_DY


void Interf_play::updatetitle(char *title)
{

	back->backempty();

	back->getback()->drawtextboxEx(0,40,back->getback()->width,80,ALIGN_CENTER,title,strlen(title),(short)COL_TITLE,-1,font_key,font_subtitle);

}

void Interf_play::setmoreinfo(int v)
{
	moreinfo=v;
}


void Interf_play::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);



	pause=Ctr_push_create(container,back,back->ws/2-26,PLAY_Y0-PLAY_DY*4,52,52,"interf/sound/b_pause.r",icbplaypause,this,(void*)0,0x1f);

	count=Ctr_text_create(container,back,back->ws/2-185/2,PLAY_Y0-PLAY_DY*2,185,24,"--:--",COL_TITLE,-1,font_title,ALIGN_CENTER+ALIGN_VCENTER);
	count->backupdate("interf/skin/txt_fond_185.r");
	
	Ctr_button* bar=Ctr_button_create(container,back,back->ws/2-185/2,PLAY_Y0-PLAY_DY,185,40,1);
	bar->setsrcbmp(0,rscGet("interf/sound/play_barre.r"),0x1f,0);
	bar->setlayer(0,0,0,0,0,LAYER_BLIT);
	bar->setmask(0,1);

	level=Ctr_button_create(container,bar,44,5,99,30,1);
	level->setsrcbmp(0,rscGet("interf/zoom/zoom_level.r"),-1,0);
	level->setlayer(0,0,0,0,0,LAYER_BLIT);
	level->setmask(0,1);

	leveldown=Ctr_push_create(container,bar,7,7,42,26,"interf/sound/bout_vol-.r",icblevelchg,this,(void*)-1,0x87f);
	levelup=Ctr_push_create(container,bar,135,7,42,26,"interf/sound/bout_vol+.r",icblevelchg,this,(void*)1,0x87f);

	if (moreinfo)
	{
		Ctr_push* p=Ctr_push_create(container,(Control*)back,back->ws/2-186/2,270,186,32,
			rscButton("interf/skin/b2.r",ilang->loc("loc_play_more"),font_key,2)/*66,22,"interf/bout_moreinfo.r"*/
			,icbplaykey,this,(void*)1);
	}

	cbvol(0);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbplayclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_play::unload()
{
//	PRINTF("unload play %d\n",loaded);
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
//	PRINTF("end unload play %d\n",loaded);
}


void Interf_play::show()
{
	if (!loaded) load();

	lastcount=-1;
	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;
}

void Interf_play::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_play::clic(int x,int y)
{
	return NULL;
}
void Interf_play::unclic(int x,int y)
{
}

void Interf_play::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if (!hiding)
	{
		level->movesrcbmp(0,0,32*audioGetVolume());
		if (!mp3running())
		{
			mp3stop();
			interfActive(ITF_PLAY,0);
		}
		else if (lastcount!=mp3counter())
		{
			char buffer[64];
			int c=mp3counter()/10;
			int l=mp3length()/10;
			sprintf(buffer,"%02d:%02d / %02d:%02d",c/60,c%60,l/60,l%60);
//			PRINTF("iplay->textupdate:%s\n",buffer);
			count->textupdate(buffer);
			lastcount=mp3counter();
		}
	}
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_play* Interf_play_create(Container *c,Control* f)
{
	return new Interf_play(c,f);
}

