//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "poi.h"
#include "hash.h"
#include "file.h"
#include "raw/raw.h"

Interf_poi::Interf_poi(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	back=NULL;
	count=0;
	poidata=NULL;
	poi=NULL;
	star=rscGet("interf/poi/star.r");
	metro=rscGet("interf/metro_icon.r");
}

Interf_poi::~Interf_poi()
{
	hide();
	unload();
	link(NULL);
	if (poidata) delete poidata;
	if (star) delete star;
	if (iconsbig) delete iconsbig;
}


void Interf_poi::poigo(Poi* p,int from,void* user1,void* user2)
{
	backinterf=from;
	backuser1=user1;
	backuser2=user2;
	poiset(p);
	int px=poilist->getpoix(p);
	int py=poilist->getpoiy(p);
	if ((px)||(py)) imap->moveto(px,py,50);
	interfActive(ITF_POI,1);
}

void Interf_poi::cbclose()
{
//	PRINTF("cbclose\n");
	interfActive(ITF_I,0);
	interfActive(ITF_DIAPO,0);
	interfActive(ITF_SEARCH,0);
	interfActive(ITF_PANIER,0);
	interfActive(ITF_POI,0);
}

void icbpoiclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_poi*)user)->cbclose();
}

extern "C" {
#include "mp3/audio.h"
} 

void Interf_poi::cbhp()
{
//	PRINTF("cbmp3 %dx%d %d\n",x,y,state);
	char buffer[128];
	char* p=poidata->get(ilang->loc("loc_poi_Audio"));
#ifdef HASHFILE
	sprintf(buffer,"mp3_/%02d/%s",fileHash(p,HASHFILE),p);
#else
	sprintf(buffer,"mp3/%s",p);
#endif
	PRINTF("--------check mp3 %s\n",buffer);
	if (fileCheck(buffer))
	{
		mp3start(buffer,1);//"voix_nathan-mono-32kbps.mp3"
		iplay->setmoreinfo((npages>=2)?1:0);
		interfActive(ITF_PLAY,1);
		iplay->updatetitle(poilist->getdesclocalized(poi)/*data->get(ilang->loc("loc_poi_Desc"))*/);
	}
}

void icbpoihp(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_poi*)user)->cbhp();
}

void Interf_poi::cbpoiplay(Poi* q)
{
	char buffer[128];
#ifdef HASHFILE
	char* pp=poilist->getname(q);
	sprintf(buffer,"poi_/%02d/%s",fileHash(pp,HASHFILE),pp);
#else
	sprintf(buffer,"poi/%s",poilist->getname(q));
#endif

	Hash* subdata=new Hash(16);
	subdata->load(buffer,POICRYPT);

	char* p=subdata->get(ilang->loc("loc_poi_Audio"));
#ifdef HASHFILE
	sprintf(buffer,"mp3_/%02d/%s",fileHash(p,HASHFILE),p);
#else
	sprintf(buffer,"mp3/%s",p);
#endif
	PRINTF("--------check mp3 %s\n",buffer);
	delete subdata;

	if (fileCheck(buffer))
	{
		mp3start(buffer,1);//"voix_nathan-mono-32kbps.mp3"
		iplay->setmoreinfo(0);
		interfActive(ITF_PLAY,1);
		iplay->updatetitle(poilist->getdesclocalized(q));
	}
}

void icbpoiplay(Listitem *b,void* user,void* user2)
{
	((Interf_poi*)user)->cbpoiplay((Poi*)user2);
}

void Interf_poi::cbpoigo(Poi* p)
{
	backinterf=-1;
	poiset(p);
}

void icbpoigo(Listitem *b,void* user,void* user2)
{
	((Interf_poi*)user)->cbpoigo((Poi*)user2);
}

void Interf_poi::cbsteps()
{
	int px=poilist->getpoix(poi);
	int py=poilist->getpoiy(poi);
	iiti->setdst(px,py);
	interfActive(ITF_I,0);
	interfActive(ITF_DIAPO,0);
	interfActive(ITF_SEARCH,0);
	interfActive(ITF_PANIER,0);
	interfActive(ITF_POI,0);
	interfActive(ITF_START,1);
}

void icbpoisteps(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_poi*)user)->cbsteps();
}


void Interf_poi::cbheart()
{
	if (ipanier->listcontains(poi))
	{
		ipanier->listrem(poi);
		heart->bmpupdate("interf/poi/heart.r");
	}
	else if (!ipanier->listfull())
	{
		ipanier->listadd(poi,poilist->getdesclocalized(poi),poilist->getcurrenttype());
		heart->bmpupdate("interf/poi/heart-del.r");
	}
}

void icbpoiheart(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_poi*)user)->cbheart();
}

void Interf_poi::appendtext(char *str,int col,int fontnumber)
{
	char buffer[64];
	if (strlen(str))
	{
		sprintf(buffer,"\n\\$%04x\\*%04x",col,fontnumber);
		text->textappend(buffer);
		text->textappend(str);
	}
}

#define MAXPIC 8
void Interf_poi::poiset(Poi* p)
{
	if (!loaded) load();

	poi=p;

	PRINTF("id=%s\n",poilist->getname(p));
	PRINTF("n=%d sc=%d zoom=%d x=%d y=%d icon=%d\n",p->num,p->score,p->zoom,p->x,p->y,p->icon);

	char buffer[256];
	char* pp;
#ifdef HASHFILE
	pp=poilist->getname(p);
	sprintf(buffer,"poi_/%02d/%s",fileHash(pp,HASHFILE),pp);
#else
	sprintf(buffer,"poi/%s",poilist->getname(p));
#endif

	if (poidata) delete poidata;
	poidata=new Hash(16);
	poidata->load(buffer,POICRYPT);

	PRINTF("load poi : %s\n",buffer);

	npics=0;	// nb images
	nhp=1;	// nb mp3
	pic=-1;	// num image
	nsub=0;

	pp=poidata->get(ilang->loc("loc_poi_Audio"));
#ifdef HASHFILE
	sprintf(buffer,"mp3_/%02d/%s",fileHash(pp,HASHFILE),pp);
#else
	sprintf(buffer,"mp3/%s",pp);
#endif
	hp->enable(fileCheck(buffer)?1:0);


	text->textupdate("");

	char* txt1=poilist->getdesclocalized(poi);
	appendtext(txt1,COL_TITLE,FONT_SUBTITLE);
	if (ilang->getlang()==LANG_JP)
	{
		char* txt2=poilist->getdesclocal(poi);
		if (strcmp(txt1,txt2)) appendtext(txt2,RGBTO16(0,128,45),FONT_SUBTITLE);
	}

	appendtext(poidata->get(ilang->loc("loc_poi_Artiste")),COL_TITLE,FONT_NORMAL);
	appendtext(poidata->get(ilang->loc("loc_poi_Epoque")),COL_TITLE,FONT_NORMAL);

	sprintf(buffer,"%s\n%s",poidata->get("Voie"),poidata->get("Arr"));
	appendtext(buffer,BLACK,FONT_NORMAL);

	appendtext(poidata->get(ilang->loc("loc_poi_Quartier")),BLACK,FONT_NORMAL);
	appendtext(poidata->get("Tel"),BLACK,FONT_NORMAL);
	appendtext(poidata->get(ilang->loc("loc_poi_Tarif")),BLACK,FONT_NORMAL);
	appendtext(poidata->get(ilang->loc("loc_poi_Quand")),BLACK,FONT_NORMAL);

	appendtext(" ",BLACK,FONT_NOTE);
	appendtext(poidata->get(ilang->loc("loc_poi_Contenu")),BLACK,FONT_NOTE);

	text->setscroll(0);


	list->empty();
	int npoi=poilist->getnpoi();
	for(int i=0;i<npoi;i++)
	{
		Poi* q=poilist->getnth(i);
		if ((q)&&(poilist->getnth(q->meta)==p))
		{
//			PRINTF("sub %d %d %s\n",i,q->meta,poilist->getname(q));
//			sprintf(buffer,"poi/%s",poilist->getdesc(q));

			Listitem* li=list->getnextitem();
			li->setname(poilist->getdesclocalized(q));
			li->settext(28,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
			li->setfont(font_normal);
			li->setbutton("interf/skin/b1.r");
			if (q->audioonly)
			{
				li->seticon("interf/poi/hp-icon.r");
				li->seticonpos(4,8,0,0,22,16);
				li->setstyle(LITEM_TEXT|LITEM_BUTTON|LITEM_ICON);
				li->setcb(icbpoiplay,(void*)this,(void*)q);
			}
			else
			{
				li->setstyle(LITEM_TEXT|LITEM_BUTTON);
				li->setcb(icbpoigo,(void*)this,(void*)q);
			}
			nsub++;
		}
	}
	list->scrollto(0);
//	PRINTF("nsub=%d\n",nsub);
	if (nsub) npages=3;
	else npages=2;

	for(int i=0;i<MAXPIC;i++)
	{
		if (getpicfilepath(i,buffer))
		{
			if (fileCheck(buffer))
			{
				if (pic<0) pic=i;
				npics++;
			}
#ifndef POCKETPC
			else fprintf(logfile,"------>missing : %s\n",p);
#endif
		}
	}

	char* panier="interf/poi/heart.r";
	if (ipanier->listcontains(poi)) panier="interf/poi/heart-del.r";
	else if (ipanier->listfull()) panier="interf/poi/heart-no.r";
	heart->bmpupdate(panier);

	pageset(0);

}

void Interf_poi::drawpic()
{
	char buffer[128];
//	if (1) return;
	if (npics)
	{
		getpicfilepath(pic,buffer);
	}
	else
	{
		strcpy(buffer,"pics/PAR0GEN.jpeg");
	}
	forceraw(buffer);
//	sprintf(buffer,"pics/%s",poidata->get("Photo1"));
//	PRINTF("## pic : %s\n",buffer);
	Bitmap* picbmp=rscGet(buffer);
	int ofx=6;
	if (picbmp)
	{
		ofx=(back->getback()->width-picbmp->width)>>1;
		back->getback()->blit(ofx,30,picbmp,0,0,picbmp->width,148,-1);

		sprintf(buffer,"Copy%d",pic+1);
		char* p=poidata->get(buffer);
		PRINTF("%s : %s\n",buffer,p);
//		p="foobar";
		if (strlen(p))
//			picbmp->drawtext(0,40,0,p,strlen(p),-1,-1,font_note);
			back->getback()->drawtextbox(0,30+picbmp->height,back->getback()->width,fonth(font_note),ALIGN_RIGHT,p,strlen(p),-1,-1,font_note);

	}


//	char* id=poidata->get("ID");
//	back->getback()->drawtextbox(ofx,30,100,20,0,id,strlen(id),0,0xffff,font_normal);

/*	sprintf(buffer,"%d",poi->num);
	back->getback()->drawtextbox(ofx,50,100,20,0,buffer,strlen(buffer),0,0xffff,font_normal);
*/
	rscUnuseit(picbmp);

	if (npics>1) morepic->setenable(1);

}

int Interf_poi::drawnote(int y)
{
	int note=atoi(poidata->get("Note"));
	if ((star)&&(note)) for(int i=0;i<5;i++) back->getback()->blit(12+i*16,y,star,0,(i<note)?0:16,16,16,0x1f);
	return note;
}

void Interf_poi::drawtitle()
{
	char* title=poidata->get(ilang->loc("loc_poi_Type"));
	back->getback()->drawtextboxEx(30,5,162,19,ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(128,128,128),(short)BACKCOL,font_title,font_subtitle);
	back->getback()->blit(0,0,iconsbig,poi->icon*28,0,28,28,0x1f);
}

int Interf_poi::drawmetro(int y)
{
		char* pmetro=poidata->get("Metro");
		if ((pmetro)&&(strlen(pmetro)))
		{
			if (metro) back->getback()->blit(3,y,metro,0,0,24,24,0x1f);
			y=back->getback()->drawtextbox(3+28,y,220-3*2-28,30,0,pmetro,strlen(pmetro),BLACK,BACKCOL,font_note);
		}
		return y;
}

void Interf_poi::drawnav()
{
	if(page==2)
	{
		right->setenable(0);
		up->setenable(1);
		down->setenable(1);
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if(page==1)
	{
		right->setenable(1);
		right->enable((page<npages-1)?1:0);
		up->setenable(1);
		down->setenable(1);
		up->enable(text->mayscroll(-1));
		down->enable(text->mayscroll(1));
	}
	else
	{
		steps->setenable(1);
		heart->setenable(1);
		right->setenable(1);
		right->enable((page<npages-1)?1:0);
	}
}

void Interf_poi::pageset(int pg)
{
	if (pg<0)
	{
		if ((backinterf<0)&&(poi->meta>=0))
		{
			Poi* q=poilist->getnth(poi->meta);
			if (q)
			{
				poiset(q);
				pageset(2);
				return;
			}
		}
		interfActive(ITF_POI,0);
		if (backinterf==ITF_DIAPO)
		{
			interfActive(ITF_DIAPO,1);
			idiapo->setcrit((int)backuser1,(int)backuser2);
		}
		else if (backinterf==ITF_SEARCH)
		{
			interfActive(ITF_SEARCH,1);
			isearch->setpage((int)backuser1,(int)backuser2);
		}
		return;
	}

	if (pg>=npages) pg=npages-1;
	page=pg;

	back->backempty();
	Bitmap *bmp=back->getback();

	hp->setenable(0);
	list->setenable(0);
	text->setenable(0);
	up->setenable(0);
	down->setenable(0);
	right->setenable(0);
	steps->setenable(0);
	heart->setenable(0);
	morepic->setenable(0);


	if (poi->cat==0)
	{
		if (page==0)
		{
			drawpic();
			if (nhp) hp->setenable(1);

			drawtitle();

			char* subtitle=poilist->getdesclocalized(poi);
			bmp->drawtextboxEx(3,191,165,30,0,subtitle,strlen(subtitle),(short)RGBTO16(255,128,0),(short)BACKCOL,font_subtitle,font_normal);
			char* subtitle2=poilist->getdesclocal(poi);
			if (strcmp(subtitle,subtitle2))
				bmp->drawtextboxEx(3,221,214,20,0,subtitle2,strlen(subtitle2),(short)RGBTO16(0,128,45),(short)BACKCOL,font_subtitle,font_normal);
			drawmetro(241);
		}
		else if (page==1)
		{
			drawtitle();
			text->setenable(1);
		}
		else if (page==2)
		{
			drawtitle();
			list->setenable(1);
		}
	}
	else if (poi->cat==1)
	{
		if (page==0)
		{
			drawpic();

			drawtitle();
			
			char* subtitle=poilist->getdesclocalized(poi);
			bmp->drawtextboxEx(3,180,214,30,0,subtitle,strlen(subtitle),(short)RGBTO16(255,128,0),(short)BACKCOL,font_subtitle,font_normal);
			char* subtitle2=poilist->getdesclocal(poi);
			if (strcmp(subtitle,subtitle2))
				bmp->drawtextboxEx(3,221,214,20,0,subtitle2,strlen(subtitle2),(short)RGBTO16(0,128,45),(short)BACKCOL,font_subtitle,font_normal);
			drawmetro(241);
		}
		else if (page==1)
		{
			drawtitle();
			text->setenable(1);

		}
		else if (page==2)
		{
			drawtitle();
			list->setenable(1);
		}
	}
	drawnav();

}

int Interf_poi::getpicfilepath(int i,char* buffer)
{
	char p[128];
	sprintf(p,"Photo%d",i+1);
	char *q=poidata->get(p);
	if (!strlen(q)) return 0;

	strcpy(p,q);
	forceraw(p);
#ifdef HASHFILE
	sprintf(buffer,"pics_/%02d/%s",fileHash(p,HASHFILE),p);
#else
	sprintf(buffer,"pics/%s",p);
#endif
	return 1;
}

void Interf_poi::cbkey(int v)
{
	if ((v==2)||(v==3))
	{
		if (list->getenable())
		{
			list->scroll(v==3?5:-5);
			up->enable(list->mayscroll(-1));
			down->enable(list->mayscroll(1));
		}
		else if (text->getenable())
		{
			text->scroll(v==3?150:-150);
			up->enable(text->mayscroll(-1));
			down->enable(text->mayscroll(1));
		}
	}
	else if ((v==0)||(v==1)) pageset(page+(v?1:-1));
	else if (v==4)
	{
		char buffer[128];
		for(int i=0;i<MAXPIC;i++)
		{
			int j=pic+i+1;
			if (j>=MAXPIC) j-=MAXPIC;

			if (getpicfilepath(j,buffer))
			{
				if (fileCheck(buffer))
				{
					pic=j;
					pageset(page);
					return;
				}
			}
		}
	}
}

void icbpoikey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_poi*)user)->cbkey((int)user2);
}


#define POI_X0 (((240-2*2)-44*4)/5)
#define POI_DX	(44+POI_X0)
#define POI_DY	(32+8)
#define POI_Y0	320-POI_DY

void Interf_poi::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);


	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbpoiclose,this,NULL,0x1f);

	iconsbig=rscGet("icons/pictos_gd.r");
	hp=Ctr_push_create(container,back,178,196,44,32,"interf/poi/hp.r",icbpoihp,this,(void*)0);

	list=Ctr_list_create(container,(Control*)back,8,40,240-4-16,220,32);
	text=Ctr_text_create(container,(Control*)back,8,40,240-4-16,220,"foobar",0,-1,font_normal,0);

	morepic=Ctr_push_create(container,back,8,30+148-18,42,18,"interf/poi/bout_photo+.r",icbpoikey,this,(void*)4,0x109e);

	left=Ctr_push_create(container,back,POI_X0+0*POI_DX,POI_Y0,44,32,"interf/nav/b_back.r",icbpoikey,this,(void*)0);
	steps=Ctr_push_create(container,back,POI_X0+1*POI_DX,POI_Y0,44,32,"interf/poi/steps.r",icbpoisteps,this,(void*)NULL);
	heart=Ctr_push_create(container,back,POI_X0+2*POI_DX,POI_Y0,44,32,"interf/poi/heart.r",icbpoiheart,this,(void*)NULL);
	right=Ctr_push_create(container,back,POI_X0+3*POI_DX,POI_Y0,44,32,"interf/nav/b_next.r",icbpoikey,this,(void*)1);
	up=Ctr_push_create(container,back,POI_X0+2*POI_DX-34,POI_Y0,32,32,"interf/nav/up.r",icbpoikey,this,(void*)2,0x1f);
	down=Ctr_push_create(container,back,POI_X0+2*POI_DX+0,POI_Y0,32,32,"interf/nav/down.r",icbpoikey,this,(void*)3,0x1f);

	loaded=1;
}




void Interf_poi::unload()
{
	if (!loaded) return;

//##	loaded=0;
}

void Interf_poi::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
}

void Interf_poi::hide()
{
//	if (!loaded) unload();
//	setenable(0);

	back->setpos(2,2);
	back->move(40,0,6);
}

Control* Interf_poi::clic(int x,int y)
{
	return NULL;
}
void Interf_poi::unclic(int x,int y)
{
}

void Interf_poi::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;

	if (count)
	{
		if (!(--count))
		{
			setenable(0);

		}
	}
}

Interf_poi* Interf_poi_create(Container *c,Control* f)
{
	return new Interf_poi(c,f);
}

