//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_power::Interf_power(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	sps.ACLineStatus=0;
	sps.BatteryLifePercent=0;
	closewhenoff=0;

}

Interf_power::~Interf_power()
{
	hide();
	unload();
	link(NULL);
}

void icbpowerclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
//	PRINTF("state=%d %d,%d\n",state,x,y);
	if (state==CBBUTTON_UP) interfActive(ITF_POWER,0);
}

void Interf_power::setclosewhenoff(int v)
{
	closewhenoff=v;
}


void Interf_power::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbpowerclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_power::unload()
{
	if (!loaded) return;

//	PRINTF("unload power\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_power::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_power::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_power::clic(int x,int y)
{
	return NULL;
}
void Interf_power::unclic(int x,int y)
{
}


//#include<pm.h>
int Interf_power::checkpower()
{
	int last=sps.ACLineStatus;

/*	unsigned short buf[256];
	unsigned long flags;
	GetSystemPowerState(buf,256,&flags);
*/
#ifdef POCKETPC
#ifdef OPHRYS
	if (!GetSystemPowerStatusEx2(&sps,sizeof(sps),FALSE))
#else
	if (!GetSystemPowerStatusEx2(&sps,sizeof(sps),FALSE))
#endif

#else
	if (!GetSystemPowerStatus(&sps))
#endif
		sps.BatteryLifePercent=-1;

	if ((sps.ACLineStatus)&&(!last)) return 1;
	return 0;
}

int Interf_power::getpower()
{
	return sps.BatteryLifePercent;
}


void Interf_power::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;

	char buffer[128];
	int battery;
	int colback=RGBTO16(0,0,80);
	battery=sps.BatteryLifePercent;

	if (battery>95) colback=RGBTO16(0,0xc0,0);
	else if (battery>60) colback=RGBTO16(0xc0,0x80,0);
	else if (battery>=0) colback=RGBTO16(0xc0,0,0);

	back->getback()->empty(colback);
	back->getback()->drawtextbox(10,10,240-8-16-20,20,ALIGN_CENTER,VERSION,strlen(VERSION),(short)RGBTO16(255,255,255),colback,font_title);
	sprintf(buffer,"battery %d %c",battery,'%');
	back->getback()->drawtextbox(10,50,240-8-16-20,20,ALIGN_CENTER,buffer,strlen(buffer),(short)RGBTO16(255,255,255),colback,font_title);
//	sprintf(buffer,"battery \\$0000\\&F000\\*0000%d %c",battery,'%');
//	back->getback()->drawtextbox(10,50,240-8-16-20,20,ALIGN_CENTER,buffer,strlen(buffer),(short)RGBTO16(255,255,255),colback,font_note);

	if ((!sps.ACLineStatus)&&(!hiding)&&(closewhenoff)) interfActive(ITF_POWER,0);

	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_power* Interf_power_create(Container *c,Control* f)
{
	return new Interf_power(c,f);
}

