//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_pwd::Interf_pwd(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	strcpy(pwd,"");
}

Interf_pwd::~Interf_pwd()
{
	hide();
	unload();
	link(NULL);
}

void icbpwdclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_PWD,0);
}

void Interf_pwd::cbkey(int val)
{
	int len=strlen(pwd);
	if (val==-1)
	{
		if (len>0) len--;
		pwd[len]=0;
	}
	else if (val==10)
	{
//		if (!strcmp(pwd,"53781")) exit(0);
		if (!strcmp(pwd,"00000")) exit(0);
		interfActive(ITF_PWD,0);
		interfActive(ITF_TOOLS,0);
		interfActive(ITF_DIAPO,1);
		idiapo->setautoscroll();
		idiapo->setcrit(44,0);
		return;
	}
	else if (len<PWD_MAX-1)
	{
		pwd[len++]=val+'0';
		pwd[len]=0;
	}
//	PRINTF("text : %s\n",pwd);
	mkpwd_crypt();
	affich->textupdate(pwd_crypt);
}

void icbpwdkey(int key,void* user,void* user2)
{
	((Interf_pwd*)user)->cbkey(key);
}

#define PWD_X0 20
#define PWD_DX	76
#define PWD_Y0	120
#define PWD_DY	(32+8)

void Interf_pwd::mkpwd_crypt()
{
	int i;

	for(i=0;i<PWD_MAX;i++)
		pwd_crypt[i]=(pwd[i])?'*':0;
}

void Interf_pwd::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);


	Ctr_keybd_create(container,back,PWD_X0,PWD_Y0,KEYBD_PWD,icbpwdkey,this,NULL);

	mkpwd_crypt();
	affich=Ctr_text_create(container,back,(236-185)/2,60,185,24,"",COL_TITLE,-1,font_title,ALIGN_CENTER+ALIGN_VCENTER);
	affich->backupdate("interf/skin/txt_fond_185.r");

	back->getback()->drawtextbox(25,5,162,19,0,VERSION,strlen(VERSION),(short)RGBTO16(128,128,128),BACKCOL,font_title);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbpwdclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_pwd::unload()
{
	if (!loaded) return;
//	PRINTF("unload pwd\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_pwd::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

	strcpy(pwd,"");
	mkpwd_crypt();
	affich->textupdate(pwd_crypt);

}

void Interf_pwd::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;

}

Control* Interf_pwd::clic(int x,int y)
{
	return NULL;
}
void Interf_pwd::unclic(int x,int y)
{
}

void Interf_pwd::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_pwd* Interf_pwd_create(Container *c,Control* f)
{
	return new Interf_pwd(c,f);
}

