//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "hash.h"

#include "raw/raw.h"

#define ARBBOLEN 149
const int arbo_id[ARBBOLEN]={
-1,-2,-3,-4,45,-5,-6,-7,42,-8,-9,6,-10,-11,-12,-13,-14,-15,-16,-17,-18,122,-19,-20,-21,-22,-23,5,34,39,47,48,-24,-25,118,114,-26,-27,66,-28,-29,67,-30,14,16,17,19,-31,50,46,133,75,51,121,123,117,119,120,79,80,81,82,83,84,85,94,86,87,88,89,90,91,92,93,95,96,97,98,99,100,101,103,104,107,109,108,110,111,71,124,126,134,52,116,49,120,113,115,71,61,70,58,65,68,64,77,55,60,59,78,73,72,74,57,62,76,63,56,69,54,11,12,25,26,29,27,28,36,38,37,40,43,7,8,22,23,24,10,13,12,11,30,31,32,33,15,18,20,21,
};
const int arbo_top[ARBBOLEN]={
0,0,0,0,-1,-1,-1,-1,-2,-2,-2,-3,-3,-3,-3,-4,-4,-7,-7,-7,-7,-7,-8,-8,-8,-12,-12,-12,-12,-12,-15,-15,-15,-15,-15,-15,-16,-16,-16,-16,-16,-16,-16,-20,-20,-20,-20,-20,-5,-5,-5,-5,-6,-6,-6,-6,-6,-6,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-17,-18,-18,-18,-18,-18,-18,-18,-18,-18,-24,-24,-24,-24,-24,-24,-25,-25,-25,-25,-26,-26,-27,-27,-27,-27,-27,-27,-27,-28,-28,-29,-29,-29,-29,-29,-29,-29,-30,-30,-30,-30,-9,-9,-10,-10,-10,-10,-10,-11,-11,-11,-13,-13,-14,-14,-19,-19,-19,-21,-21,-21,-21,-22,-22,-23,-23,-31,-31,-31,-31,
};


Interf_search::Interf_search(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_search::~Interf_search()
{
	hide();
	unload();
	link(NULL);
}

void icbsearchclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_SEARCH,0);
}


void Interf_search::cbkey(int v)
{
	if (v>=0)
	{
		list->scroll(v?5:-5);
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if ((v<0)&&(page))
	{
		for(int i=0;i<ARBBOLEN;i++) if (arbo_id[i]==page)
		{
			setpage(arbo_top[i],0);
			return;
		}
	}
	else interfActive(ITF_SEARCH,0);
}


void icbsearchkey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_search*)user)->cbkey((int)user2);
}

void Interf_search::cbdiapo()
{
	interfActive(ITF_SEARCH,0);
	interfActive(ITF_DIAPO,1);
	idiapo->setcrit(page-1,0);
}


void icbsearchdiapo(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_search*)user)->cbdiapo();
}

#define SEARCH_X0 (((240-2*2)-44*4)/5)
#define SEARCH_DX	(44+SEARCH_X0)
#define SEARCH_DY	(32+8)
#define SEARCH_Y0	310-SEARCH_DY



void Interf_search::cbarbo(int val)
{
	setpage(val,0);
//	PRINTF("select item %d\n",val);
}

void icbsearcharbo(Listitem* b,void* user1,void* user2)
{
	((Interf_search*)user1)->cbarbo((int)user2);
}

void Interf_search::cbpoi(int i)
{
	Poi* poi=poilist->getnth(i);
	if (poi)
	{
		ipoi->poigo(poi,ITF_SEARCH,(void*)page,(void*)list->getscroll());
	}
}

void icbsearchpoi(Listitem* b,void* user1,void* user2)
{
	((Interf_search*)user1)->cbpoi((int)user2);
}

void Interf_search::setpage(int pg,int scroll)
{
	page=pg;

	back->backempty();
	if (page==0) back->drawtitle(ilang->loc("loc_search_title"));
	else
	{
		char buf[32];
		if (page<=0) sprintf(buf,"loc_A%d",-page);
		else sprintf(buf,"loc_C%d",page);
		back->drawtitle(ilang->loc(buf));
	}

	list->empty();

//	PRINTF("page %d\n",page);
	if (page<=0)
	{
		for(int i=0;i<ARBBOLEN;i++)
			if (arbo_top[i]==page)
			{
				char buf[32];
				if (arbo_id[i]<=0) sprintf(buf,"loc_A%d",-arbo_id[i]);
				else sprintf(buf,"loc_C%d",arbo_id[i]);
				Listitem* li=list->getnextitem();
				li->setname(ilang->loc(buf));
				li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
				li->setfont(font_normal);
				li->setbutton("interf/skin/b1.r");
				li->setstyle(LITEM_TEXT|LITEM_BUTTON);
				li->setcb(icbsearcharbo,(void*)this,(void*)arbo_id[i]);
			}
		todiapo->setenable(0);

	}
	else
	{
		int seuil=80;
		int n=poilist->getnpoi();
		for(int i=0;i<n;i++)
		{
			int s=poilist->score(i,page-1);
			if (s)
			{
				char* id=poilist->getdesclocalized(poilist->getnth(i));
				Listitem* li=list->getnextitem();
				li->setname(id);
				li->setscore(s);
				li->setfont(font_normal);
				li->setbutton("interf/skin/b1.r");
				
				if (s<seuil)
				{
					li->settext(24,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
					li->setstyle(LITEM_TEXT|LITEM_BUTTON);
				}
				else
				{
					li->settext(24,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
					li->seticon("interf/star_small.r");
					li->seticonpos(4,8,0,0,16,16);
					li->setstyle(LITEM_TEXT|LITEM_BUTTON|LITEM_ICON);
				}

				li->setcb(icbsearchpoi,(void*)this,(void*)i);
			}
		}
		list->sortname(seuil);
		poilist->setcrit(page-1,1);
		imap->updatepoi();
		isimple->redrawbar();
		interfActive(ITF_SIMPLE,1);
		todiapo->setenable(1);

	}
	list->setscroll(scroll);
	up->enable(list->mayscroll(-1));
	down->enable(list->mayscroll(1));
}


void Interf_search::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

//	back->drawtitle(ilang->loc("loc_search_title"));

	list=Ctr_list_create(container,(Control*)back,8,40,240-4-16,220,32);


	prev=Ctr_push_create(container,back,SEARCH_X0+0*SEARCH_DX,SEARCH_Y0,44,32,"interf/nav/b_back.r",icbsearchkey,this,(void*)-1);
	up=Ctr_push_create(container,back,SEARCH_X0+1*SEARCH_DX,SEARCH_Y0,32,32,"interf/nav/up.r",icbsearchkey,this,(void*)0,0x1f);
	down=Ctr_push_create(container,back,SEARCH_X0+1*SEARCH_DX+32,SEARCH_Y0,32,32,"interf/nav/down.r",icbsearchkey,this,(void*)1,0x1f);
	todiapo=Ctr_push_create(container,back,SEARCH_X0+3*SEARCH_DX,SEARCH_Y0-4,36,36,
		(ilang->getlang()==LANG_JP)?"interf/bout_photo_jp.r":"interf/bout_photo.r",
		icbsearchdiapo,this,NULL,0x87f);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbsearchclose,this,NULL,0x1f);

	setpage(0,0);

	loaded=1;
}

void Interf_search::unload()
{
	if (!loaded) return;
//	PRINTF("unload search %d\n",loaded);
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
//	PRINTF("end unload search %d\n",loaded);
}


void Interf_search::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;
}

void Interf_search::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_search::clic(int x,int y)
{
	return NULL;
}
void Interf_search::unclic(int x,int y)
{
}

void Interf_search::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_search* Interf_search_create(Container *c,Control* f)
{
	return new Interf_search(c,f);
}

