//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "metro.h"

Interf_sel::Interf_sel(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	tp=0;
}

Interf_sel::~Interf_sel()
{
	hide();
	unload();
	link(NULL);
}

void Interf_sel::settype(int t)
{
	tp=t;
}


void Interf_sel::cbsel()
{
	interfActive(ITF_SEL,0);
	if (tp==ITF_ITI)
	{
		int x=120;
		int y=160;
		imap->getcoord(&x,&y);
//		PRINTF("org = %d,%d\n",x,y);
		iiti->setorg(x,y);
		iiti->update();
		interfActive(ITF_ITI,1);
		interfActive(ITF_ZOOM,1);
	}
}
void icbviseur(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)	((Interf_sel*)user)->cbsel();
}


void Interf_sel::load()
{
	if (loaded) return;
	Bitmap* gifviseur=rscGet("interf/sel.r");

	viseur=Ctr_button_create(container,this,120,160,26,25,1);
	viseur->setsrcbmp(0,gifviseur,0x1f,0);
	viseur->setlayer(0,0,0,0,0,LAYER_BLIT);
	viseur->setmask(0,1);
	viseur->setcb(icbviseur,(void*)this,NULL);
	viseur->setoff(12,12);

	Ctr_text_create(container,viseur,-102,-140,204,80,ilang->loc("loc_help_sel"),COL_TITLE,-1,font_subtitle,ALIGN_CENTER+ALIGN_VCENTER)->backupdate("interf/skin/txt_fond_204_80.r");


	loaded=1;
}

void Interf_sel::unload()
{
	if (!loaded) return;
//	PRINTF("unload sel\n");
	viseur->link(NULL);
	delete viseur;
	hiding=0;
	loaded=0;
}

void Interf_sel::show()
{
	if (!loaded) load();

	viseur->setpos(-20,160);
	viseur->move(14,0,10);
	setenable(1);
	hiding=0;
}

void Interf_sel::hide()
{
	viseur->setpos(120,160);
	viseur->move(-14,0,10);
	hiding=1;
}

Control* Interf_sel::clic(int x,int y)
{
	return NULL;
}
void Interf_sel::unclic(int x,int y)
{
}

void Interf_sel::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!viseur->moving()))
	{
		unload();
	}
}

Interf_sel* Interf_sel_create(Container *c,Control* f)
{
	return new Interf_sel(c,f);
}

