//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "hash.h"

#include "raw/raw.h"
extern "C" {
#include "mp3/audio.h"
} 

Interf_seq::Interf_seq(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	pg=0;
	seq=NULL;
	list=NULL;
	text=NULL;
	pgbackindex=0;
}

Interf_seq::~Interf_seq()
{
	hide();
	unload();
	link(NULL);
	if (seq) delete seq;
}

void icbseqclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
			mp3stop();
			interfActive(ITF_SEQ,0);
	}
}

void Interf_seq::getseq(char *filename)
{
	if (seq) delete seq;
	if (list)
	{
		list->link(NULL);
		delete list;
		list=NULL;
	}
	if (text)
	{
		text->link(NULL);
		delete text;
		text=NULL;
	}

	seq=new Hash(1);
	seq->load(filename);
//	seq->dump();
	pg=0;
	pgbackindex=0;
}

HashKey* Interf_seq::pagereach(int i)
{
	if (!seq) return NULL;
	int j=0;
	HashKey *p=seq->getnth(0);
	while(p)
	{
		if (!strcmp(p->key,"page"))
		{
			if (!i) return p->next;
			i--;
		}
		p=p->next;
	}
	return NULL;
}

int Interf_seq::pagereach(char* id)
{
	if (!seq) return 0;
	int j=0;
	HashKey *p=seq->getnth(0);
	int pg=0;
	while(p)
	{
		if (!strcmp(p->key,"page"))
		{
			if (!strcmp(p->val,id)) return pg;
			pg++;
		}
		p=p->next;
	}
	return 0;
}

void icbseqlabel(Listitem *b,void* user,void* user2)
{
	((Interf_seq*)user)->page((char*)user2);
}

void Interf_seq::page(int i)
{
	if (i<0) i=0;
	pg=i;
	if ((!pgbackindex)||(pgback[pgbackindex-1]!=pg))
	{
		if (pgbackindex<SEQ_MAXBACK)
		{
			pgbackscroll[pgbackindex]=0;
			pgback[pgbackindex++]=pg;
		}
	}
	back->backempty();

	if (list)
	{
		list->link(NULL);
		delete list;
		list=NULL;
	}
	if (text)
	{
		text->link(NULL);
		delete text;
		text=NULL;
	}
	int nonext=0;
	char *listitemcb=NULL;
	mp3=NULL;
	mp3stop();
	int infoplus=0;


	HashKey *p=pagereach(pg);
	while((p)&&(strcmp(p->key,"page")))
	{
		if (!strcmp(p->key,"title")) back->drawtitle(ilang->loc(p->val));
		else if (!strcmp(p->key,"text"))
		{
			text=Ctr_text_create(container,(Control*)back,8,40,240-4-16,220,ilang->loc(p->val),0,-1,font_note,0);
		}
		else if (!strcmp(p->key,"pic"))
		{
			PRINTF("load pic in seq %s\n",p->val);
			Bitmap* bmp=bmpGet(p->val);
			if (bmp)
			{
				back->getback()->blit((back->getback()->width-bmp->width)>>1,40+((220-bmp->height)>>1),bmp,0,0,bmp->width,bmp->height,-1);
				delete bmp;
			}
		}
		else if (!strcmp(p->key,"list"))
		{
			list=Ctr_list_create(container,(Control*)back,8,40,240-4-16,220,32);
		}
		else if (!strcmp(p->key,"listitemcb"))
		{
			listitemcb=p->val;
		}
		else if (!strcmp(p->key,"listitem"))
		{
			Listitem* li=list->getnextitem();
			li->setname(ilang->loc(p->val));
			li->settext(0,ALIGN_CENTER+ALIGN_VCENTER,COL_TITLE);
			li->setfont(font_note);
			li->setbutton("interf/skin/b1.r");
			li->setstyle(LITEM_TEXT|LITEM_BUTTON);
			li->setcb(icbseqlabel,(void*)this,(void*)listitemcb);
		}
		else if (!strcmp(p->key,"nonext")) nonext=1;
		else if (!strcmp(p->key,"mp3")) mp3=p->val;
		else if (!strcmp(p->key,"info+")) infoplus=1;
		p=p->next;
	}
	if (!p)
	{
		mp3stop();
		interfActive(ITF_SEQ,0);
		return;
	}

	prev->setenable(1);
	info->setenable(0);
	volplus->setenable(0);
	volmoins->setenable(0);
	level->setenable(0);
	if (list)
	{
		list->setscroll(pgbackscroll[pgbackindex-1]);
		up->setenable(1);
		down->setenable(1);
		if ((!p)||(nonext)) next->setenable(0);
		else next->setenable(1);
		up->enable(list->mayscroll(-1));
		down->enable(list->mayscroll(1));
	}
	else if (text)
	{
		text->setscroll(pgbackscroll[pgbackindex-1]);
		up->setenable(1);
		down->setenable(1);
		if ((!p)||(nonext)) next->setenable(0);
		else next->setenable(1);
		up->enable(text->mayscroll(-1));
		down->enable(text->mayscroll(1));
	}
	else
	{
		up->setenable(0);
		down->setenable(0);
		if (infoplus)
		{
			prev->setenable(0);
			next->setenable(0);
			info->setenable(1);
		}
		else
		{
			if ((!p)||(nonext)) next->setenable(0);
			else next->setenable(1);
		}
	}
	if (mp3)
	{
		hp_play->setenable(1);
		hp_stop->setenable(0);
	}
	else
	{
		hp_play->setenable(0);
		hp_stop->setenable(0);
	}
}

void Interf_seq::page(char* p)
{
	page(pagereach(p));
}

void Interf_seq::cbvol(int v)
{
	audioSetVolume(audioGetVolume()+v);
}

void icbseqvol(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_seq*)user)->cbvol((int)user2);
}

void Interf_seq::cbkey(int v)
{
	if ((v==2)||(v==3))
	{
		if (list)
		{
			list->scroll(v==3?5:-5);
			pgbackscroll[pgbackindex-1]=list->getscroll();
			up->enable(list->mayscroll(-1));
			down->enable(list->mayscroll(1));
		}
		else if (text)
		{
			text->scroll(v==3?160:-160);
			pgbackscroll[pgbackindex-1]=text->getscroll();
			up->enable(text->mayscroll(-1));
			down->enable(text->mayscroll(1));
		}
	}
	else if (v==1) page(pg+1);
	else if (v==-1)
	{
		if (pgbackindex>1)
		{
			pgbackindex--;
			page(pgback[pgbackindex-1]);
		}
		else
		{
				mp3stop();
				interfActive(ITF_SEQ,0);
		}
	}
	else if (v==4)
	{
		if (mp3)
		{
			mp3start(mp3,0);
			hp_play->setenable(0);
			hp_stop->setenable(1);
			volplus->setenable(1);
			volmoins->setenable(1);
			level->setenable(1);
		}
	}
	else if (v==5)
	{
		if (mp3)
		{
			mp3stop();
			hp_play->setenable(1);
			hp_stop->setenable(0);
			volplus->setenable(0);
			volmoins->setenable(0);
			level->setenable(0);
		}
	}
}

void icbseqkey(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_seq*)user)->cbkey((int)user2);
}


#define SEQ_X0 (((240-2*2)-44*3)/4)
#define SEQ_DX	(44+SEQ_X0)
#define SEQ_DY	(32+8)
#define SEQ_Y0	320-SEQ_DY



void Interf_seq::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);


	prev=Ctr_push_create(container,back,SEQ_X0+0*SEQ_DX,SEQ_Y0,44,32,"interf/nav/b_back.r",icbseqkey,this,(void*)-1);
	next=Ctr_push_create(container,back,SEQ_X0+SEQ_DX,SEQ_Y0,44,32,"interf/nav/b_next.r",icbseqkey,this,(void*)1);
	info=Ctr_push_create(container,back,SEQ_X0+2*SEQ_DX+5,SEQ_Y0+7,42,18,"interf/diapo/bout_info+.r",icbseqkey,this,(void*)1,0x109e);
	up=Ctr_push_create(container,back,SEQ_X0+2*SEQ_DX-10,SEQ_Y0,32,32,"interf/nav/up.r",icbseqkey,this,(void*)2,0x1f);
	down=Ctr_push_create(container,back,SEQ_X0+2*SEQ_DX+22,SEQ_Y0,32,32,"interf/nav/down.r",icbseqkey,this,(void*)3,0x1f);
	hp_play=Ctr_push_create(container,back,SEQ_X0+SEQ_DX,SEQ_Y0,32,32,"interf/sound/b_hp.r",icbseqkey,this,(void*)4,0x1f);
	hp_stop=Ctr_push_create(container,back,5,SEQ_Y0,32,32,"interf/sound/b_hp_pause.r",icbseqkey,this,(void*)5,0x1f);

	volmoins=Ctr_push_create(container,back,40,SEQ_Y0+3,26,26,"interf/zoom/b_zoommoins.r",icbseqvol,this,(void*)-1,0x1f);
	Bitmap* giflevel=rscGet("interf/zoom/zoom_level2.r");
	level=Ctr_button_create(container,back,68,SEQ_Y0+4,66,24,1);
	level->setsrcbmp(0,giflevel,-1,0);
	level->setlayer(0,0,0,0,0,LAYER_BLIT);
	level->setmask(0,1);
	volplus=Ctr_push_create(container,back,68+66+2,SEQ_Y0+3,26,26,"interf/zoom/b_zoomplus.r",icbseqvol,this,(void*)1,0x1f);

	up->setenable(0);
	down->setenable(0);
	next->setenable(0);
	hp_play->setenable(0);
	hp_stop->setenable(0);
	volmoins->setenable(0);
	volplus->setenable(0);
	level->setenable(0);


	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbseqclose,this,NULL,0x1f);

	cbvol(0);
	back->setalpha(255);
	page(pg);

	loaded=1;
}

void Interf_seq::unload()
{
	if (!loaded) return;
//	PRINTF("unload seq\n");
	back->link(NULL);
	delete back;
	list=NULL;
	text=NULL;
	hiding=0;
	loaded=0;
}


void Interf_seq::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

	page(0);
}

void Interf_seq::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_seq::clic(int x,int y)
{
	return NULL;
}
void Interf_seq::unclic(int x,int y)
{
}

void Interf_seq::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((mp3)&&(!mp3running())&&(hp_stop->getenable()))
	{
		mp3stop();
		hp_play->setenable(1);
		hp_stop->setenable(0);
		volplus->setenable(0);
		volmoins->setenable(0);
		level->setenable(0);
	}
	level->movesrcbmp(0,0,24*audioGetVolume());

	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_seq* Interf_seq_create(Container *c,Control* f)
{
	return new Interf_seq(c,f);
}

