//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "poi.h"

#define SIMPLE_TIMEOUT 20000

Interf_simple::Interf_simple(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	menu=NULL;
	count=0;
	scrollpos=countscroll=0;
	scrollmax=2;
	icons=rscGet("interf/select/barre_menu_haut_full.r");
	menu=new Bitmap(icons->width*2,22);
	lastlang=0;
}

Interf_simple::~Interf_simple()
{
	hide();
	unload();
	link(NULL);
	if (menu) delete menu;
	if (icons) rscUnuseit(icons);
}

void Interf_simple::scroll(int state,int dir)
{
//	PRINTF("cbsimple %d\n",dir);
	t0=GetTickCount();
	if (state==CBBUTTON_UP)
	{
		int ns=scrollpos+dir;
		choices->movesrcbmp(0,scrollpos*175,0);
		countscroll=dir>0?35:-35;
		scrollpos=ns;
	}
}

void icbsimplescroll(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	((Interf_simple*)user)->scroll(state,(int)user2);
}

void Interf_simple::cbcancel()
{
//	PRINTF("cbcancel\n");
	poilist->setsimple(0,1);
	imap->updatepoi();
	redrawbar();
	interfActive(ITF_SIMPLE,0);
}

void icbsimplecancel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_simple*)user)->cbcancel();
}


const int simple_limit[7]=
{
	0,87,175,215,308,350,525
};

int getchoice(int x)
{
	for(int i=0;i<5;i++) if (x<simple_limit[i+1]) return i;
	return 6;
}

void Interf_simple::cbchoice(int x)
{
	t0=GetTickCount();
	x+=scrollpos*175;
	int val=getchoice(x);

//	PRINTF("choice %d\n",val);
	if (val>=5)
	{
		int i=poilist->getcurrenttype();
		if (i>=1000)
		{
			Poi* p=poilist->getnth(i-1000);
			ipoi->poigo(p,-1,NULL,NULL);
//			int px=poilist->getpoix(p);
//			int py=poilist->getpoiy(p);
//			if ((px)||(py)) imap->moveto(px,py,1);
		}

	}
	else
	{
		poilist->setsimple(val,1);
		imap->updatepoi();
		redrawbar();
	}
}

void icbsimplech(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_simple*)user)->cbchoice(x);
}


void Interf_simple::redrawbar()
{
	int x=ilang->getlang();
	if (x!=lastlang)
	{
		lastlang=x;
		if (icons) rscUnuseit(icons);
		icons=rscGet((lastlang==LANG_JP)?"interf/select/barre_menu_haut_full_jp.r":"interf/select/barre_menu_haut_full.r");
		if (!icons) return;
	}
	int i=poilist->getcurrenttype();

	if ((i>=1000)||(i<0))
	{
		menu->blit(0,(menu->height-(icons->height>>1))>>1,icons,0,0,icons->width,icons->height>>1,-1);
		menu->blit(icons->width,(menu->height-(icons->height>>1))>>1,icons,0,0,icons->width,icons->height>>1,-1);
		char txt[256];
		if (i<0)
		{
			char buf[32];
			sprintf(buf,"loc_C%d",-i);
			strcpy(txt,ilang->loc(buf));
		}
		else strcpy(txt,poilist->getdesclocal(poilist->getnth(i-1000)));

		if (extstrlen(txt)>25) strcpy(txt+25,"...");
		i=5;
		menu->drawtextbox(357,3,518-357,16,ALIGN_CENTER+ALIGN_VCENTER,txt,strlen(txt),0xffff,-1,font_normal);
		menu->drawtextbox(icons->width+357,3,518-357,16,ALIGN_CENTER+ALIGN_VCENTER,txt,strlen(txt),0xffff,-1,font_normal);
		printf("select %s\n",txt);

		scrollmax=3;
	}
	else
	{
		menu->blit(0,(menu->height-(icons->height>>1))>>1,icons,0,0,icons->width,icons->height>>1,-1);
		menu->blit(350,(menu->height-(icons->height>>1))>>1,icons,0,0,icons->width,icons->height>>1,-1);
		menu->blit(simple_limit[i],(menu->height-(icons->height>>1))>>1,icons,simple_limit[i],icons->height>>1,simple_limit[i+1]-simple_limit[i],icons->height>>1,-1);
		menu->blit(350+simple_limit[i],(menu->height-(icons->height>>1))>>1,icons,simple_limit[i],icons->height>>1,simple_limit[i+1]-simple_limit[i],icons->height>>1,-1);
		scrollmax=2;
	}
}

void Interf_simple::load()
{
	if (loaded) return;

	bar=Ctr_button_create(container,this,2,0,236,38,1);
	bar->setsrcbmp(0,rscGet("interf/select/simple_barre_fond.r"),0x1f,0);
	bar->setlayer(0,0,0,0,0,LAYER_BLIT);
	bar->setmask(0,1);

	choices=Ctr_button_create(container,bar,28,8,175,22,1);
	choices->setsrcbmp(0,menu,-1,0);
	choices->setlayer(0,0,0,0,0,LAYER_BLIT);
	choices->setmask(0,1);
	choices->setcb(icbsimplech,(void*)this,(void*)0);

//	left=Ctr_push_create(container,bar,7,7,26,26,"interf/nav/b_scroll_l.r",icbsimplescroll,this,(void*)-1,0x1f);
	right=Ctr_push_create(container,bar,7,9,20,20,"interf/nav/b_scroll_l2.r",icbsimplescroll,this,(void*)1,0x1f);
//	cancel=Ctr_push_create(container,bar,210,8,22,22,"interf/nav/fermer_petit.r",icbsimplecancel,this,(void*)NULL,0x1f);

	cancel=Ctr_push_create(container,bar,207,5,28,28,"interf/nav/fermer_petit.r",icbsimplecancel,this,(void*)NULL,0x1f);
	


	loaded=1;
	redrawbar();
}

void Interf_simple::unload()
{
	if (!loaded) return;

//##	loaded=0;
}

void Interf_simple::show()
{
	t0=GetTickCount();
	if (!loaded) load();

	int v=poilist->getcurrenttype();

	PRINTF("####v=%d\n",v);
	if (scrollmax==3) scrollpos=2;
	else scrollpos=1;
//	if ((v>=0)&&(v<2)) scrollpos=0;

	countscroll=0;
	choices->movesrcbmp(0,scrollpos*175,0);

	bar->setpos(2,-42);
	bar->move(0,4,11);
	setenable(1);
}

void Interf_simple::hide()
{
//	if (!loaded) unload();
//	setenable(0);
	bar->setpos(2,2);
	bar->move(0,-4,11);
}

Control* Interf_simple::clic(int x,int y)
{
	return NULL;
}
void Interf_simple::unclic(int x,int y)
{
}

void Interf_simple::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if (count)
	{
		if (!(--count))
		{
			setenable(0);

		}
	}
/*	if (GetTickCount()-t0>SIMPLE_TIMEOUT)
	{
		interfActive(ITF_SIMPLE,0);
	}
*/	if (countscroll)
	{
		if (countscroll>0) countscroll--;
		else countscroll++;
		if ((!countscroll)&&(scrollpos>=scrollmax)) scrollpos=0;
		choices->movesrcbmp(0,scrollpos*175-countscroll*5,0);
	}
}

Interf_simple* Interf_simple_create(Container *c,Control* f)
{
	return new Interf_simple(c,f);
}

