//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "gps.h"


Interf_start::Interf_start(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_start::~Interf_start()
{
	hide();
	unload();
	link(NULL);
}

void icbstartclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_START,0);
	}
}
void icbstartgps(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		iiti->setorg(gps_x,gps_y);
		iiti->update();
		interfActive(ITF_START,0);
		interfActive(ITF_ITI,1);
		interfActive(ITF_ZOOM,1);
	}
}

void icbstarthotel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	Poi* p=poilist->getstart();
	if ((p)&&(state==CBBUTTON_UP))
	{
		int px=poilist->getpoix(p);
		int py=poilist->getpoiy(p);
		iiti->setorg(px,py);
		iiti->update();
		interfActive(ITF_START,0);
		interfActive(ITF_ITI,1);
		interfActive(ITF_ZOOM,1);
	}
}


void icbstartsel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		interfActive(ITF_START,0);
		isel->settype(ITF_ITI);
		interfActive(ITF_SEL,1);
	}
}

void Interf_start::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_start_title"));

	Ctr_push_create(container,back,8,40,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_start_hotel"),font_subtitle,2),icbstarthotel,this,NULL);
	Ctr_push_create(container,back,8,80,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_start_gps"),font_subtitle,2),icbstartgps,this,NULL);
	Ctr_push_create(container,back,8,120,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_start_map"),font_subtitle,2),icbstartsel,this,NULL);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbstartclose,this,NULL,0x1f);

	loaded=1;
}

void Interf_start::unload()
{
	if (!loaded) return;

//	PRINTF("unload start\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_start::show()
{
	if (!loaded) load();

	back->setpos(242,2);
	back->move(-40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_start::hide()
{
	back->setpos(2,2);
	back->move(40,0,6);
	hiding=1;
}

Control* Interf_start::clic(int x,int y)
{
	return NULL;
}
void Interf_start::unclic(int x,int y)
{
}

void Interf_start::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_start* Interf_start_create(Container *c,Control* f)
{
	return new Interf_start(c,f);
}

