//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"
#include "metro.h"

#define STATION_TIMEOUT 10000

Interf_station::Interf_station(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	count=0;
	station=-1;
}

Interf_station::~Interf_station()
{
	hide();
	unload();
	link(NULL);
}


void Interf_station::cbcancel()
{
//	PRINTF("cbcancel\n");
	interfActive(ITF_STATION,0);
}

void icbstationcancel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_station*)user)->cbcancel();
}


void Interf_station::cbgo()
{
	if (station>=0)
	{
		iiti->setdst(metro->getstationx(station),metro->getstationy(station));
		interfActive(ITF_STATION,0);
		interfActive(ITF_START,1);
	}
}

void icbstationgo(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_station*)user)->cbgo();
}


void Interf_station::redrawbar(int st)
{
	if (!loaded) return;
	station=st;
	PRINTF("Station %d\n",st);
	bmp->empty(0x1f);
	if (station>=0)
	{
		Bitmap* lignes=rscGet("interf/lignes.r");
		metro->lignesfromstation(station);
		int x=0;
		for(int i=0;i<NBLIGNES;i++)
			if (metro->stationslignes[i])
			{
				bmp->blit(x,3,lignes,i*25,0,25,25,0x1f);
				x+=25;
			}
		char* p=metro->getstationname(station);
		bmp->drawtextboxEx(x,0,156-x,30,ALIGN_CENTER+ALIGN_VCENTER,p,strlen(p),0,-1,font_normal,font_note);
		rscUnuseit(lignes);
	}
}

void Interf_station::load()
{
	if (loaded) return;

	bar=Ctr_button_create(container,this,0,0,240,40,1);
	bar->setsrcbmp(0,rscGet("interf/select/simplebar.r"),0x1f,0);
	bar->setlayer(0,0,0,0,0,LAYER_BLIT);
	bar->setmask(0,1);

	bmp=new Bitmap(156,30);

	display=Ctr_button_create(container,bar,35,5,156,30,1);
	display->setsrcbmp(0,bmp,0x1f,0);
	display->setlayer(0,0,0,0,0,LAYER_BLIT);
	display->setmask(0,1);

	go=Ctr_push_create(container,bar,7,7,26,26,"interf/b_steps.r",icbstationgo,this,(void*)1,0x1f);
	cancel=Ctr_push_create(container,bar,202,7,26,26,"interf/nav/b_fermer.r",icbstationcancel,this,(void*)NULL,0x1f);



	loaded=1;
}

void Interf_station::unload()
{
	if (!loaded) return;

//##	loaded=0;
}

void Interf_station::show()
{
	PRINTF("Station show\n");
	t0=GetTickCount();
	if (!loaded) load();

	bar->setpos(0,-40);
	bar->move(0,4,11);
	setenable(1);
}

void Interf_station::hide()
{
//	if (!loaded) unload();
//	setenable(0);
	bar->setpos(0,4);
	bar->move(0,-4,11);
}

Control* Interf_station::clic(int x,int y)
{
	return NULL;
}
void Interf_station::unclic(int x,int y)
{
}

void Interf_station::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if (count)
	{
		if (!(--count))
		{
			setenable(0);

		}
	}
	if (GetTickCount()-t0>STATION_TIMEOUT)
	{
		interfActive(ITF_STATION,0);
	}
}

Interf_station* Interf_station_create(Container *c,Control* f)
{
	return new Interf_station(c,f);
}

