//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"


Interf_tools::Interf_tools(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
}

Interf_tools::~Interf_tools()
{
	hide();
	unload();
	link(NULL);
}


void icbtoolsclose(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_TOOLS,0);
}

void icbtoolsdico(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_DICOLIST,1);
}

void icbtoolsconv(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_CONVLIST,1);
}

void icbtoolsadmin(Ctr_button *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) interfActive(ITF_PWD,1);
}

void icbtoolsguide(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		iseq->getseq(ilang->loc("loc_guide_seq"));
		interfActive(ITF_SEQ,1);
	}
}


void icbtoolspower(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP)
	{
		ipower->setclosewhenoff(0);
		interfActive(ITF_TOOLS,0);
		interfActive(ITF_POWER,1);
	}
}

#define TOOLS_Y0	(40)
#define TOOLS_DY	(32+4)


void Interf_tools::load()
{
	if (loaded) return;

	back=Ctr_back_create(container,this,2,2,240-2*2,320-2*2);

	back->drawtitle(ilang->loc("loc_tools_title"));

	Ctr_push_create(container,back,8,TOOLS_Y0+0*TOOLS_DY,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_tools_guide"),font_subtitle,2),icbtoolsguide,this,(void*)NULL);
	Ctr_push_create(container,back,8,TOOLS_Y0+1*TOOLS_DY,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_tools_dico"),font_subtitle,2),icbtoolsdico,this,(void*)NULL);
	Ctr_push_create(container,back,8,TOOLS_Y0+2*TOOLS_DY,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_tools_convert"),font_subtitle,2),icbtoolsconv,this,(void*)NULL);
	Ctr_push_create(container,back,8,TOOLS_Y0+3*TOOLS_DY,220,32,rscButton("interf/skin/b1.r",ilang->loc("loc_tools_power"),font_subtitle,2),icbtoolspower,this,(void*)NULL);

	Ctr_push_create(container,back,198,6,28,28,"interf/nav/b_close.r",icbtoolsclose,this,NULL,0x1f);

	Bitmap* b=back->getback();
	b->drawline(b->width-5,b->height-1,b->width-5,b->height-5,(short)COL_TITLE);
	b->drawline(b->width-5,b->height-5,b->width-1,b->height-5,(short)COL_TITLE);
	b->drawline(b->width-1,b->height-5,b->width-1,b->height-1,(short)COL_TITLE);

	Ctr_button_create(container,back,240-32,320-32,28,28,0)->setcb(icbtoolsadmin,(void*)this,(void*)NULL);


	loaded=1;
}

void Interf_tools::unload()
{
	if (!loaded) return;

//	PRINTF("unload i\n");
	back->link(NULL);
	delete back;
	hiding=0;
	loaded=0;
}

void Interf_tools::show()
{
	if (!loaded) load();

	back->setpos(-238,2);
	back->move(40,0,6);
	setenable(1);
	hiding=0;

}

void Interf_tools::hide()
{
	back->setpos(2,2);
	back->move(-40,0,6);
	hiding=1;
}

Control* Interf_tools::clic(int x,int y)
{
	return NULL;
}
void Interf_tools::unclic(int x,int y)
{
}

void Interf_tools::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	if ((hiding)&&(!back->moving()))
	{
		unload();
	}
}

Interf_tools* Interf_tools_create(Container *c,Control* f)
{
	return new Interf_tools(c,f);
}

