//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "param.h"
#include "control.h"
#include "interf.h"
#include "bitmap.h"
#include "rsc.h"

#define ZOOM_TIMEOUT 10000


Interf_zoom::Interf_zoom(Container *c,Control* f):Control(c,f,0,0,0,0)
{
	loaded=0;
	setenable(0);
	bar=NULL;
	zoomin=zoomout=cancel=NULL;
	count=0;
}

Interf_zoom::~Interf_zoom()
{
	hide();
	unload();
	link(NULL);
}

void Interf_zoom::zoom(int in,int state)
{
//	PRINTF("cbzoom %d - %d\n",in,state);
	t0=GetTickCount();
	if (state==CBBUTTON_DOWN) imap->zoomd(in);
	else imap->zoomstop();
}

void icbzoomchg(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	((Interf_zoom*)user)->zoom((int)user2,state);
}

void Interf_zoom::cbcancel()
{
//	PRINTF("cbcancel\n");
	interfActive(ITF_ZOOM,0);
}

void icbcancel(Ctr_push *b,int x,int y,int state,void* user,void* user2)
{
	if (state==CBBUTTON_UP) ((Interf_zoom*)user)->cbcancel();
}

void Interf_zoom::load()
{
	if (loaded) return;
	Bitmap* giflevel=rscGet("interf/zoom/zoom_level2.r");

	bar=Ctr_button_create(container,this,2,286,234,34,1);
	bar->setsrcbmp(0,rscGet("interf/zoom/zoom_barre2.r"),0x1f,0);
	bar->setlayer(0,0,0,0,0,LAYER_BLIT);
	bar->setmask(0,1);

	level=Ctr_button_create(container,bar,70,5,66,24,1);
	level->setsrcbmp(0,giflevel,-1,0);
	level->setlayer(0,0,0,0,0,LAYER_BLIT);
	level->setmask(0,1);

	zoomin=Ctr_push_create(container,bar,4,4,54,26,
		(ilang->getlang()==LANG_JP)?"interf/zoom/b_zoommoins2_jp.r":"interf/zoom/b_zoommoins2.r",icbzoomchg,this,(void*)0,0x1f);
	zoomout=Ctr_push_create(container,bar,145,4,54,26,
		(ilang->getlang()==LANG_JP)?"interf/zoom/b_zoomplus2_jp.r":"interf/zoom/b_zoomplus2.r",icbzoomchg,this,(void*)1,0x1f);
	cancel=Ctr_push_create(container,bar,202,4,26,26,"interf/nav/b_fermer.r",icbcancel,this,(void*)NULL,0x1f);
	langupdate();

	loaded=1;
}

void Interf_zoom::langupdate()
{
	if (!loaded) return;
	zoomin->bmpupdate((ilang->getlang()==LANG_JP)?"interf/zoom/b_zoommoins2_jp.r":"interf/zoom/b_zoommoins2.r");
	zoomout->bmpupdate((ilang->getlang()==LANG_JP)?"interf/zoom/b_zoomplus2_jp.r":"interf/zoom/b_zoomplus2.r");
}

void Interf_zoom::unload()
{
	if (!loaded) return;

//##	loaded=0;
}

void Interf_zoom::show()
{
	t0=GetTickCount();
	if (!loaded) load();

	bar->setpos(2,332);
	bar->move(0,-4,12);
	setenable(1);
}

void Interf_zoom::hide()
{
//	if (!loaded) unload();
//	setenable(0);
	bar->setpos(2,284);
	bar->move(0,4,12);
}

Control* Interf_zoom::clic(int x,int y)
{
	return NULL;
}
void Interf_zoom::unclic(int x,int y)
{
}

void Interf_zoom::draw(Bitmap *bmp,int dx,int dy)
{
	if (!loaded) return;
	level->movesrcbmp(0,0,24*(5-imap->getscale()));
	if (GetTickCount()-t0>ZOOM_TIMEOUT) interfActive(ITF_ZOOM,0);
	if (count)
	{
		if (!(--count))
		{
			setenable(0);

		}
	}
}

Interf_zoom* Interf_zoom_create(Container *c,Control* f)
{
	return new Interf_zoom(c,f);
}

