//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include<windows.h>
#include<windowsx.h>
#include<wingdi.h>
#include<stdio.h>
#include<string.h>

#include "param.h"

#ifdef POCKETPC
#include<Aygshell.h>
#endif

#include "mainwindow.h"
#include "container.h"
#include "control.h"
#include "interf.h"
#include "file.h"
#include "hash.h"

#include "gps.h"

#include "rsc.h"

#include "metro.h"

extern "C" {
#include "mp3/audio.h"
} 


Ctr_text* c6;


HWND crText (display_type *text,HWND Parent,int x, int y, int w,int h)
{
	HWND hwnd;
	int Flags=ES_READONLY|WS_CHILD  ;

	hwnd=CreateWindowEx ( WS_EX_CLIENTEDGE ,
	TEXT("Edit"),
	text , Flags ,
	x,y,w,h,
	Parent , NULL ,
	NULL/*thisinst*/ , NULL ) ;
    ShowWindow(hwnd,SW_SHOW);
    UpdateWindow(hwnd);
	return hwnd;
}

HWND crMultiline(display_type *text,HWND Parent,int x, int y, int w,int h)
{
	HWND hwnd;
	int Flags=WS_CHILD | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL |WS_HSCROLL|WS_VSCROLL|ES_READONLY ;

	hwnd=CreateWindowEx ( WS_EX_CLIENTEDGE ,
	TEXT("Edit"),
	text , Flags ,
	x,y,w,h,
	Parent , NULL ,
	NULL/*thisinst*/ , NULL ) ;
    ShowWindow(hwnd,SW_SHOW);
    UpdateWindow(hwnd);
	return hwnd;
}


MainWindow::MainWindow(HINSTANCE this_inst,int cmdshow)
{
	back=new Bitmap(WIDTH,HEIGHT);
#ifdef POCKETPC
	mainwin =  CreateWindow(TEXT("MainWindowClass"),TEXT("Tao"), WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,WIDTH,HEIGHT,NULL,NULL,this_inst,NULL);
#else
	RECT r;
	BITMAPINFO *Bi ;
	int tf ;
	HDC dc ;
	DIBSECTION mainbmpinfo ;
	
	dc = NULL ;

	char *p=new char[1024];
	memset(p,0,1024);
	Bi=(BITMAPINFO*)p;
	Bi->bmiHeader.biSize = sizeof ( BITMAPINFOHEADER ) ;
	Bi->bmiHeader.biWidth = WIDTH ;
	Bi->bmiHeader.biHeight = -HEIGHT ;
	Bi->bmiHeader.biPlanes = 1 ;
	Bi->bmiHeader.biBitCount = 16 ;
	Bi->bmiHeader.biCompression = BI_BITFIELDS;//BI_RGB ;
	Bi->bmiHeader.biSizeImage = 0 ;
	Bi->bmiHeader.biXPelsPerMeter = 0 ;
	Bi->bmiHeader.biYPelsPerMeter = 0 ;
	Bi->bmiHeader.biClrUsed = 0 ;
	((int*)Bi->bmiColors)[0]=0xF800;
	((int*)Bi->bmiColors)[1]=0x07E0;
	((int*)Bi->bmiColors)[2]=0x001F;
	tf = DIB_RGB_COLORS ;
	Bi->bmiHeader.biClrImportant = Bi->bmiHeader.biClrUsed ;
	mainbmp = CreateDIBSection ( dc , Bi , tf , (void**)&start , NULL , 0 ) ;
	GetObject ( mainbmp , sizeof( DIBSECTION ) , &mainbmpinfo ) ;

	r.left=0;
	r.top=0;
	r.right=WIDTH;
	r.bottom=HEIGHT;
	AdjustWindowRect(&r,WS_POPUP,FALSE);
	mainwin =  CreateWindow(TEXT("MainWindowClass"),TEXT("Tao"), WS_POPUP,
        600,100,r.right-r.left,r.bottom-r.top,
        NULL,NULL,this_inst,NULL);

#endif
	SetWindowLong(mainwin,GWL_USERDATA,(long)this);

/*
	crText(TEXT("-"),mainwin,0,0,240,44);
	crMultiline(TEXT(""),mainwin,0,44,240,HEIGHT-44);
    ShowWindow(mainwin,SW_SHOW);
    UpdateWindow(mainwin);

	Sleep(2000);
*/
#ifdef POCKETPC
	if (GXOpenDisplay(mainwin, GX_FULLSCREEN) == 0) return;
	GXOpenInput();
	g_gxdp = GXGetDisplayProperties();
	g_gxkl = GXGetDefaultKeys(GX_NORMALKEYS);

#endif
#ifdef POCKETPC
	SHFullScreen(mainwin, SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON|SHFS_HIDESTARTICON);

    ShowWindow(mainwin,cmdshow);
    UpdateWindow(mainwin);

	SetWindowPos(mainwin, HWND_TOPMOST, 0, 0, 240, 320, SWP_SHOWWINDOW);
	InvalidateRect(mainwin, NULL, false);
	UpdateWindow(mainwin);
#else
    ShowWindow(mainwin,SW_SHOW);
    UpdateWindow(mainwin);
#endif

	SetTimer(mainwin,1,1,NULL);

	mp3setwin(mainwin);
	audioSetVolume(3);
#ifdef POCKETPC
	audioSetVolume(4);
#endif
	gpsStart();
	count=0;

//	mp3start(mainwin,"rach.mp3");
	//"voix_nathan-mono-32kbps.mp3");


	container=new Container(this,0x8200);
	interfInit(container);
	poilistInit();
	gpsResetpos();
	imap->moveto(gps_x,gps_y,50);

	battery=Ctr_button_create(container,NULL,240-36,284-20,32,16,1);
	battery->setsrcbmp(0,rscGet("interf/battery.r"),0x1f,0);
	battery->setlayer(0,0,0,0,0,LAYER_BLIT);
	battery->setmask(0,1);

	disableuseruntil=lasttimeofday=timeofday();
	disableuseruntil=GetTickCount();
	container->draw();
//	metro->solve(metro->getstationx(18),metro->getstationy(18),metro->getstationx(267),metro->getstationy(267));
//	metro->solve(metro->getstationx(267),metro->getstationy(267),metro->getstationx(18),metro->getstationy(18));
//	PRINTF("dist=%d\n",metro->dist(metro->getstationx(266),metro->getstationy(266),metro->getstationx(267),metro->getstationy(267)));
}

int MainWindow::timeofday()
{
	SYSTEMTIME s;
	GetLocalTime(&s);
	return (s.wHour*60+s.wMinute)*60+s.wSecond;
}

#define DAY_LENGTH (24*3600)


void MainWindow::pausedetect()
{
	int t=timeofday();
	int gtc=GetTickCount();
	int d=t-lasttimeofday;
	if(d<0) d+=DAY_LENGTH;
	lasttimeofday=t;
	if ((d>1)||(d<0))
	{
		disableuseruntil=gtc+3*1000;
		gpsReset();
	}
	else if (disableuseruntil-gtc<0) disableuseruntil=gtc;
}

int MainWindow::checkdisable()
{
	int t=GetTickCount()-disableuseruntil;
	if (t<0) return 1;
	return 0;
}


MainWindow::~MainWindow()
{
#ifdef POCKETPC
	GXCloseDisplay();
	GXCloseInput();
#else
	DeleteObject(mainbmp);
#endif
	delete back;
}

#ifndef POCKETPC
void MainWindow::winrepaint()
{
	
    HDC Dcw,Dcb;
    PAINTSTRUCT ps;
	
	Dcw=BeginPaint(mainwin,&ps);
	Dcb=CreateCompatibleDC(Dcw);
	SelectObject(Dcb, mainbmp);
	BitBlt ( Dcw, 0, 0, WIDTH, HEIGHT, Dcb, 0, 0, SRCCOPY);
	DeleteDC ( Dcb ) ;	
	EndPaint(mainwin,&ps);
}

void MainWindow::winupdate()
{
	InvalidateRect(mainwin,NULL,FALSE);
    UpdateWindow(mainwin);
}
#endif

void MainWindow::movemouse(short x,short y)
{
	if (checkdisable()) return;
	container->moveclic(x,y);
}

void MainWindow::clickmouse(short x,short y,int state)
{
/*	if ((state)&&(x<20)&&(y<20))
	{
		delete this;
		PostQuitMessage(0);
		return;
	}
*/
	if (checkdisable()) return;
	if (state)container->clic(x,y);
	else container->unclic(x,y);
}

unsigned char header16[0x36]={
	0x42,0x4d,0x36,0x58,0x02,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x00,0x00,0x28,0x00,
	0x00,0x00,0xf0,0x00,0x00,0x00,0x40,0x01,0x00,0x00,0x01,0x00,0x10,0x00,0x00,0x00,
	0x00,0x00,0x00,0x58,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00
};

#define RGB16TO15(col) (col&0x1f)+((col>>1)&0x7fe0)

void MainWindow::saveback()
{
#ifndef POCKETPC
	char buf[128];
	sprintf(buf,"cap/tao-%d.bmp",GetTickCount());
	FILE *f=fopen(buf,"wb+");
	if (f)
	{
		fwrite(header16,0x36,1,f);
		for(int j=0;j<320*240;j++) back->start[j]=RGB16TO15(back->start[j]);
		for(int i=0;i<320;i++)
			fwrite(back->start+240*(319-i),240*2,1,f);
		fclose(f);
		PRINTF("dump picture %s\n",buf);
	}
#endif
}


int t0=0;
int fps=0;

int test=0;
int ip=0;

void MainWindow::timer()
{
	pausedetect();
	if (test==1)
	{
		if(ip<poilist->getnpoi())
		{
			ipoi->poiset(poilist->getnth(ip));
			interfActive(ITF_POI,1);
			ip++;
		}
		else test=0;
	}
	battery->setenable(ipower->getpower()<20?(GetTickCount()>>9)&1:0);
	if (!count)
	{
#ifdef POCKETPC
#ifndef OPHRYS
	SHFullScreen(mainwin, SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON|SHFS_HIDESTARTICON);

    ShowWindow(mainwin,SW_SHOW);
    UpdateWindow(mainwin);

	SetWindowPos(mainwin, HWND_TOPMOST, 0, 0, 240, 320, SWP_SHOWWINDOW);
	InvalidateRect(mainwin, NULL, false);
    UpdateWindow(mainwin);
#endif
#endif
//		gpsTimer();
//		sprintf(buf,"%dx%d %d/%d",gps_x,gps_y,mp3counter(),mp3length());
/*
#ifdef POCKETPC
		SYSTEM_POWER_STATUS_EX2 sps;
		if (GetSystemPowerStatusEx2(&sps,sizeof(sps),FALSE))
#else
		SYSTEM_POWER_STATUS sps;
		if (GetSystemPowerStatus(&sps))
#endif
			sprintf(buf,"%d %d",sps.ACLineStatus,sps.BatteryLifePercent);
		else sprintf(buf,"cannot get power information");
*/
		imap->gpsnotify(gps_ok,gps_x,gps_y);
//		imain->setgps(gps_ok);
//		c4->setpos(gps_x-13,gps_y-13);
		if (ipower->checkpower())
		{
			ipanier->listclear();
			ipower->setclosewhenoff(1);
			interfActive(ITF_POWER,1);
			interfActive(ITF_LANG,1);
			if(poilist->getstart())
			{
				gpsResetpos();
			}
			interfActive(ITF_I,1);
		}
		poilist->checkreset();
	}
	count++;
	count&=63;
//	char *p=mp3debug();
//	c6->textupdate(p);
	container->draw();
	if (!count)
	{
		int t=GetTickCount();
		if (t0)
		{
			if (t!=t0) fps=64000/(t-t0);
			else fps=0;
		}
		t0=t;
	}
}


void MainWindow::blitback()
{
//	char buf[128];
//	sprintf(buf,"%d fps",fps);
//	back->drawtext(0,80,0,buf,strlen(buf),(short)RGBTO16(0xff,0xc0,0x00),-1,NULL);
//	back->drawtextbox(0,80,160,30,0,buf,strlen(buf),(short)RGBTO16(0xff,0xc0,0x00),-1,NULL);

#ifdef POCKETPC
	unsigned short *dst;

	dst = (unsigned short *)GXBeginDraw();
	if (dst == NULL) return; // NOT OK TO DRAW, return failure.
	memcpy(dst,back->start,WIDTH*HEIGHT*2);
	GXEndDraw();
#else
	if (start) memcpy(start,back->start,WIDTH*HEIGHT*2);
	else PRINTF("no bitmap\n");
	winupdate();
#endif
}

Bitmap* MainWindow::getback()
{
	return back;
}

#ifndef POCKETPC
void checkmp3()
{
	int i;
	PRINTF("---------checkmp3\n");
	for(i=0;i<poilist->getnpoi();i++)
	{
		char buffer[128];
		sprintf(buffer,"poi/%s",poilist->getname(poilist->getnth(i)));
		Hash* subdata=new Hash(16);
		subdata->load(buffer);

		if (strlen(subdata->get("Audio")))
		{
			sprintf(buffer,"mp3/%s",subdata->get("Audio"));
//			PRINTF("--------check mp3 %s\n",buffer);
			if (!fileCheck(buffer)) fprintf(logfile,"------>missing : %s\n",buffer);
		}

		if (strlen(subdata->get("AudioEn")))
		{
			sprintf(buffer,"mp3/%s",subdata->get("AudioEn"));
//			PRINTF("--------check mp3 %s\n",buffer);
			if (!fileCheck(buffer)) fprintf(logfile,"------>missing : %s\n",buffer);
		}
		delete subdata;
	}
}
#endif

LRESULT CALLBACK MainWindowProc( HWND hwnd, unsigned msg,
							UINT wParam, LONG lParam )
{
	//	displaystring bufmsg[1024];

	MainWindow *mainwin;

	mainwin=(MainWindow*)GetWindowLong(hwnd,GWL_USERDATA);
    switch( msg ) {
		
    case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_CREATE:
		break;

#ifndef POCKETPC
    case WM_PAINT:
		mainwin->winrepaint();
        break;
#endif
    case WM_MOUSEMOVE :
		mainwin->movemouse(LOWORD(lParam),HIWORD(lParam));
        break;
    case WM_LBUTTONDOWN :
		SetCapture(hwnd);
		mainwin->clickmouse(LOWORD(lParam),HIWORD(lParam),1);
		break;
	case WM_RBUTTONDOWN :
		mainwin->saveback();
		break;
    case WM_LBUTTONUP :
		if ((wParam & MK_RBUTTON)==0) ReleaseCapture();
		mainwin->clickmouse(LOWORD(lParam),HIWORD(lParam),0);
		break;
	case WM_KEYDOWN :
		printf("keydown =%d\n",wParam);
		if ((wParam==38)||(wParam==194)) audioSetVolume(audioGetVolume()+1);
		if ((wParam==40)||(wParam==196)) audioSetVolume(audioGetVolume()-1);
		break;
#ifndef POCKETPC
	case WM_CHAR :
		if (wParam=='t')
		{
			ip=0;
			test=(test==1)?0:1;
		}
		if (wParam=='m')
		{
			checkmp3();
		}
		break;
#endif
    case WM_TIMER:
		mainwin->timer();
		break;
	case MM_WOM_DONE:
		mainwin->pausedetect();
		if (mainwin->checkdisable()) mp3setpause(1);
		audioEventPlayData(msg,wParam,lParam);
		break;
    default:
        return( DefWindowProc( hwnd, msg, wParam, lParam ) );
    }
	
	return 0;
}


BOOL DeclareMainWindow( HINSTANCE this_inst )
{
    WNDCLASS    wc;
    BOOL        rc;
	
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (WNDPROC) MainWindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = this_inst;
    wc.hIcon = 0;
#ifdef POCKETPC
	wc.hCursor = 0;
#else
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
#endif
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = 0;
    wc.lpszClassName = TEXT("MainWindowClass");
    rc = RegisterClass( &wc );
	
    return( rc );
}




