//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _METRO_
#define _METRO_

#include"param.h"


#define NBLIGNES 19

class Metro
{
private:

	int* indlignes;
	int* indstations;
	int* xstations;
	int* ystations;
	int* indquais;

	char* dataquais;
	char* datanames;
	char* data;
	char* hotspots;

	int msbtoint(char *p);
	int msbtoshort(char *p);

	char* sortin;
	char* used;
	short* val;
	short* prec;

	int* indindex;
	char* dataindex;
	char* sel;

	int remsort();
	void remsort(int v);
	void insertsort(int q);
	int corrfromquai(int q,int n);
	void tryq(int u,int v,int k);
	int dist(int q,int x,int y);
	void dumpsort();

public:
	int nlignes;
	int nstations;
	int nquais;
	int nsort;
	short* sort;
	int timetodest;
	char stationslignes[NBLIGNES];

	Metro();
	~Metro();
	int load(char *filename);
	char* getlignename(int i);
	int getlinecolor(int i);
	char* getstationname(int i);
	int getstationx(int i);
	int getstationy(int i);
	int stationfromquai(int i);
	int lignefromquai(int i);

	int solve(int a,int b);
	int solve(int xo,int yo,int xd,int yd);
	int dist(int xo,int yo,int xd,int yd);
	int getnthquai(int i);
	int getnsteps();
	int gettime();
	int getindligne(int i);
	int isrer(int i);
	int hotspot(int x,int y,int scale,int dist);
	int lignesfromstation(int i);
	int select(char* key);
	int isselected(int i);
	int getnstations();


};

#endif