// Librairie Sound

#include<windows.h>
#include<winsock.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
//#include<io.h>
#include<time.h>

#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <mmsystem.h>
#include"mpg123.h"
#include"mpglib.h"
#include "audio.h"
//#include "vaudio.h"
#include"../param.h"

HWAVEOUT hWaveOut;

int nPlayBuffers;
WaveOutBuffer* WaveOutBuf;
int SendOutBuffers;
BOOL StopPlayback;
BOOL PlaybackInitialised;
int audioVol;
int* statewavebuf;


int OutFillBuffer(int i)
{
	int k,len;

	if (WaveOutBuf[i].lpData==NULL) return 0;

	k=mp3Fetch(WaveOutBuf[i].lpData,WaveOutBuf[i].dwDataSize);
//	PRINTF("#outfill %d/%d\n",k,WaveOutBuf[i].dwDataSize);
/*	for(k=0;k<WaveOutBuf[i].dwDataSize;k++)
	{
		WaveOutBuf[i].lpData[k]=((k/50)&1)?64:-64;
	}
	len=0;
*/	len=WaveOutBuf[i].dwDataSize-k;
	if (len>0)
	{
		if (WaveOutBuf[i].Resolution==8)
		    memset(WaveOutBuf[i].lpData+k,128,len);
		else
		    memset(WaveOutBuf[i].lpData+k,0,len);
	}
	return 0;
}

void WaveOutFreeAll()
{
	int i;
	PRINTF("WaveOutFreeAll\n");
	for (i=0;i<nPlayBuffers;i++)
	{
		waveOutUnprepareHeader(hWaveOut,WaveOutBuf[i].lpWaveHdr,sizeof(WAVEHDR));

		if (WaveOutBuf[i].lpData != NULL) GlobalUnlock(WaveOutBuf[i].hData);
		if (WaveOutBuf[i].hData) GlobalFree(WaveOutBuf[i].hData);

		if (WaveOutBuf[i].lpWaveHdr != NULL) GlobalUnlock(WaveOutBuf[i].hWaveHdr);
		if (WaveOutBuf[i].hWaveHdr) GlobalFree(WaveOutBuf[i].hWaveHdr);
	}
	memset(WaveOutBuf,0,nPlayBuffers*sizeof(WaveOutBuffer));
	PlaybackInitialised=FALSE;
	SendOutBuffers=0;
}

int PlayStart(HWND mainwin,int rate,int nChannels,int ChannelSize,int BitsPerSample,int nbBuffers)
{
	UINT wResult;
	PCMWAVEFORMAT pcmWaveFormat;
	int i,vol;

	if (!PlaybackInitialised)
	{

		// Open a waveform device for output using window callback.

		if (BitsPerSample<8) BitsPerSample=8;
		if (BitsPerSample>8) BitsPerSample=16;
		pcmWaveFormat.wf.wFormatTag=WAVE_FORMAT_PCM;
		pcmWaveFormat.wf.nChannels=nChannels;
		pcmWaveFormat.wf.nSamplesPerSec=rate;
		pcmWaveFormat.wf.nAvgBytesPerSec=rate*nChannels*(BitsPerSample/8);
		pcmWaveFormat.wf.nBlockAlign=(nChannels*BitsPerSample)/8;
		pcmWaveFormat.wBitsPerSample=BitsPerSample;

		wResult=waveOutOpen((LPHWAVEOUT)&hWaveOut, WAVE_MAPPER,
			  (LPWAVEFORMATEX)&pcmWaveFormat,
			  (LONG)mainwin, 0L, CALLBACK_WINDOW);
		if (wResult != 0)	return 0;

		vol=audioVol*255/5;
		waveOutSetVolume(hWaveOut,(vol<<24)+(vol<<8));

		nPlayBuffers=nbBuffers;
		if (WaveOutBuf) free(WaveOutBuf);
		WaveOutBuf=(WaveOutBuffer*)malloc(sizeof(WaveOutBuffer)*nPlayBuffers);
		if (statewavebuf) free(statewavebuf);
		statewavebuf=(int*)malloc(sizeof(int)*nPlayBuffers);


		for (i=0;i<nPlayBuffers;i++)
		{
			WaveOutBuf[i].nChannels=nChannels;
			WaveOutBuf[i].Rate=rate;
			WaveOutBuf[i].Resolution=BitsPerSample;
			WaveOutBuf[i].hwnd=mainwin;
			WaveOutBuf[i].dwDataSize=ChannelSize;
			statewavebuf[i]=0;

			// Allocate and lock memory for the waveform data.
			WaveOutBuf[i].hData = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE, WaveOutBuf[i].dwDataSize );
			if (!WaveOutBuf[i].hData) return 0;
			if ((WaveOutBuf[i].lpData = (char*)GlobalLock(WaveOutBuf[i].hData)) == NULL)
			{
				WaveOutFreeAll();
				return 0;
			}

			// Allocate and lock memory for the header.
			WaveOutBuf[i].hWaveHdr = GlobalAlloc(GMEM_MOVEABLE | GMEM_SHARE,(DWORD) sizeof(WAVEHDR));
			if (WaveOutBuf[i].hWaveHdr == NULL)
			{
				WaveOutFreeAll();
				return 0;
			}

			WaveOutBuf[i].lpWaveHdr = (LPWAVEHDR) GlobalLock(WaveOutBuf[i].hWaveHdr);
			if (WaveOutBuf[i].lpWaveHdr == NULL)
			{
				WaveOutFreeAll();
				return 0;
			}

			// After allocation, set up and prepare header.

			WaveOutBuf[i].lpWaveHdr->lpData = WaveOutBuf[i].lpData;
			WaveOutBuf[i].lpWaveHdr->dwBufferLength = WaveOutBuf[i].dwDataSize;
			WaveOutBuf[i].lpWaveHdr->dwUser = i;
			WaveOutBuf[i].lpWaveHdr->dwFlags = 0L;
			WaveOutBuf[i].lpWaveHdr->dwLoops = 1L;
			wResult = waveOutPrepareHeader(hWaveOut,WaveOutBuf[i].lpWaveHdr,sizeof(WAVEHDR));
			if (wResult != 0)
			{
				wResult=waveOutClose(hWaveOut);
				WaveOutFreeAll();
				return 0;
			}
		}
	}

	PlaybackInitialised=TRUE;
	StopPlayback=FALSE;

	for (i=0;i<nPlayBuffers;i++)
		if (statewavebuf[i]==0)
		{
			// Now the data block can be sent to the output device. The
			// waveOutWrite function returns immediately and waveform
			// data is sent to the output device in the background.
			if (WaveOutBuf[i].Resolution==8)
				memset(WaveOutBuf[i].lpData,128,WaveOutBuf[i].dwDataSize);
			else
				memset(WaveOutBuf[i].lpData,0,WaveOutBuf[i].dwDataSize);
			wResult = waveOutWrite(hWaveOut,WaveOutBuf[i].lpWaveHdr,sizeof(WAVEHDR));
			if (wResult != 0)
			{
				wResult=waveOutReset(hWaveOut);
				wResult=waveOutClose(hWaveOut);
				WaveOutFreeAll();
				return 0;
			}
			statewavebuf[i]=1;
			SendOutBuffers++;
		}
	return 1;
}

int PlayStop()
{
	StopPlayback=TRUE;
	return 0;
}

int PlayKill()
{
	PRINTF("#############################kill play\n");
	WaveOutFreeAll();
	StopPlayback=FALSE;
	waveOutClose(hWaveOut);
	return 0;
}

int PlayData(int i)
{
	WORD wResult;

	PRINTF("###playdata ----> %d\n",i);
	statewavebuf[i]=0;
	SendOutBuffers--;
	if (!StopPlayback)
	{
		OutFillBuffer(i);
		wResult = waveOutWrite(hWaveOut,WaveOutBuf[i].lpWaveHdr,sizeof(WAVEHDR));
		if (wResult != 0)
		{
			WaveOutFreeAll();
			return 0;
		}
		statewavebuf[i]=1;
		SendOutBuffers++;
	}
	else
	{
		if (!SendOutBuffers)
		{
			PlayKill();
		}
	}
	return 1;
}

int audioEventPlayData(int eventId, int wParam, int lParam)
{
//	PRINTF("###play cb\n");
	if(!PlaybackInitialised) return 0;
	PlayData(((LPWAVEHDR)lParam)->dwUser);
	return 0;
}

int audioInit()
{
	nPlayBuffers=0;
	SendOutBuffers=0;
	StopPlayback=FALSE;
	PlaybackInitialised=FALSE;
	audioVol=0xff;
	WaveOutBuf=NULL;
	statewavebuf=NULL;

	return 0;
}

void audioSetVolume(int vol)
{
	if (vol<0) vol=0;
	if (vol>5) vol=5;
	audioVol=vol;

	vol=audioVol*255/5;
	if (PlaybackInitialised) waveOutSetVolume(hWaveOut,(vol<<24)+(vol<<8));
}
int audioGetVolume()
{
	return audioVol;
}
