//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#ifndef _POI_
#define _POI_

#include"param.h"


typedef struct
{
  int num;
  int id;
  int desc;
  int index;
  int x;
  int y;
  int tp;
  int cat;
  int zoom;
  int meta;
  int icon;
  int audioonly;
  int perso;
  int score;
  int tmp;	// valeur utilise pour indiquer les poi en cours d'affichage
  int sort;	// valeur utilise pour trier les poi par score dcroissant -> pointe vers un autre poi
  int tl;
  int select;
} Poi;


class Poilist
{
private:
	int npoi;
	Poi *tpoi;
	int ncrit;
	char* tcrit;

	char *names;
	char *desc;
	char *index;

	int notnul;
	int curtype;
	int msbtoint(char *p);

	Poi* poistart;

	int lasttimechg;
	void touch();

public:
	Poilist();
	~Poilist();
	int load(char *filename);
	int getbest(Poi** tb,int nmax,int xmin,int xmax,int ymin,int ymax,int scale,int dist);

	void clearscore();
	void mergecritt(int n,int coeff);
	void mergetype(int tp,int val);

	void currentcrit(int n,int addstart);
	void setcrit(int n,int addstart);
	void setsimple(int n,int addstart);
	void setpoi(int poi);


	int getcurrenttype();
	char* getname(Poi* p);
	char* getdesclocal(Poi* p);
	char* getdescn(Poi* p,int n);
	char* getdesclocalized(Poi* p);


	int getnpoi();
	Poi* getnth(int i);
	int score(int poi,int i);
	Poi* getstart();
	int select(char* key);
	void setscore(Poi* p,int i);
	int getscore(Poi* p);
	void sort();
	int nbsorted();
	Poi* nthsorted(int i);

	int getpoix(Poi* p);
	int getpoiy(Poi* p);

	int conc(int p,int q);
	void divide(int p,int *q,int *r);
	int quicksort(int p);
	void dump(int p);

	void checkreset();

};

int poilistInit();
int poilistReload();

extern Poilist* poilist;


#endif