//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>

#include "param.h"
#include "bitmap.h"
#include "raw/raw.h"


Bitmap* rsclist;


Bitmap* rscBmpbyname(char *filename)
{
	Bitmap* p=rsclist;
	while(p)
	{
		if ((p->name)&&(!strcmp(p->name,filename))) return p;
		p=p->next;
	}
	return NULL;
}

void rscListadd(Bitmap *p)
{
	p->next=rsclist;
	rsclist=p;
}

void rscListrem(Bitmap *p)
{
	if (rsclist==p)
	{
		rsclist=p->next;
		return;
	}
	Bitmap *q=rsclist;
	while(q)
	{
		if (q->next==p)
		{
			q->next=p->next;
			return;
		}
		q=q->next;
	}
}

void rscInit()
{
	rsclist=NULL;
}

Bitmap* rscNameit(Bitmap *p,char *filename)
{
	char *name=new char[strlen(filename)+1];
	strcpy(name,filename);
	p->name=name;
	p->count=1;
	rscListadd(p);
	return p;
}

Bitmap* rscUseit(Bitmap *p)
{
	p->count++;
	return p;
}

void rscUnuseit(Bitmap *p)
{
	if(!p) return;
	p->count--;
	if (p->count>0) return;
	if (p->name) PRINTF("delete %s\n",p->name);
	rscListrem(p);
	delete p;
}



Bitmap* rscGet(char *filename)
{
	Bitmap* p=rscBmpbyname(filename);
	if (p)
	{
//		PRINTF("reuse %s\n",filename);
		p->count++;
		return p;
	}
	PRINTF("load %s\n",filename);
	p=stdloadRaw(filename);
	if (!p) return NULL;
	return rscNameit(p,filename);
}

Bitmap* bmpGet(char *filename)
{
	return stdloadRaw(filename);
}


Bitmap* rscButton(char *filename,char* title,Font* font,int n,int col)
{
	Bitmap* bmp=bmpGet(filename);
	if (!bmp) return NULL;
	if (title)
	{
		int h=bmp->height/n;
		int w=bmp->width;
		if (n>=1) bmp->drawtextboxEx(0,0,w,h,ALIGN_CENTER+ALIGN_VCENTER,title,strlen(title),(short)col,-1,font,font_subtitle);
		if (n>=2) bmp->drawtextboxEx(0,h,w,h,ALIGN_CENTER+ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(0xff,0xff,0xff),-1,font,font_subtitle);
		if (n>=3) bmp->drawtextboxEx(0,h+h,w,h,ALIGN_CENTER+ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(0xc0,0xc0,0xc0),-1,font,font_subtitle);
	}
	return rscNameit(bmp,title);
}

Bitmap* rscButton(char *filename,int off,char* title,Font* font,int n,int col)
{
	Bitmap* bmp=bmpGet(filename);
	if (!bmp) return NULL;
	if (title)
	{
		int h=bmp->height/n;
		int w=bmp->width;
		if (n>=1) bmp->drawtextboxEx(off,0,w-off,h,ALIGN_VCENTER,title,strlen(title),(short)col,-1,font,font_subtitle);
		if (n>=2) bmp->drawtextboxEx(off,h,w-off,h,ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(0xff,0xff,0xff),-1,font,font_subtitle);
		if (n>=3) bmp->drawtextboxEx(off,h+h,w-off,h,ALIGN_VCENTER,title,strlen(title),(short)RGBTO16(0xc0,0xc0,0xc0),-1,font,font_subtitle);
	}
	return rscNameit(bmp,title);
}

Bitmap* rscButton(char *filename,char* title,Font* font,int n)
{
	return rscButton(filename,title,font,n,COL_TITLE);
}
Bitmap* rscButton(char *filename,int off,char* title,Font* font,int n)
{
	return rscButton(filename,off,title,font,n,COL_TITLE);
}
