//--------------------------
// TAO - 2006 - Sylvain Huet
//--------------------------

#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>
#include<stdio.h>

#include "param.h"
#include "config.h"
#include "street.h"
#include "file.h"
#include "control.h"
#include "interf.h"


Streetlist::Streetlist()
{
	nstreet=0;
	tstreet=NULL;
	desc=NULL;
	index=NULL;
}

Streetlist::~Streetlist()
{
	if (tstreet) delete tstreet;
	if (desc) delete desc;
	if (index) delete index;
}

int Streetlist::msbtoint(char *p)
{
	return ((p[0]&255)<<24)+((p[1]&255)<<16)+((p[2]&255)<<8)+(p[3]&255);
}

int Streetlist::load(char *filename)
{
	char* data=fileLoad(filename);
	if (!data) return -1;

	int i=0;
	nstreet=msbtoint(data+i); i+=4;

	if (tstreet) delete tstreet;
	tstreet=new Street[nstreet];

	int j;
	for(j=0;j<nstreet;j++) tstreet[j].desc=msbtoint(data+i+(j<<2));
	i+=nstreet*4;
	for(j=0;j<nstreet;j++) tstreet[j].index=msbtoint(data+i+(j<<2));
	i+=nstreet*4;
	for(j=0;j<nstreet;j++) tstreet[j].x=msbtoint(data+i+(j<<2));
	i+=nstreet*4;
	for(j=0;j<nstreet;j++) tstreet[j].y=msbtoint(data+i+(j<<2));
	i+=nstreet*4;

	int lendesc=msbtoint(data+i); i+=4;
	PRINTF("lendesc=%d\n",lendesc);
	desc=new char[lendesc];
	memcpy(desc,data+i,lendesc);
	i+=lendesc;

	int lenindex=msbtoint(data+i); i+=4;
	PRINTF("lenindex=%d\n",lenindex);
	index=new char[lenindex];
	memcpy(index,data+i,lenindex);
	i+=lenindex;

	fileRelease(data);

	return 0;
}

char* Streetlist::getdesc(Street* p)
{
	return &desc[p->desc];
}

int Streetlist::getnstreet()
{
	return nstreet;
}
Street* Streetlist::getnth(int i)
{
	if ((i<0)||(i>=nstreet)) return NULL;
	return tstreet+i;
}

int Streetlist::select(char* key)
{
	int i;
	int n=0;
	for(i=0;i<nstreet;i++)
	{
		int k=(strstr(&index[tstreet[i].index],key)==NULL)?0:1;
		tstreet[i].select=k;
		n+=k;
//		if (k) PRINTF("-%s : %s\n",&index[tstreet[i].index],getdesc(&tstreet[i]));
	}
	return n;

}

Streetlist* streetlist=NULL;

int streetlistInit()
{
	streetlist=new Streetlist();
	streetlist->load("misc/streets.bin");
	return 0;
}


